#include "stdafx.h"
#include "index.h"
#include "ScriptPlayer.h"
#include "DrawManagerfY.h"

//ftHgRXgN^
DrawManagerfY::DrawManagerfY(){
	m_DrawRect->CreateSurfaceByType(GetScreenWidth(), GetScreenHeight(), 5);
}

//ʂ̉擾
unsigned int DrawManagerfY::GetScreenWidth() const{
	bool IsFullScreen;
	int X, Y, ColorDepth;
	GETMYFRAME()->GetDraw()->GetDisplay(IsFullScreen, X, Y, ColorDepth);
	return(X);
}
//ʂ̏c擾
unsigned int DrawManagerfY::GetScreenHeight() const{
	bool IsFullScreen;
	int X, Y, ColorDepth;
	GETMYFRAME()->GetDraw()->GetDisplay(IsFullScreen, X, Y, ColorDepth);
	return(Y);
}
//tXN[ۂ擾
bool DrawManagerfY::GetFullScreen() const{
	bool IsFullScreen;
	int X, Y, ColorDepth;
	GETMYFRAME()->GetDraw()->GetDisplay(IsFullScreen, X, Y, ColorDepth);
	return(IsFullScreen);
}
//tXN[ۂݒ
void DrawManagerfY::SetFullScreen(bool IsFullScreen){
	GETMYFRAME()->GetDraw()->SetDisplay(IsFullScreen);
}

//ʂXV
void DrawManagerfY::Flip(){
	GETMYFRAME()->GetDraw()->OnDraw();
}

bool DrawManagerfY::_LoadImage(const char* FileName){
	m_Cache.insert(pair<string, CPlane>(FileName, CPlane()));
	if(m_Cache.find(FileName)->second->Load(FileName)==0){
		m_Cache.find(FileName)->second->SetColorKey(DEFAULT_COLORKEY);
		return(true);
	}
	else{
		m_Cache.erase(m_Cache.find(FileName));
		return(false);
	}
}
bool DrawManagerfY::_UnloadImage(const char* FileName){
	if(m_Cache.find(FileName)->second->Release()==0){
		m_Cache.erase(m_Cache.find(FileName));
		return(true);
	}
	else{
		return(false);
	}
}
void DrawManagerfY::_Clear(COLORREF Color){
	ISurfaceRGB Temp = 0;
	BYTE R = GetRValue(Color);
	BYTE G = GetGValue(Color);
	BYTE B = GetBValue(Color);
	Temp = GETMYFRAME()->GetDraw()->GetSecondary()->GetFillColor();
	GETMYFRAME()->GetDraw()->GetSecondary()->SetFillColor(ISurface::makeRGB(R, G, B));
	GETMYFRAME()->GetDraw()->GetSecondary()->Clear();
	GETMYFRAME()->GetDraw()->GetSecondary()->SetFillColor(Temp);
}
void DrawManagerfY::_Blt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Cache.find(FileName)!=m_Cache.end()){
		GETMYFRAME()->GetDraw()->GetSecondary()->BltNatural(m_Cache.find(FileName)->second, x, y, a, NULL, &SrcRect);
	}
}
void DrawManagerfY::_AddBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Cache.find(FileName)!=m_Cache.end()){
		GETMYFRAME()->GetDraw()->GetSecondary()->AddColorBltFade(m_Cache.find(FileName)->second, x, y, a, NULL, &SrcRect);
	}
}
void DrawManagerfY::_SubBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Cache.find(FileName)!=m_Cache.end()){
		GETMYFRAME()->GetDraw()->GetSecondary()->SubColorBltFade(m_Cache.find(FileName)->second, x, y, a, NULL, &SrcRect);
	}
}
void DrawManagerfY::_BltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Cache.find(FileName)!=m_Cache.end()){
		GETMYFRAME()->GetDraw()->GetSecondary()->BlendBltFast(m_Cache.find(FileName)->second, x, y, a, NULL, &SrcRect);
	}
}
void DrawManagerfY::_AddBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Cache.find(FileName)!=m_Cache.end()){
		GETMYFRAME()->GetDraw()->GetSecondary()->AddColorBltFastFade(m_Cache.find(FileName)->second, x, y, a, NULL, &SrcRect);
	}
}
void DrawManagerfY::_SubBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Cache.find(FileName)!=m_Cache.end()){
		GETMYFRAME()->GetDraw()->GetSecondary()->SubColorBltFastFade(m_Cache.find(FileName)->second, x, y, a, NULL, &SrcRect);
	}
}
void DrawManagerfY::_DrawFreeText(const string& Text, int x, int y, BYTE a, const string& Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree){
	m_Text.GetFont()->SetFont(Font);
	m_Text.GetFont()->SetSize(Size);
	m_Text.GetFont()->SetText(Text);
	m_Text.GetFont()->SetColor(Color);
	m_Text.GetFont()->SetWeight(IsBold ? FW_BOLD : FW_LIGHT);
	m_Text.GetFont()->SetItalic(IsItalic);
	m_Text.UpdateTextAA();
	GETMYFRAME()->GetDraw()->GetSecondary()->BltNatural(&m_Text, x, y, a);
}
void DrawManagerfY::_DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree){
	BYTE R = GetRValue(Color);
	BYTE G = GetGValue(Color);
	BYTE B = GetBValue(Color);
	if(a==255){
		ISurfaceRGB Temp = 0;
		Temp = GETMYFRAME()->GetDraw()->GetSecondary()->GetFillColor();
		GETMYFRAME()->GetDraw()->GetSecondary()->SetFillColor(ISurface::makeRGB(R, G, B));
		GETMYFRAME()->GetDraw()->GetSecondary()->Clear(&Rect);
		GETMYFRAME()->GetDraw()->GetSecondary()->SetFillColor(Temp);
	}
	else{
		Rect.bottom -= Rect.top;
		Rect.right -= Rect.left;
		Rect.left = 0;
		Rect.top = 0;
		m_DrawRect.get()->SetFillColor(ISurface::makeRGB(R, G, B));
		m_DrawRect.get()->Clear();
		GETMYFRAME()->GetDraw()->GetSecondary()->BlendBltFast(m_DrawRect, Rect.left, Rect.top, a, 0, &Rect);
	}
}