#include "stdafx.h"
#include "yaneFile.h"
#include "yaneLZSS.h"
#include "yaneStringScanner.h"
#include "../AppFrame/yaneAppInitializer.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

#ifndef COMPILE_YANE_PLUGIN_DLL

//	CFilȅpIuWFNg
CFile::CFileInitializer::CFileInitializer(){
	//	BCC͖IɃLXgȂƃI[o[[hꂽ֐𔻕ʂłȂ
	void(*f)() = &CFile::SetCurrentDir;
	CAppInitializer::RegistInitCallback( smart_ptr<function_callback>(function_callback_v::Create(f)) );
}
CFile::CFileInitializer m_dummy;

#else
//@dȂ̂ŁACAppInitializer::DllInitŏ邩..
#endif

//////////////////////////////////////////////////////////////////////////////

string	CFile::m_strCurrentDirectory;		// ݑΏۂƂĂfBNg
smart_ptr<vector<string> >	CFile::m_astrPathList;	// pXXg

//////////////////////////////////////////////////////////////////////////////
//	<yanepackp\̂ɂ>
//		t@Cwb_[ "yanepack" 8oCg + i[t@C DWORD
//		̌AȉCFileInfoi[t@CāAƂ̓f[^
struct CFileInfo {
	CHAR	filename[32];
	DWORD	startpos;	//	seek pos
	size_t	filesize;	//	file size
};
struct CFileInfoEx {
	CHAR	filename[32];
	DWORD	startpos;	//	seek pos
	size_t	filesize;	//	file size(WJ̃t@CTCY)
	size_t	arcsize;	//	arc size (kTCY)
};
struct CFileInfoDx {
	CHAR	filename[256];	//	Kwt@CȂ̂ŁATCYłƂ
	DWORD	startpos;	//	seek pos
	size_t	filesize;	//	file size(WJ̃t@CTCY)
	size_t	arcsize;	//	arc size (kTCY)
};
//////////////////////////////////////////////////////////////////////////////

CFile::CFile() {
	m_lpFile = NULL;
	m_lpFileAdr		= NULL;
	m_dwFileSize	= 0;
	m_lpFileMemPos	= NULL;
	m_bEncode		= false;
	m_bTempFile		= false;
	m_bCompress		= false;
	m_bMemoryImage	= false;
}

CFile::~CFile() {
	Close();
}

LRESULT CFile::Close(){
	if (m_lpFile!=NULL) {
		LRESULT l;
		l = ::fclose(m_lpFile);
		m_lpFile = NULL;
		return l;
	}
	if (m_bMemoryImage) {
	//	̉zt@C
		m_lpFileAdr = NULL;
		m_dwFileSize = 0;
		m_lpFileMemPos = NULL;
		m_bMemoryImage = false;
	}
	if (m_lpFileAdr!=NULL) {
		::GlobalFree(m_lpFileAdr);
//		delete [] m_lpFileAdr;
		m_lpFileAdr = NULL;
		m_dwFileSize = 0;
		m_lpFileMemPos = NULL;
	}
	if (m_bTempFile) {
		m_bTempFile = false;
		Delete(m_strFileName);	//	t@C̍폜
	}
	m_bCompress	= false;
	m_strFileName.erase();
	return 0;
}

//	t@C̍폜
LRESULT	CFile::Delete(const string& filename){
	//	ȂnȂ...
	if (filename.empty()) return -1;

	string fn(MakeFullName(filename));
	return !::DeleteFile(fn.c_str());
}

LRESULT	CFile::CreateTemporary(bool bForce/* = false*/){
	if (m_lpFileAdr==NULL && !bForce) return 1;
	if (m_bCompress || m_bMemoryImage || bForce) {
	//	kt@CAC[Wit@Ĉj
	//	̂Ƃ̂duplicate

		string strTmpFileName;
		LRESULT lr = GetTemporaryFileName(strTmpFileName);
		if (lr!=0) return 2;

		if (WriteBack(strTmpFileName) != 0) {
//			Err.Out("CFile::CreateTemporary::e|t@Cɏ߂ȂB");
			return 2;
		}
		Close();
		//	write backق̃KĂt@CƂ
		m_bTempFile = true;
		m_strFileName = strTmpFileName;
	} else {
		//	ACloseĂقSOOG
		string s;
		s = m_strFileName;
		Close();
		m_strFileName = s;
	}
	return 0;
}


LRESULT	CFile::GetTemporaryFileName(string& strFileName){
	//	e|t@C擾

	CHAR	szTmpPath[MAX_PATH];
	CHAR	szTmpFileName[MAX_PATH];
	if (::GetTempPath(sizeof(szTmpPath), szTmpPath) == 0) {
//		Err.Out("CFile::CreateTemporary::e|pX擾łȂB");
		return 2;
	}
	if (::GetTempFileName(szTmpPath, "YNE", 0, szTmpFileName) == 0) {
//		Err.Out("CFile::CreateTemporary::e|t@C쐬łȂB");
		return 2;
	}
	strFileName = szTmpFileName;
	return 0;
}

//////////////////////////////////////////////////////////////////////////////
string CFile::GetCurrentDir() {
	if (m_strCurrentDirectory.empty()) {
		//	悤Ȃ̂ŁAݒ肷
		CHAR dir[_MAX_PATH];
		::GetCurrentDirectory(_MAX_PATH,dir);
		SetCurrentDir(dir);
	}
	return m_strCurrentDirectory;
}

void CFile::SetCurrentDir(){
	CHAR dir[_MAX_PATH];
	::GetCurrentDirectory(_MAX_PATH,dir);
	SetCurrentDir(dir);
}

void CFile::SetCurrentDir(const string& dir){

	bool bDir = false;
	m_strCurrentDirectory = dir;
	if (!m_strCurrentDirectory.empty() && m_strCurrentDirectory[0]=='"') {
		bDir = true;
		m_strCurrentDirectory.erase(0,1);	// R}hCnȂ...
	}
	// c:\test\test.exe@̂悤ɃR}hCăJgfBNg
	// ݒł悤ɍHvB(bDir==truêƂ)
	// c:\test\@܂ŁBŌ\܂߂ĕۑB

	string::size_type pos;
	if (bDir) {
		pos = m_strCurrentDirectory.find('.');
	} else {
		pos = string::npos;
	}
	string::iterator it;
	if (pos==string::npos) {		// . Ȃ
		it = m_strCurrentDirectory.end() - 1;
		if (*it!='\\' && *it!='/') {
			// \/ŏIĂȂȂ\ǉ
			m_strCurrentDirectory += '\\';
		}
	} else { // c:\test\test or c:\test\test.exe
		GetParentDir(m_strCurrentDirectory);
	}
}

LRESULT	CFile::GetParentDir(string& filename){						//	etH_Ԃ
// e.g. "c:\test1\test2\test3.exe" -> "c:\test1\test2\" -> "c:\test1\" -> "c:\" -> "c:\"
	//	̂PoCgڂKv...
	//
	//	1. Albg[NhCuŗL΁ARs[^XLbvB
	//	@@邱ƂŁA[J̃pXƓɂȂB
	//@@@i\\HOST\PATH ܂łAhCu^[łƂ  dl
	//	2. \/TB̍ۂɍŌɌʒuƍŌォQԖڂɌʒuL^Ă
	//	3. \ł/łȂꍇA[gȂ΁tB[głȂ΁AŌ@@@@@ɌƂ܂łefBNgƂĕԂ
	//	4. \  /łꍇ@A[gȂ΂̂܂ܕԂB[głȂ΁AŌォQԖڂɌƂ܂łefBNgƂĕԂ
	//
	//	2001/07/29 sohei
	//	  [gɗLt@Cnꂽ\/͈ȂA[gԂȂƂȂ
	//	2001/08/06 sohei
	//	  string  \ t邱ƂŊgꂽꍇAoÔC
	//	@˂ӂ`@񍐗L܂B

	if (filename.empty()) return 1;	//	Ȃn^^;

	string::iterator it = filename.begin();
	if (filename.substr(0,2)=="\\\\") {
		//	lbg[NpX
		it += 2;	if (*it == '\0')	return 1;	//	\\ ł肩^^;
		//	̂Ƃ́ARs[^XLbv
		bool bKanji=false;
		for(;;it++){
			if (*it == '\0') break;
			if (bKanji) { bKanji=false; continue; }
//			if (((BYTE)*it>=0x80 && (BYTE)*it<=0xa0) || ((BYTE)*it>=0xe0 && (BYTE)*it<=0xff)) {
			if (  CStringScanner::IsLead_ShiftJIS(*it)  ){
				bKanji = true;	//	QoCgR[ĥPoCgڂł
			} else {
				bKanji = false;	//	QoCgR[ĥPoCgڂł͂Ȃ
				if (*it == '\\' || *it=='/') {	//	؂蕶
					it++;	//	\\HOST\ ̎Ƃ΃[JƓɂȂ
					break;
				}
			}
		}
	} else {
	}
	string::iterator pos1,pos2;	
	// pos1 : ŌɌ\/̈ʒu
	// pos2 : ŌォQԖڂɌ\/̈ʒu
//	pos1 = pos2 = string::npos;	// not found
	pos1 = pos2 = filename.end();	// not found

	bool bKanji=false;
	
	while (true) {
		if (*it == '\0') break;
		if (bKanji) { bKanji=false; goto skip; }
//		if (((BYTE)*it>=0x80 && (BYTE)*it<=0xa0) || ((BYTE)*it>=0xe0 && (BYTE)*it<=0xff)) {
		if ( CStringScanner::IsLead_ShiftJIS(*it) ){
			bKanji = true;	//	QoCgR[ĥPoCgڂł
		} else {
			bKanji = false;	//	QoCgR[ĥPoCgڂł͂Ȃ
			if (*it == '\\' || *it=='/') {	//	؂蕶
				pos2 = pos1;
				pos1 = it;
			}
		}
skip:;
		it++;
	}
	//	2001/08/06	sohei
	//		string LƂɁACe[^ɂȂāA
	//		sȏNĂ̂CB
	//		˂ӂ`@L܂B

	//	\ł/łȂ
	if ( !bKanji && (*(it-1)!='\\' && *(it-1)!='/')) {
		//	̏ꍇ͍ŌɌ܂łKvB
		if (pos1 == filename.end()) {	//	\Ȃ烋[gȂ̂\t
			filename+='\\';
		} else {
			filename.erase(pos1+1,filename.end());	//	[gł͂Ȃ̂ŁAŌɌƂ܂łԂ
		}
	} else {
		//	̏ꍇ͂QԖڂɌ܂łKvB
		if (pos2 == filename.end()) return 1;	//	[gȂŎ菜Kv͂Ȃ
		filename.erase(pos2+1,filename.end());		//	ŌォQԖڂ܂łԂ΂悢
	}
	return 0;
}

string	CFile::GetSuffix()const{
	return GetSuffixOf(m_strFileName);
}

string	CFile::GetPureFileName()const{
	return GetPureFileNameOf(m_strFileName);
}

// ------ static function ------
string	CFile::GetSuffixOf(const string& filename){
	string suffix;
	suffix = GetPureFileNameOf(filename);
	// @@@@ԂɃfBNgLƂ܂̂ŃpX
	string::size_type pos;
	pos = suffix.rfind('.');
	if (pos==string::npos) {
		suffix.erase();
	} else {
		suffix.erase(0,pos+1);
	}
	return suffix;
}	

string	CFile::GetPureFileNameOf(const string& filename){

	if (filename.empty()) return string("");

	string purefilename;
	string::iterator pos1;
	// pos1 : ŌɌ\/̈ʒu
	purefilename = filename;
	string::iterator it = purefilename.begin();
	pos1 = purefilename.end();	// not found
	bool bKanji=false;
	while (true) {
		if (it == purefilename.end()) break;
		if (bKanji) { bKanji=false; goto skip; }
//		if (((BYTE)*it>=0x80 && (BYTE)*it<=0xa0) || ((BYTE)*it>=0xe0 && (BYTE)*it<=0xff)) {
		if ( CStringScanner::IsLead_ShiftJIS(*it) ){
			bKanji = true;	//	QoCgR[ĥPoCgڂł
		} else {
			bKanji = false;	//	QoCgR[ĥPoCgڂł͂Ȃ
			if (*it == '\\' || *it=='/') {
				pos1 = it;
			}
		}
skip:;
		it++;
	}
	if (pos1!=purefilename.end()){
		purefilename.erase(purefilename.begin(),pos1+1);
	}
	return purefilename;
}

//////////////////////////////////////////////////////////////////////////////
//	static function..
void  CFile::ToLower(string &str){
	//	(do_tolower)
	string::iterator it = str.begin();
	bool bSkip = false;
	while (it!=str.end()){
		if (bSkip) {
			bSkip = false;
			goto Repeat;
		}

//		if (((BYTE)*it>=0x80 && (BYTE)*it<=0xa0) || ((BYTE)*it>=0xe0 && (BYTE)*it<=0xff)) {
		if ( CStringScanner::IsLead_ShiftJIS(*it) ){
			//	QoCgR[ĥPoCgڂł
			bSkip = true;
			goto Repeat;
		} else {
			//	QoCgR[ĥPoCgڂł͂Ȃ
			bSkip = false;
		}
		*it = tolower(*it);
Repeat:;
		it ++;
	}
}
//////////////////////////////////////////////////////////////////////////////

LRESULT CFile::Open(const string& filename,const string& access)
{
	LRESULT lr;
	//	JgtH_̓ǂݍ
	lr = InnerOpen(MakeFullName(filename), access);
	if (lr==0) return 0;

	if (GetPathList().isNull()) return lr;	//	pXw肳ĂȂDDOOG

	//	ݒ肳ĂpXǂĒׂ
	pathlist::iterator it = GetPathList()->begin();
	while (it!=GetPathList()->end()){
		lr = InnerOpen(*it + '/' + filename, access);
		if (lr == 0) return 0; // OOG
		it++;
	}
	return lr;	//	߂AAiԂj
}

LRESULT CFile::InnerOpen(const string& filename,const string& access)
{
	Close();
	m_lpFile = fopen(filename.c_str(), access.c_str());
	if (m_lpFile==NULL) return 1;

	// t@Cݒ
	m_strFileName = filename;
	return 0;
}

LRESULT CFile::Write(const string& s) {
	if (m_lpFile==NULL) return -1;
	if (fprintf(m_lpFile,"%s",s.c_str())<0) return 1;
	return 0;
}

LRESULT	CFile::WriteBack(const string& filename){
	return Write(filename,GetMemory(),GetSize());
}

//////////////////////////////////////////////////////////////////////////////

DWORD	CFile::GetSize() const {
	if (m_bEncode) return m_dwFileSize - 4;	//	SoCg
	return m_dwFileSize;
}

LPVOID	CFile::GetMemory() const {
	if (m_bEncode) return (BYTE*)m_lpFileAdr + 4;	//	ʃwb_̂SoCg
	return m_lpFileAdr;
}

LRESULT	CFile::Encode(){
	if (*(DWORD*)m_lpFileMemPos == 0x314B5059) return 1;	// already encoding!!
	if (m_bEncode) return 1;	//	already encoding!!
	
	DWORD size = m_dwFileSize+4;
	BYTE* m_lpFileAdr2 // = new BYTE[size+1];
		= (BYTE*)GlobalAlloc(GMEM_FIXED | GMEM_NOCOMPACT,size+1);

	//	PoCg߂ɊmۂāAŌ\0ۏ؂B΁A
	//	r₷ȂB
	*((BYTE*)m_lpFileAdr2 + size) = 0;

	for (DWORD i=0;i<size-4;i++){
		//	juœւ邾:p
		*(m_lpFileAdr2+i+4) =	(((*((BYTE*)m_lpFileAdr+i) & 0xf) << 4) +
								 ((*((BYTE*)m_lpFileAdr+i) &0xf0) >> 4)) ^ 0xcc;
	}
	*(DWORD*)m_lpFileAdr2 =	 0x314B5059;	// YPK1:wb_t^

	Close();

	m_lpFileAdr		= (LPVOID)m_lpFileAdr2;
	m_dwFileSize	= size;
	m_lpFileMemPos	= (LPCSTR)m_lpFileAdr; // for ReadLine
	m_bEncode		= false;	//	falseɂ邱Ƃɂăwb_[t^
	return 0;
}

string	CFile::GetWindowsDir(){
	//	VXefBNg擾iI[\\j
	CHAR	buf[MAX_PATH];
	::GetWindowsDirectory(buf,MAX_PATH);
	if (buf[::lstrlen(buf)-1]!='\\'){	//	I['\'H
		::lstrcat(buf,"\\");
	}
	return buf;	//	Rs[RXgN^N̂ňS
}

//////////////////////////////////////////////////////////////////////////////
string	CFile::MakeFullName(const string& filename){	// NfBNgĊSpX
	string file;
	if (filename.substr(0,2)=="\\\\") {
			//	lbg[NpXȂ̂ŉȂ
			file = filename;
	} else {
		string::size_type pos = filename.find(':');
		if (pos==string::npos) {
			//	tpXłȂ΃JgfBNg₤

			// ..\\ł̋삯オ葊΃pXT|[g
			string dir;
//			dir = m_strCurrentDirectory;
			dir = GetCurrentDir();
				//	ݒ肳ĂȂ΁ȀuԂɐݒ肷
			file = filename;
			while (true) {
				if (file.substr(0,3)=="..\\" || file.substr(0,3)=="../"){
					GetParentDir(dir);
					file.erase(0,3);
				} else if ((file.substr(0,2)==".\\" || file.substr(0,2)=="./")) {
					//	./ɂJgtH_
					file.erase(0,2);
				} else if (!CStringScanner::IsLead_ShiftJIS(file.at(0))&&(file.substr(0,1)=="\\" || file.substr(0,1)=="/")){
					//	\PƂȂ疳  }`oCg1byteڂl
					file.erase(0,1);
				} else {
					break;
				}
			}
			file = dir + file;
		} else {
			file = filename;
		}
	}
	/*
		'01/10/07	˂炨
			/	Ƃ܂ǂݍ߂ȂƂ悤Ȃ̂ŁA\ɒuOOG
		'02/02/11	
			}`oCglĂȂ̂ŏC
			t@C̑݃`FbNāAGetPathŒT悤ɂ
	*/


//	RgAEg by ˂炨 '02/03/14 01:36
#if 0

	// GetPath()!=NULĹAw肳ꂽt@C݂邩`FbN
	if(!GetPath().isNull()){
		bool bFound = false;
		if(!PathFileExists(file)){
			// kĂ邩
			string fullname(file);
			string inner_filename(fullname);
			GetParentDir(fullname);
			inner_filename.erase(0, fullname.size());
			fullname[fullname.size() - 1] = '.';
			fullname += "dat";
			if(PathFileExists(fullname)) { bFound=true; }	// kt@C
		}else{
			bFound=true;
		}

		// ȂĎ͑̏ꏊɂ
		if(!bFound){
			const string file2 = file;
			vector<string>::iterator it = GetPath()->begin();
			while(it!=GetPath()->end()){
				file = *it + '/' + filename;
				if(!PathFileExists(file)){
					// kĂ邩
					string fullname(file);
					string inner_filename(fullname);
					GetParentDir(fullname);
					inner_filename.erase(0, fullname.size());
					fullname[fullname.size() - 1] = '.';
					fullname += "dat";
					if(PathFileExists(fullname)) { bFound=true;	 break; }	// kt@C
				}else{
					bFound=true;  break;
				}
				it++;
			}
			// ȂAJĝɖ߂Ă
			if(!bFound) { file = file2; }
		}
	}
#endif

	{
		bool bKanji=false;
		string::iterator it = file.begin();
		while (it!=file.end()){
			if( CStringScanner::IsLead_ShiftJIS(*it) ){
				//	QoCgR[ĥPoCgڂł
				bKanji=true;
			}else{
				//	QoCgR[ĥPoCgڂł͂Ȃ
				if(!bKanji && *it == '/') { *it='\\'; }
				bKanji=false;
			}
			it++;
		}
	}

	return file;
}

bool CFile::PathFileExists(const string& fullname)
{
	HANDLE hFile = ::CreateFile(fullname.c_str(),
		GENERIC_READ,		// Read
		FILE_SHARE_READ,	// ReadOpenȂ狤L̂̓}i[ 
		NULL,				// security
		OPEN_EXISTING,		// ݂ĂȂ΃G[
		FILE_ATTRIBUTE_NORMAL,	//	t@C
		NULL				// ev[gt@C
	);

	if (hFile == INVALID_HANDLE_VALUE) { // I
		// closeKv͂Ȃ(INVALIDnhȂ񂾂)
		return false;
	}
	::CloseHandle(hFile);
	return true;
}

//////////////////////////////////////////////////////////////////////////////

LRESULT CFile::Read(const string& strFileName){
	LRESULT lr;
	//	JgtH_̓ǂݍ
	lr = InnerRead(strFileName);
	if (lr==0) return 0;

	if (m_astrPathList.isNull()) return lr;	//	pXw肳ĂȂDDOOG

	//	ݒ肳ĂpXǂĒׂ
	pathlist::iterator it = m_astrPathList->begin();
	while (it!=m_astrPathList->end()){
		lr = InnerRead(*it + '/' + strFileName);
		if (lr == 0) return 0; // OOG
		it++;
	}
	return lr;	//	߂AAiԂj
}

#pragma warning(disable:4701) // l蓖ĂĂȂϐwarning
LRESULT CFile::InnerRead(const string& filename){

	if (filename.empty()) return -1; // H

	DWORD NumberOfBytesRead;
	int nFileType = 0;
	//	0:ʂ̃t@C 1:yanePack
	//	2:yanePackEx 3:yanePackDx

	DWORD dwReadSize;	// ǂݍރTCY

	Close(); // OɓǂݍłAȂI
	m_strFileName = filename;

	if (filename[0] == '!') {
		//	C[W
		if(::sscanf(filename.c_str(),"!%x,%x",&m_lpFileAdr,&m_dwFileSize)!=2) {
			return 6; // ̃t@CłȂH
		}
		m_lpFileMemPos	= (LPCSTR)m_lpFileAdr;
		m_bMemoryImage	= true;
		return 0;
	}
	m_bMemoryImage = false;

	string fullname;
	fullname = MakeFullName(filename);
	HANDLE hFile = ::CreateFile(fullname.c_str(),
		GENERIC_READ,		// Read
		FILE_SHARE_READ,	// ReadOpenȂ狤L̂̓}i[ 
		NULL,				// security
		OPEN_EXISTING,		// ݂ĂȂ΃G[
		FILE_ATTRIBUTE_NORMAL,	//	t@C
		NULL				// ev[gt@C
	);

	if (hFile == INVALID_HANDLE_VALUE) { // I
		// closeKv͂Ȃ(INVALIDnhȂ񂾂)

		//	ЂƂĈkt@CH
		//	test/script/game.c
		//	 test/script.datgame.cT
		//	 test.datscript/game.cT
		//	̂悤ɏԂɂĒׂĂ

		/*
		string::size_type pos1,pos2;
		pos1 = fullname.rfind('/');
		pos2 = fullname.rfind('\\');
		//	̋LȂƂƂ͍lȂB
		//	ɑ݂قȍ~؂藎Ƃ
		if (pos1 == string::npos) pos1=0;
		if (pos2 == string::npos) pos2=0;
		if (pos2 > pos1) pos1 = pos2;
		string inner_filename;
		inner_filename = fullname.substr(pos1+1,string::npos);
		fullname.erase(pos1);
		fullname += ".dat";
		*/

		//	fixed by TearDrop_Stone
		string inner_filename(fullname);
		string dirname(fullname);

	//	---- kt@C͋삯オĒׂ̂ŁÃgC[v
CompressFileRetry:;

		GetParentDir(dirname);
		{
			string temp(dirname);
			GetParentDir(temp);
			if (temp==dirname){
				return 1;	//	ȏA삯オ܂
			}
		}

		inner_filename = fullname.substr(dirname.size()
			,fullname.length()-dirname.length());
		dirname[dirname.size() - 1] = '.';
		dirname += "dat";

		hFile = ::CreateFile(dirname.c_str(),
			GENERIC_READ,		// Read
			FILE_SHARE_READ,	// ReadOpenȂ狤L̂̓}i[ 
			NULL,				// security
			OPEN_EXISTING,		// ݂ĂȂ΃G[
			FILE_ATTRIBUTE_NORMAL,	//	t@C
			NULL				// ev[gt@C
		);

		if (hFile == INVALID_HANDLE_VALUE) {
			goto CompressFileRetry;
		}

		//	kt@CI
		CHAR ident[9];
		ident[8] = '\0';
		if (!::ReadFile(hFile,ident,8,&NumberOfBytesRead,NULL)){
			::CloseHandle(hFile);
			goto CompressFileRetry;
		}
		if (!strcmp(ident,"yanepack")) nFileType = 1;
		ef (!strcmp(ident,"yanepkEx")) nFileType = 2;
		ef (!strcmp(ident,"yanepkDx")) nFileType = 3;
		if (nFileType==0) {
			::CloseHandle(hFile);
			goto CompressFileRetry;
		}

		DWORD filenum;
		if (!::ReadFile(hFile,&filenum,sizeof(filenum),&NumberOfBytesRead,NULL)){
			::CloseHandle(hFile);
			goto CompressFileRetry;
		}
		
		bool bFound = false;
		
		ToLower(inner_filename);
		CFileInfo info;
		CFileInfoEx infoEx;
		CFileInfoDx	infoDx;
		DWORD dwStartPos; // t@CJnItZbg
		for(int i=0;i<(int)filenum;i++){
			string s;
			switch (nFileType){
			case 1: // yanePack
				if (!::ReadFile(hFile,&info,sizeof(info),&NumberOfBytesRead,NULL)){
					::CloseHandle(hFile);
					goto CompressFileRetry;
				}
				s = info.filename;	//	ĂeXg
				break;
			case 2: // yanePackEx
				if (!::ReadFile(hFile,&infoEx,sizeof(infoEx),&NumberOfBytesRead,NULL)){
					::CloseHandle(hFile);
					goto CompressFileRetry;
				}
				s = infoEx.filename;	//	ĂeXg
				break;
			case 3: // yanePackDx
				if (!::ReadFile(hFile,&infoDx,sizeof(infoDx),&NumberOfBytesRead,NULL)){
					::CloseHandle(hFile);
					goto CompressFileRetry;
				}
				s = infoDx.filename;	//	ĂeXg
				break;
			}
			ToLower(s);
			if (s == inner_filename) {
				//	vI
				// info.startposSeek
				switch (nFileType){
				case 1:	m_dwFileSize = info.filesize;
						dwReadSize	 = info.filesize;
						dwStartPos	 = info.startpos;
					break;
				case 2:	m_dwFileSize = infoEx.filesize;
						dwReadSize	 = infoEx.arcsize;
						dwStartPos	 = infoEx.startpos;
					break;
				case 3:	m_dwFileSize = infoDx.filesize;
						dwReadSize	 = infoDx.arcsize;
						dwStartPos	 = infoDx.startpos;
					break;
				}
				bFound = true;
				break;
			}
		}
		if (!bFound) {
			::CloseHandle(hFile);
			//	ɋ삯オĒׂ
			goto CompressFileRetry;
		}
		m_bCompress	= true;	//	Őݒ肵ƂOOG
		if (::SetFilePointer(hFile,dwStartPos,NULL,FILE_BEGIN)==0xFFFFFFFF) {
			::CloseHandle(hFile);
			goto CompressFileRetry;
		}
		goto StartOfRead;
	}
	
	// 4GBȏ̃t@CɓǂݍނƂȂčlȂ
	m_dwFileSize = ::GetFileSize(hFile,NULL);
	
	if (m_dwFileSize == 0xFFFFFFFF) {
		m_dwFileSize = 0;
		::CloseHandle(hFile);
		// Err.Out("CFile::ReadFileFileSize擾s");
		return 2; // filesize̎擾ɎsBiőɂȂƎvǁj
	}

	//	ǂݍ݃TCY
	dwReadSize = m_dwFileSize;

StartOfRead:;
	//	܂ǂݍނ߂̃mہI
	m_lpFileAdr = (LPVOID)::GlobalAlloc(GMEM_FIXED | GMEM_NOCOMPACT,m_dwFileSize+1);

	// m_lpFileAdr = new BYTE[m_dwFileSize+1];

	// ܂炷ĝɁÃGAk[B
	if (m_lpFileAdr==NULL) {
		::CloseHandle(hFile);
		// Err.Out("CFile::ReadFileŃmێs");
		return 3; // mۂł񂩂B
				  // σt@CłƂȁ[i΁j
	}
	//	PoCg߂ɊmۂāAŌ\0ۏ؂B΁A
	//	r₷ȂB
	*((BYTE*)m_lpFileAdr + m_dwFileSize) = 0;

	if ((nFileType==2||nFileType==3) && (m_dwFileSize!=dwReadSize)) {
		//	kt@CȂ̂ŎOœǂݍ
		smart_ptr<BYTE> lpBuf;
		lpBuf.AddArray(dwReadSize);
		if (lpBuf.isNull()) {
		//	łă:p
			Close();
			::CloseHandle(hFile); // ...
			return 4;
		}
		if (!::ReadFile(hFile,lpBuf.get(),dwReadSize,&NumberOfBytesRead,NULL)){
		//	Ȃǂݍݎs..
			Close();
			::CloseHandle(hFile); // ...
			return 4;
		}
		//	kt@C
		CLZSS lzss;
		lzss.Decode(lpBuf.get(),*(BYTE**)&m_lpFileAdr,m_dwFileSize,false);	//	G[͂ˁHH
	} else if (!::ReadFile(hFile,m_lpFileAdr,dwReadSize,&NumberOfBytesRead,NULL)){
		Close();
		::CloseHandle(hFile); // ...
		// Err.Out("CFileŃt@Cǂݍ݂Ɏs");
		return 4; // t@C̓ǂݍ݂ɎsB
	}

	if (::CloseHandle(hFile)==false) {
		Close();
		// Err.Out("CFileŃt@CcloseɎs");
		return 5; // Close̎sBȂ񂠂񂩂...
	}

	if (*(DWORD*)m_lpFileAdr == 0x314B5059) {	//	HEADER:YPK1(yanepack1) == Data is Encoding...
		m_bEncode = true;
		for (DWORD i=4;i<m_dwFileSize;i++){
			//	juœւ邾:p
			*((BYTE*)m_lpFileAdr+i) =	(((*((BYTE*)m_lpFileAdr+i) & 0xf) << 4) +
										 ((*((BYTE*)m_lpFileAdr+i) &0xf0) >> 4)) ^ 0xcc;
		}
		m_lpFileMemPos = (LPCSTR)m_lpFileAdr + 4; // for ReadLine
	} else {
		m_bEncode = false;
		m_lpFileMemPos = (LPCSTR)m_lpFileAdr; // for ReadLine
	}

	return 0; // ƂI:)
}
#pragma warning(default:4701) // l蓖ĂĂȂϐwarning

LRESULT CFile::Write(const string& fileName,LPVOID lpMem,DWORD dwSize){

	string strTempName;
	strTempName = CFile::MakeFullName(fileName);
	HANDLE hFile = ::CreateFile(strTempName.c_str(),
		GENERIC_WRITE,		// Write
		0,					// 
		NULL,				// security
		TRUNCATE_EXISTING,
		FILE_ATTRIBUTE_NORMAL,	//	t@C
		NULL				// ev[gt@C
	);
	//	OPEN_ALWAYSł́AÕt@CTCYcĂ܂...

	if (hFile == INVALID_HANDLE_VALUE) { // I
		hFile = ::CreateFile(strTempName.c_str(),
			GENERIC_WRITE,		// Write
			0,					// 
			NULL,				// security
			CREATE_NEW,
			FILE_ATTRIBUTE_NORMAL,	//	t@C
			NULL				// ev[gt@C
		);
		if (hFile == INVALID_HANDLE_VALUE) return 1; // Opens		
	}

	DWORD NumberOfBytesRead = 0;
	if (!::WriteFile(hFile,lpMem,dwSize,&NumberOfBytesRead,NULL)){
		::CloseHandle(hFile); // ...
		// Err.Out("CFile::WriteŃt@C݂Ɏs");
		return 2;
	}

	if (!::CloseHandle(hFile)) {
		return 3; // Close̎sBȂ񂠂񂩂...
	}

	return 0; // ƂI:)
}

const string	CFile::GetName() const {
	// ǂݍłt@CԂ
	return m_strFileName;
}

void CFile::Reset(){
	m_lpFileMemPos = (LPCSTR)GetMemory();
}

//	UNICODEΉBWindows̃eLXgt@Cp:p
LRESULT		CFile::ReadLine(LPSTR buf,DWORD dwSize){	 // obt@dwSizeoCgpӂƂĂ˂
	if (m_lpFileMemPos == NULL) return 3; // ǂȂƂ́[II
	if (m_lpFileMemPos >= (LPCSTR)m_lpFileAdr + m_dwFileSize) return 1;

	for(int i=0;i<(int)(dwSize-1);i++){
		if (*m_lpFileMemPos == 0x0D && *(m_lpFileMemPos+1) == 0x0A ||
			(m_lpFileMemPos >= (LPCSTR)m_lpFileAdr + m_dwFileSize)) { // CR+LF
			*buf = '\0'; // sII
			m_lpFileMemPos+=2;
			return 0;
		}
		*(buf++) = *(m_lpFileMemPos++);
	}
	*buf = '\0';
	return 2;	// buffer over
}

LRESULT		CFile::ReadLine(string&s){
	// ́Aobt@͎OŗpӂȂėǂB
	//	Ԃl 0: I 1:EOF   3:t@CǂݍłȂOOG
	if (m_lpFileMemPos == NULL) return 3; // ǂȂƂ́[II
	if (m_lpFileMemPos >= (LPCSTR)m_lpFileAdr + m_dwFileSize) return 1;
//	if (m_lpFileMemPos+1 >= (LPCSTR)m_lpFileAdr + m_dwFileSize) return 1;
				//	Pc'\0'ǉĂ̂ŁA+1Kv?

	DWORD dwSize = 0;
	while (true) {
		if (*m_lpFileMemPos == 0x0D && *(m_lpFileMemPos+1) == 0x0A ||
			(m_lpFileMemPos >= (LPCSTR)m_lpFileAdr + m_dwFileSize)) { // CR+LF
//			*buf = '\0'; // sII
			//LPSTR psz = new CHAR[dwSize+1];
			//::CopyMemory(psz,m_lpFileMemPos-dwSize,dwSize);
			//*(psz+dwSize) = '\0';
			//s = psz;
			//delete [] psz;
			s.assign(m_lpFileMemPos-dwSize,dwSize);
			m_lpFileMemPos+=2;
			return 0;
		}
//		*(buf++) = *(m_lpFileMemPos++);
		++m_lpFileMemPos;
		++dwSize;
	}
	//	ɂ͗Ȃ..
	return 0;
}

LRESULT		CFile::ReadLine2(LPSTR Senario,DWORD dwSize){
	smart_ptr<CHAR> lpBuf;
	lpBuf.AddArray(dwSize);	//	TCYm

	::lstrcpy(Senario,"");	//	ꉞAIƂɃS~oȂ悤...
	if (ReadLine(lpBuf.get())!=0) return 1;
	if (!::lstrcmp(lpBuf.get(),"\"END\"")) return 1; // I
	::lstrcpy(Senario,lpBuf.get()+1);	//	擪"폜

	while (true) {
		if (Senario[strlen(Senario)-1] == '\"') break;	//	f~^:="
		if (ReadLine(lpBuf.get())!=0) return 1;
		::lstrcat(Senario,"\n");
		::lstrcat(Senario,lpBuf.get());
	}
	Senario[::lstrlen(Senario)-1] = '\0';
	return 0;
}

LRESULT	CFile::ReadData(BYTE*p,DWORD size){
	if (m_lpFileMemPos == NULL) return 2; // ǂȂƂ́[II
	if (m_lpFileMemPos >= (LPCSTR)m_lpFileAdr + m_dwFileSize) return 1;

	::CopyMemory(p,m_lpFileMemPos,size);
	m_lpFileMemPos+=size;
	return 0;
}

//	f[^̕ۑ^ǂݍ(CSerializeƕpƗǂ)
LRESULT		CFile::Load(const string& filename,vector<BYTE>*vData){
	LRESULT lr = Read(filename);
	if (lr!=0) return lr; // ǂݍݎsƂDDD
	//	ǂݍ񂾃t@C̒𒲂ׂāASvDataɃRsI
	const int nSize = GetSize();
	vData->resize(nSize);
	::CopyMemory((LPVOID)&(*vData)[0],GetMemory(),nSize);
	return 0;
}

LRESULT		CFile::Save(const string& filename,vector<BYTE>*vData){
	return Write(filename,(LPVOID)&(*vData)[0],vData->size());
}

LRESULT		CFile::Save(const string& filename,vector<string>*vData){
	//	Afopenď񂾂قAĂƂ葁񂩂ȁH
	const int nSize = vData->size();
	FILE *fp = fopen(filename.c_str(),"w");
	if (fp==NULL) return 1;

	for(int i=0;i<nSize;i++){
		if (fprintf(fp,(*vData)[i].c_str())<0) return 2;
		//	݂ĂŒHDDꂽ񂿂Ⴄ񂯁H
	}
	fclose(fp);
	return 0;
}

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd
