// yaneLoadCache.h

#ifndef __yaneLoadCache_h__
#define __yaneLoadCache_h__

#include <LIMITS.h>	//	INT_MAX

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

class CIDObjectManager {
/**
	IDƂɑΉ̂Ԃ
	̂smart_obj(ǂȃIuWFNgłX}[g|C^)ŊǗ
	Ă̂ŁAɕ֗B
*/
public:
	typedef map<int,smart_obj> CIDObject;

	void	clear();
	///	Reiׂč폜

	LRESULT	erase(int nID);
		///	w肵ID̂̂폜
		///	Rei݂A폜łƂ́A0Ԃ

	void	setObject(int nID,const smart_obj& object);
		///	IDɑΉIuWFNgݒ肷

	LRESULT getObject(int nID,smart_obj& object);
		///	w肵IDɑΉIuWFNg擾

	CIDObject* GetObject() { return& id_object_; }

protected:
	CIDObject	id_object_;
};

///////////////////////////////////////////////////////////////

struct CLoadCacheInfo
/**
	CLoadCacheŗp\
*/
{
	smart_obj	pObj;		//	IuWFNg(CFastPlaneƂCSoundƂ..)
	string		strFileName;// ǂݍނׂt@C
};

class ICacheStaleListener
/**
	cacheĂ̂̂Ȃ
	ÂȂf[^̂Ă邽߂̎dg
*/
{
public:
	virtual LRESULT OnLoad(const smart_obj& pObj) = 0;
	/**
		pObjǂݍ񂾂ƂɌĂяo
	*/

	virtual LRESULT OnRelease(const smart_obj& pObj) = 0;
	/**
		pObjƂɌĂяo

		Ƃ́ÃXîȂōsȂȂĂǂ
	*/

	virtual bool isFull() const = 0;
	/**
		LbVɂȂĂȂ true
		ˁ@̂ƂÂׂ̂
	*/

	virtual ~ICacheStaleListener() {}
};

class CDefaultCacheStaleListener : public ICacheStaleListener
/**
	fBtHgStaler
*/
{
public:
	virtual LRESULT OnLoad(const smart_obj& pObj) { m_nRead++; return 0; }
	virtual LRESULT OnRelease(const smart_obj& pObj) { m_nRead--; return 0; }
	virtual bool isFull() const { return m_nRead > m_nMax; }

	void	SetMax(int nMax) { m_nMax = nMax; }
	/**
		̐LbVBI[o[ꍇ
		Â̂
	*/

	CDefaultCacheStaleListener() { m_nMax = INT_MAX; m_nRead = 0; }

protected:
	int m_nRead; // ǂݍłf[^̐
	int m_nMax;	 // LbVׂf[^̏
};


class ILoadCacheListener {
/**
	class CLoadCache ̓ǂݍݎ̃R[obNB
	KvȂnNoύXł
	ǂݍނ͂̃t@C𑼂̃t@C֒ûɎgB
*/
public:
	virtual void OnLoad(int &nNo) = 0;
	virtual ~ILoadCacheListener() {}
};

class CDefaultLoadCacheListener : public ILoadCacheListener {
/**
	ILoadCacheListener̉Ȃ
*/
public:
	virtual void OnLoad(int &nNo) {}
};

class ILoadCache {
public:
	virtual LRESULT	Set(const string& filename,bool bUseID=false)=0;

	virtual LRESULT	Load(int nNo)=0;
	virtual LRESULT	Release(int nNo)=0;
	virtual LRESULT	ReleaseAll()=0;

	virtual LRESULT GetObj(int nNo,smart_obj& obj)=0;

	virtual void	SetLoadCacheListener(const smart_ptr<ILoadCacheListener>& v)=0;
	virtual smart_ptr<ILoadCacheListener> GetLoadCacheListener() const =0;

	virtual void SetCacheStaleListener(const smart_ptr<ICacheStaleListener>& p)=0;
	virtual smart_ptr<ICacheStaleListener> GetCacheStaleListener() const=0;

	virtual void	SetCanReloadAgain(bool b)=0;

	virtual void	SetReadDir(const string& path)=0;
	virtual string	GetReadDir() const = 0;

	virtual ~ILoadCache(){}
};

}}

#include "yaneFile.h"
#include "yaneStringScanner.h"

//	templateŏĂ镔̂߂ɁincludeKvɂȂ(;LD`)
//	inclusion modeltemplate͊قĂ[

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

class CLoadCache : public ILoadCache {
/**
	[LbV̂悤ȓ܂B
	gp@ɂẮÃNX̔hĂB

	hNXF
		class CSoundLoader
		class CPlaneLoader
*/
public:
	virtual LRESULT	Set(const string& filename,bool bUseID=false)
		{ return SetHelper(filename,bUseID,CLoadCacheInfo()); }
	/**
		`t@C̐ݒiǂݍ݁j
		bUseID == trueȂ΁A`t@ĆAt@C̗ł͂ȂA
			t@C , IDԍ
		̗łB̂Ƃw肳ꂽIDԍƂĎQƂ邱Ƃo
	*/

	template <class T>
	LRESULT SetHelper(const string& filename,bool bUseID,T t){

		//	ǂݍݍς݁Qxǂ݋֎~
		if (!m_bCanReloadAgain) return 0;

		//	t@Cݒt@CǂݍނƂ̂߂ɁDDD
		CFile file;
		if (file.Read(filename)!=0) return 1;

		int nNums = 0;
		//	ݒ肳t@C
		while (true){
			CHAR buf[256];
			LRESULT lr = file.ReadLine(buf);
			if (lr==1) break ; // EOF
			if (buf[0]=='\0') continue;		//	s̓ǂݔ΂
			if (buf[0]=='/' && buf[1]=='/') continue;	//	Rgs̓ǂݔ΂
			LPCSTR lp = buf;
			T* pInfo = new T;
			pInfo->strFileName = m_strReadDir + CStringScanner::GetStrFromCsv(lp);

			smart_obj obj(pInfo);

			int nID;
			if (bUseID){
				if (CStringScanner::GetNumFromCsv(lp,nID)!=0){
					return 2;	//	Aǂݍ݃G[łH
				}
			} else {
				nID = nNums;
			}
			GetIDObjectManager()->setObject(nID,obj);
			OnSet(obj,nID);		//	KvȂΏǋL	
			nNums ++;
		}
		return 0;
	}
	/**
		SetĂяoĎgׂhelper֐
		Qlˁ@class CSELoader
	*/

	virtual LRESULT	Load(int nNo);
	/**
		̃io[̃f[^̓ǂݍ
		t@CɂāAIuWFNg͎̉
	*/

	/**
		SetLoad́AyAŎgB
		̂ƂAXiICacheStaleListenerOnLoad,OnReleasëŎ󂯎
		smart_obj̐̂CLoadCacheInfoȂ̂
		smart_ptr<CLoadCacheInfo>* pInfo = obj.get()
		̂悤ɃLXgĎgB
	*/

	virtual LRESULT GetObj(int nNo,smart_obj& obj);
	/**
		nNoɑΉIuWFNg擾
	*/

	virtual LRESULT	Release(int nNo);
	///	̃io[̃f[^̉

	virtual LRESULT	ReleaseAll();
	/**
		ǂݍłf[^̑S

		ACLoadCachẽCX^Xǂݍ񂾂̂̂݁B
		LbVLĂ鑼CLoadCacheǂݍ񂾂̂͊܂܂ȂB
	*/

	virtual void SetCacheStaleListener(
		const smart_ptr<ICacheStaleListener>& p)
	/**
		LbVݒ肷dg݁B
		̃LbVVXeŁALbV^郊XiB
		fBtHgł́ACDefaultCacheStalerB
		́Aǂݍł鐔CDefaultCacheStaler::SetMax𒴂ꍇ
		ŋߎgĂȂ̂dg
		defaultłINT_MAXiȂ̂ł܂łȂj
	*/
	{	m_pCacheStaleListener = p;	}

	smart_ptr<ICacheStaleListener>	GetCacheStaleListener() const
		{ return m_pCacheStaleListener; }

	struct CIDObjectAndNumber{
	/**
		CacheManageŕAԌÂIuWFNgj@\
		KvȂ̂ŁACIDObjectManager̃|C^ƁAio[Ă
	*/
		CIDObjectManager * pIDObject;
		int			nNum;
		CIDObjectAndNumber():pIDObject(NULL),nNum(0) {}
	};

	typedef fast_list<CIDObjectAndNumber> CCacheManager;
	///	fast_listYTLŒ`ĂBlist̑Ǝv˂B

	/**
		CacheManagerɊւAݒ`擾֐
		̃v[[_[ŁAꌳIȃLbVsȂƂ́A
			CPlaneLoader p1,p2;
			smart_ptr<CLoadCache::CCacheManager> pCache;
			pCache = p2.GetCacheManager();
			p1.SetCacheManager(pCache);
		Ƃ悤ɁALbV}l[WgLh邱Ƃɂ
		ӂCPlaneLoaderŁAg[^PÕOtBbN
		LbVƂƂ\ɂȂ܂Biłj
	*/
	smart_ptr<CCacheManager> GetCacheManager() const
		{ return m_vCacheManager; }

	void	SetCacheManager(const smart_ptr<CCacheManager>& pCacheManager)
		{ m_vCacheManager = pCacheManager; }

	CIDObjectManager* GetIDObjectManager() { return& m_vIDObject; }

	///	---- ܂
	///	SetŐݒ肵At@CXg̗vfԂ܂B
	virtual int		GetSize() const;

	///	property..
	///	Xi̐ݒ`擾
	virtual void	SetLoadCacheListener(const smart_ptr<ILoadCacheListener>& v)
		{ m_pLoadCacheListener = v;}
	virtual smart_ptr<ILoadCacheListener> GetLoadCacheListener() const
		{ return m_pLoadCacheListener; }


	/**
		SetŎw肷t@CŏĂt@CǂݍނƂA
		Őݒ肳ꂽDirĂ珈B

		)
			SetReadDir("../Read/");
			//	ˁ@"test.bmp"ǂݍނƂA
			//		../Read/test.bmpɓǂݍ

			ӁF
			PDݒ肷ƂA̍Ō̃XbVYȂƁI
			QDSetĂяoOɂ̊֐Őݒ肷邱ƁI
	*/

	virtual void	SetReadDir(const string& strDir)
		{ m_strReadDir = strDir; }

	virtual string	GetReadDir() const 
		{ return m_strReadDir; }

	//	ݒt@ĈQxǂ݂̋֎~(default:true == Qxǂ݉\)
	virtual void	SetCanReloadAgain(bool b) { m_bCanReloadAgain = b; }

	CLoadCache();
	virtual ~CLoadCache();

protected:

	/**
		̃NX̎gF

		܂ÃNXhA
		CCacheManager(GetCacheManagerŎ擾ł)
		delegateݒ֐Ŋ֐Zbg܂B
	*/

	/////////////////////////////////////////////////////////

	smart_ptr<ILoadCacheListener>	m_pLoadCacheListener;
	smart_ptr<ICacheStaleListener>	m_pCacheStaleListener;

	//	LbVVXe
	smart_ptr<CCacheManager>		m_vCacheManager;

	//	IuWFNg
	CIDObjectManager m_vIDObject;

	/*
		CIDObjectManagerɂ́AׂẴIuWFNgo^Ă
		ÂȂɈ͂܂ĂIuWFNg̉
		Ƃ͌Ȃ

		CCacheManagerɂ́AMRU(ŋߎgpjbg)IDԍ݂̂
		ǗĂB
	*/

	CIDObjectAndNumber GetIDObjectAndNumber(int n)
	{
		CIDObjectAndNumber o;
		o.pIDObject = &m_vIDObject;
		o.nNum = n;
		return o;
	}

	//	ݒt@ĈQxǂ݋֎~tO
	bool	m_bCanReloadAgain;

	//	t@C݂pX(Ύw)
	string	m_strReadDir;

	virtual LRESULT InnerLoad(const smart_obj& obj) = 0;
	/**
		ǂݍݍ
		ǂݍ݂̌ʃG[ȂΔ0Ԃ悤ɃR[fBO
	*/

	virtual void OnSet(const smart_obj& obj,int nID){}
	/**
		SetŃt@CǂݍނƂɒǉLq΁A
		̊֐I[o[Ch邱
	*/

};

//	t̂߂ɕKv
inline bool operator < (const CLoadCache::CIDObjectAndNumber& c1, const CLoadCache::CIDObjectAndNumber& c2)
{
	return (c1.pIDObject<c2.pIDObject) || (c1.pIDObject==c2.pIDObject && c1.nNum<c2.nNum);
}

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd

////////////////////////////////////////////////////////////////

#endif
