#include "stdafx.h"
#include "yaneStringMap.h"
#include "yaneStringScanner.h"
#include "yaneFile.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

void	CStringMap::Serialize(ISerialize&s){
	//	m_vStringMap܂邲serialize
	int n;
	if (s.IsStoring()){
		n = GetMap()->size();
		s << n; // TCY˂ނȂ[OO

		mymap::iterator it;
		for(it = GetMap()->begin();it!=GetMap()->end();++it){
			s << *const_cast<string*>(&it->first);
			s << *const_cast<string*>(&it->second);
		}

	} else {
		s << n;		//	𕜌Ȃ
		GetMap()->clear();	//	NAȂ

		for(int i = 0; i<n ; i++){
			string s1,s2;
			s << s1;
			s << s2;
			GetMap()->insert(pair<string,string>(s1,s2));
		}
	}
}


//	L[ɑ΂f[^̏
void	CStringMap::Write(const string& strKey,const string& strData){
	mymap::iterator it;
	it = GetMap()->find(strKey);
	if (it==GetMap()->end()){
		//	key݂͑Ȃ
		//	قȁA}[
		GetMap()->insert(pair<string,string>(strKey,strData));
	} else {
		//	㏑㏑㏑`(ށ)o
		it->second = strData;
	}
}

void	CStringMap::Write(const string& strKey,LONGLONG nData){
	string s;
	CStringScanner::NumToString(nData,s);
	Write(strKey,s);
}

//	L[ɑ΂f[^̒ǉ
void	CStringMap::Append(const string& strKey,const string& strData){
	mymap::iterator it;
	it = GetMap()->find(strKey);
	if (it==GetMap()->end()){
		//	key݂͑Ȃ
		//	قȁA}[
		GetMap()->insert(pair<string,string>(strKey,strData));
	} else {
		//	ǉǉǉ`(ށ)o@Ă̓XCJ`(ށ)o
		it->second += strData;
		//	string̒ǉȂŁAłłH
	}
}

void	CStringMap::Append(const string& strKey,LONGLONG nData){
	string s;
	CStringScanner::NumToString(nData,s);
	Write(strKey,s);
}

//	L[ɑ΂f[^̓ǂݏo
LRESULT	CStringMap::Read(const string& strKey,string& strData){
	mymap::iterator it;
	it = GetMap()->find(strKey);
	if (it==GetMap()->end()){
		//	key݂͑Ȃ
		strData.erase();
		return -1;
	}
	strData = it->second;
	return 0;
}

LRESULT	CStringMap::Read(const string& strKey,LONGLONG& nData){
	string s;
	LRESULT lr = Read(strKey,s);
	if (lr!=0) {
		nData = 0; // fail safe΍
		return lr;
	}
	return CStringScanner::StringToNum(s,nData);
}

//	L[ɑ΂f[^̒ڎ擾
	//	(̃L[݂ȂƂ́AstrDefault or lDefaultԂ)
string	CStringMap::GetStr(const string& strKey,const string& strDefault){
	string s;
	Read(strKey,s);
	if (s.empty()) {
		return strDefault; // G[szDefaultԂ
	}
	return s;
}

int CStringMap::GetNum(const string& strKey,int nDefault){
	LONGLONG l;
	if (Read(strKey,l)!=0) return nDefault; // errornDefaultԂ
	return (int)l;
}

LONGLONG	CStringMap::GetLongNum(const string& strKey,LONGLONG nDefault){
	LONGLONG l;
	if (Read(strKey,l)!=0) return nDefault; // errornDefaultԂ
	return l;
}

//	L[ɑ΂f[^̍폜
bool	CStringMap::Delete(const string& strKey){
	//	폜Ƃɂtrue
	return GetMap()->erase(strKey)!=0;
}

//	܂邲ƍ폜
void	CStringMap::Clear(){
	//	clear all data..
	GetMap()->clear();
}


//	`t@Cf[^ǂݏoāAi[@\
//	(VACYƂ͈ႢAȃtH[}bg̃t@Cǂݏo)
LRESULT	CStringMap::ReadFromConfigFile(const string& strFileName){
	CFile file;
	LRESULT lr = file.Read(strFileName);
	if (lr!=0) return lr;	//	ǂݍ߂Ė..

	Clear();	//	f[^̃NA

	string buf;
	string strKey,strData;
	while (true){
		LRESULT lr = file.ReadLine(buf);
		if (lr==1) break;
		if (buf.empty()) continue;
		if (buf.size()>=2 && buf[0] == '/' && buf[1] =='/') continue; // Rgs..
		if (buf.size()>=1 && buf[0]=='#') {	//	ݒs..
			LPCSTR psz = buf.c_str()+1;
			if (CStringScanner::SkipSpace(psz)!=0) continue;
			strKey = CStringScanner::GetStr(psz);
			if (CStringScanner::SkipSpace(psz)!=0) continue;
			strData = CStringScanner::GetStr(psz);
			if (strData.empty()) continue ; // f[^ւŁH
			Write(strKey,strData);
		}
	}
	return 0;
}

LRESULT CStringMap::WriteToConfigFile(const string& strFileName){
	CFile file;
	if (file.Open(strFileName.c_str(),"w")!=0) return 1;

	mymap::iterator it;
	for(it = GetMap()->begin();it!=GetMap()->end();++it){
		file.Write(
			string("#") + (it->first) + " " + (it->second) + '\n'
		);
	}
	return 0;
}

//	̘AzLŒu
void	CStringMap::Replace(string& s,bool bCaseSensitive){
	//	uȂ̕\
	mymap::iterator it;
	for(it = GetMap()->begin();it!=GetMap()->end();++it){
		CStringScanner::Replace(s,
			static_cast<string>(it->first).c_str(),
			static_cast<string>(it->second).c_str(),
			bCaseSensitive);
	}
}

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd
