//
//	Device Independent Bitmap
//

#ifndef __yaneDIBitmap_h__
#define __yaneDIBitmap_h__


namespace yaneuraoGameSDK3rd {
namespace Draw {

class CSurfaceInfo;

class IDIBitmap {
public:
	virtual LRESULT Load(const string& strFileName,int nBpp=24)=0;
	virtual LRESULT Blt(HDC hSrcDC,LPCRECT lpRect,int nBpp=24)=0;
	virtual LRESULT Save(const string& strFileName,LPCRECT lpRect=NULL)=0;
	virtual LRESULT CreateSurface(int nSizeX,int nSizeY,int nBpp=24,bool bAlpha=false)=0;
	virtual LRESULT Clear(LPRECT pRect=NULL)=0;
	virtual LRESULT	Release()=0;

	virtual HDC		GetDC()=0;
	virtual HBITMAP GetHBITMAP()=0;
	virtual LRESULT	GetSize(LONG& x,LONG& y)=0;
	virtual BYTE*	GetPtr()=0;

	virtual CSurfaceInfo* GetSurfaceInfo()=0;

	virtual ~IDIBitmap(){}
};

class CDIBitmap : public IDIBitmap {
/**
	DIB(Device Independent BitmapFfoCXɈˑȂrbg}bv)
	Ǘ܂B
*/
public:
	///	摜̓ǂݍ
	virtual LRESULT Load(const string& strFileName,int nBpp=24);
	/**
		Load̓t@CT[tF[XɓǂݍށB
		Save̓T[tF[Xt@Cɏ݂܂B
@		ǂݍ݂CGraphicLoaderNXgp̂ŁA
		BMP,GIF,JPEG,SPI̗p\ɂȂ܂B
		nBppw肷ƁAbpp(bits per pixel)œǂݍ݂܂B
		݂24bpp̃rbg}bvɂȂ܂B
		lpRect̓t@CɕۑT[tF[X̋`̈w肵܂B
		w肪ȂΑSɂȂ܂B

		gpj
	@@::SetPixel(dib.GetDC(),0,0,RGB(100,200,150));
			// (0,0)̍WRGB(100,200,150)̓_ł

		QƁ@::GetPixel,COLORREF,GetRValue,GetGValue,GetBValue

	*/

	virtual LRESULT Blt(HDC hSrcDC,LPCRECT lpRect,int nBpp=24);
	/**
		hDCŎw肳A`̈lpRectCDIBitmapɓǂݍށB
		̂ƁASave邱ƂɂāArbg}bvɕۑĂ邱Ƃ
		oB܂HDClł΁Å֐SaveŃrbg}bv
		ۑ邱ƂoB
		nBppw肷ƁAbpp(bits per pixel)ŃT[tF[X쐬
		ǂݍ݂܂Bx͒xłB
	*/

	virtual LRESULT Save(const string& strFileName,LPCRECT lpRect=NULL);
	/**
		T[tF[X̃t@Cւ̕ۑ
		w肵`ۑ܂BlpRect==NULLȂ΁AT[tF[XSB
	*/

	virtual LRESULT CreateSurface(int nSizeX,int nSizeY,int nBpp=24,bool bAlpha=false);
	/**
		T[tF[XwTCYAwBPP(BitParPixel)ō쐬܂B
		T[tF[X̓NA܂B

		bAlpha==trueɂĂƁAGetSurfaceInfoŎ擾ł
		SurfaceTypeT[tF[X̔ԍɂȂĕԂĂ̂
		(AnBpp==32w肵Ȃ΂ȂȂ)
		̂ƁACSurfaceInfoBltterAlphaT[tF[X̂Ƃ
		]邱Ƃo
	*/

	virtual LRESULT Clear(LPRECT pRect=NULL);
	/**
		T[tF[X̃NA
	*/

	virtual LRESULT	Release();
	/**
		T[tF[X܂BfXgN^ŉ̂ŁA
		IɎw肷Kv͂܂B
	*/

	//	LoadBitmap/CreateSurfaceȍ~AłDC̎擾͉\
	virtual HDC		GetDC() { return m_hDC; }
	virtual HBITMAP GetHBITMAP() { return m_hBitmap; }
	/**
		HDCAHBITMAPԂ܂BUseDIBSection(true)ƂĂꍇ
		idefaultłfalsejALoadBitmap/CreateSurfaceȍ~Ał
		HDC,HBITMAP̎擾͉\łB
		păsNZƗǂłB
	*/

	virtual LRESULT	GetSize(LONG& x,LONG& y);
	/**
		T[tF[X̃TCY擾܂B
	*/

	virtual BYTE*	GetPtr() { return (BYTE*)m_lpdwSrc; }
	/**
		Load/CreateSurfaceŊmۂꂽC[Wւ̃|C^܂B
		(CreateDIBSectionœꂽ)
		DIBȂ̂ŁAC[W̊eC̐擪́ADWORDŃACĂ̂
		ӂKvB㉺͓]uĂ܂B
	*/

	virtual CSurfaceInfo* GetSurfaceInfo();
	/**
		class CSurfaceInfo ΁ABltterp
		ǂȓ]ł\ɂȂ
	*/

	/**
		TCY擾̂߂property
	*/
	ULONG GetWidth() const { return m_nSizeX; }
	ULONG GetHeight() const { return m_nSizeY; }

	CDIBitmap();
	virtual ~CDIBitmap();

protected:
	DWORD*	m_lpdwSrc;		//	\[Xobt@
	LONG	m_nSizeX;
	LONG	m_nSizeY;
	int		m_nBpp;
	HBITMAP m_hBitmap;
	HDC		m_hDC;

	smart_ptr<CSurfaceInfo> m_vSurfaceInfo;
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif
