
// yaneFastDraw.h
/**
	 This is a extended DirectDraw wrapper using the template library.
		programmed by yaneurao(M.Isozaki) '01/10/01-'01/10/06

		`ɊւAVvȎB
		yaneuraoGameSDK 3rd styleƂ́A
		ƁACDirectDraw,CPlane,CDIBDrawjāA
		̃NXɂ邾낤B

		قǁAA`̍ƂȂł낤NXB

		ĆAɊmۂT[tF[XB
		ZJ_AɊmۂT[tF[XB
		vC}iꍇɂĂ̓ZJ_jADirectDrawSurfaceB
		{Iɂ́Ag킯B

		AtXN[́AtbsOT[tF[XT|[gB
			˂܂胁bgȂ̂ŁAmT|[gɂ܂OOG
		̂Ƃ́AVRAMɊmۂꂽvC}QāA
		ZJ_̓ɊmۂĂAƂ\tgI
		gvobt@OsȂB

		܂A`̂߂̓]́AfunctorgčsȂB
		ŏIIɂ́AIɁAPentium/MMX̃AZuɂR[h
		邩mȂB

*/

#ifndef __yaneFastDraw_h__
#define __yaneFastDraw_h__


#ifdef USE_FastDraw

#include "yaneSurface.h"
#include "../Window/yaneWinHook.h"
#include "yaneLayer.h"
//#include "yaneSprite.h"
#include "yaneDirectDraw.h"
#include "yaneFastPlane.h"
#include "../AppFrame/yaneAppDraw.h"

//////////////////////////////////////////////////////////////////////////////

namespace yaneuraoGameSDK3rd {
namespace Draw {

class CFastDraw : public IWinHook , public IAppDraw {
public:

	///	---	IAppDraw̃o
	virtual int GetType() const { return 1; }

	//////////////////////////////////////////
	//	fBXvC[h̕ύX

	LRESULT		SetDisplay(bool bFullScr=false,int nSizeX=0,int nSizeY=0,int nColorDepth=0);
	void		GetDisplay(bool&bFullScr,int &nSizeX,int &nSizeY,int &nColorDepth);
	void		GetSize(int &nSizeX,int &nSizeY);	// GetDisplayModex,y
	bool		IsFullScreen();

	//	Begin`EndŃfBXvC[hύXB
	void		BeginChangeDisplay();
	void		TestDisplayMode(int nSX,int nSY,bool bFullScr=false,int nColor=0);
	LRESULT		EndChangeDisplay();

	//////////////////////////////////////////

//	void	UseHardwareFlip(bool bEnable) { m_bUseFlip=true; }
	//	n[hEFAtbsOĝH
	//		fBtHgłtrue
	//		AύXȂ΁AfBXvC[h̕ύXɐsāA
	//		̊֐ĂяoƁB
	//	FastDrawɂFlip@\͑xIɂ́A܂Ahoe[W
	//	܂AZJ_rfIɔzuĂ܂ƁA
	//	ꂼ̓]ɂAlock`unlock̃RXgłȂDD
	//	PɁA`掞́AtbJOij̖h~炢̈Ӗ
	//	ADirectDraẃAWindows GDI𖳎ĕ`sȂ̂
	//	j[ɍ쓮ȂȂ̂ŒӂKv

	void	UseDibSectionIn256(bool bEnable){}
		//	ˁ@ł́AT|[g
	//	256F[hɂāARGB555(16bpp)gǂB
	//		fBtHgłtrue
	//		A256F[hł́ApbggA
	//		Ǝ̔sȂȂfalseɂĂƁB

	//////////////////////////////////////////
	//	vC}ƃZJ_̎擾

	CFastPlane*		GetPrimary()		{ return &m_Primary; }
		//	@`悷邽߂̃vC}T[tF[X
/*
	CFastPlane*		GetPrimary2()		{ return &m_Primary2; }
		//	tXN[ŁAn[hEFAtbsOsȂƂ
		//		̃T[tF[XʂɂȂ
*/
	CFastPlane*		GetSecondary256()	{ return &m_Secondary256; }
		//	QTUF[ĥƂɂ́AZJ_(RGB555)A
		//@̃T[tF[Xɓ]Ă`悷̂

	CFastPlane*		GetSecondary()		{ return &m_Secondary;}
		//	ɊmۂꂽAZJ_T[tF[X
		//		fBtHgłDirectDrawSurfaceƂȂB
		//	A256F[hɂẮARGB555̃T[tF[XI

	//////////////////////////////////////////
	//	Secondary->Primaryv[̓]
	
	virtual void	OnDraw(LPCRECT lpRect=NULL,bool bLayerCallBack=true);
	//	Secondary->Primaryւ̓]

	//	L]̂ƂɁAւĂp[^
	void	SetOffset(int ox,int oy);	//	ZJ_̓]ItZbg
	void	SetBrightness(int nBright); //	tF[h䗦(0-256)

	//////////////////////////////////////////
	//	C̊Ǘ

	//	Layer̃XgԂ
	ILayerList* GetLayerList() { return &m_LayerList; }
	ILayerList* GetAfterLayerList() { return &m_AfterLayerList; }
	ILayerList* GetHDCLayerList() { return &m_HDCLayerList; }

	//	CƂ́AOnDraŵƂAȂ킿AZJ_vC}
	//	]ƂɁAR[obNƂČĂяôÁA
	//	ZJ_HDC擾łT[tF[XiDirectDrawSurfacej
	//	ł邱Ƃ̑OƂȂB

	//////////////////////////////////////////
	/// ----	܂
	int	GetBpp(); // ݂̉bpp̎擾

	///	DirectDrawPtr擾
	LPDIRECTDRAW	GetDDraw() { return m_DirectDrawBase.Get(); }

	/// ̃NXǗĂT[tF[Xւ̃|C^擾
	list_chain<CFastPlane>* GetFastPlaneList() { return& m_listFastPlane; }

	//////////////////////////////////////////
	//	property..

	int		GetMenuHeight();
	//	j[ĂȂ΁Ãj[Ԃ

	//////////////////////////////////////////

	CFastDraw();
	virtual ~CFastDraw();

protected:
	CDirectDraw m_DirectDrawBase;

	//	ʃ[h̕ύX֘A
	LRESULT		ChangeDisplay(bool bFullScr);	//	݂̃fBXvC[h𔽉f
	bool	m_bFullScr;			//	tXN[[hH
	int		m_nScreenXSize;		//	ʃTCY
	int		m_nScreenYSize;
	int		m_nScreenColor;		//	bpp
	bool	m_bDisplayChanging; //	𑜓xύX
	bool	m_bChangeDisplayMode;// fBXvC[hύX邩 // ǉ

	//	--- OnDrawŗp
	//		ʂ̃tF[h֘A
	int		m_nBrightness;
	//		]ItZbg
	int		m_nSecondaryOffsetX;		//	ZJ_̓]ItZbg
	int		m_nSecondaryOffsetY;

	HWND	m_hWnd;				//	CAppInitializer擾ƒxȂ̂

	int		m_nMenu;			//	j[
	//	̃NX̃RXgN^ŌvZĕێĂ

	//	for Layer management
	CLayerList	m_LayerList;
	CLayerList	m_AfterLayerList;
	CLayerList	m_HDCLayerList;

	//////////////////////////////////////////
	//	T[tF[X̃Xg`FbN
	//	i[U[́AIɂ́AĂяoȂj
	void		CheckSurfaceLost();
	//	T[tF[X̃Xg`FbNipj
	bool	m_bLostSurface;

/*
	//	tXN[filpping surfacegp̂H
	//	default == true
	bool	m_bUseFlip;
	//	ۂɁAtbsOT[tF[X͍쐬ꂽ̂H
	bool	m_bUseFlip2;
*/

	//	ꎞ̂
	void	RealizeBrightness(int nBrightness);

	///////////////////////////////////////////////////////

	list_chain<CFastPlane> m_listFastPlane;

	///////////////////////////////////////////////////////
	//	CFastPlanẽRXgN^ɂCFastDraw*Kv
	//	܂CFastPlanéACFastDrawlist_chainadd悤Ƃ
	//	āACFastDraw̃RXgN^ŏƂɂ́A
	//	list_chainς݂łȂĂ͂ȂȂB
	
	//	vC}T[tF[XƃZJ_T[tF[X
	CFastPlane	m_Primary;	//	
//	CFastPlane	m_Primary2;	//	FlippingƂ̂߂̃T[tF[X
	CFastPlane	m_Secondary256;	//	256F[h̎̉BZJ_
	CFastPlane	m_Secondary;
	CDirectDrawClipper m_WindowClipper;

	CFastDraw* GetThis() { return this; }

	//	T[tF[X̃XgoāAXgA
	void	RestoreAll();


	//	fBXvC𑜓xύXƂ̔rlockp
	CCriticalSection m_cs;
	CCriticalSection* GetCriticalSection(){return &m_cs;}

	// overriden from CWinHook
	LRESULT WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif // USE_FastDraw

#endif
