
#include "stdafx.h"

#ifdef USE_FastDraw

#include "yaneFastPlane.h"
#include "yaneFastDraw.h"
#include "yaneDirectDraw.h"
#include "yaneDIBitmap.h"
#include "yaneGraphicLoader.h"
#include "../Auxiliary/yaneFile.h"
#include "yaneGTL.h"

namespace yaneuraoGameSDK3rd {
namespace Draw {

//////////////////////////////////////////////////////
//	static members..

ThreadLocal<CFastDraw*> CFastPlane::m_pDefaultFastDraw;

//////////////////////////////////////////////////////

CFastPlane::CFastPlane(CFastDraw* pFastDraw)
{
	m_pFastDraw = NULL;
	SetFastDraw(pFastDraw);

	m_nSizeX	=	0;
	m_nSizeY	=	0;
	m_lpSurface	=	NULL;
	m_lpPalette	=	NULL;

	ResetColorKey();
	m_hDC		=	NULL;

	//	VXeɊmۂ̂I
	m_bUseSystemMemory	=	true;

	m_bYGA			= false;
	m_bYGAUse		= false;
	m_bMySurface	= false;
	m_bSecondary256 = false;
	//	256F[hȂ΁AʏRGB555̃T[tF[X쐬̂A
	//	ZJ_256FT[tF[X
	m_bLoad256		= false;
	m_bSecondary256DIB=false;

	//	RGB555MySurfaceɑ΂āADIB Sectiongp̂H
	m_hBitmap		= NULL;
	m_hDC			= NULL;

	//	CT[tF[X
	m_bAutoRestore = false;
	//	I[i[h[(RestoreĂяoȂBPrimary,Secondary͂)
	m_bOwnerDraw	= false;
	m_bPrimary		= false;

	m_bNowRestoring	= false;
}

CFastPlane::~CFastPlane(){
	Release();
}

smart_ptr<ISurface> CFastPlane::clone() {
	return smart_ptr<ISurface>(new CFastPlane(GetMyFastDraw()));
}

LRESULT	CFastPlane::Release(){
	//	owner create surface
	//	256F[h̉zZJ_DIBƂč쐬Ă񂩁H
	if (m_hBitmap){
		m_bMySurface = false;
		if (m_hDC!=NULL){
			::DeleteDC(m_hDC);
			m_hDC = NULL;
		}
		if (m_hBitmap!=NULL){
			::DeleteObject(m_hBitmap);
			m_hBitmap = NULL;
		}
	}

	if (m_bMySurface) {
		switch (GetSurfaceType()){
		case 3: {
			CFastPlaneRGB565* pwd = (CFastPlaneRGB565*)GetSurfaceInfo()->GetPtr();
			delete [] pwd; } break;
		case 4: {
			CFastPlaneRGB555* pwd = (CFastPlaneRGB555*)GetSurfaceInfo()->GetPtr();
			delete [] pwd; } break;
		case 5: {
			CFastPlaneRGB888* pwd = (CFastPlaneRGB888*)GetSurfaceInfo()->GetPtr();
			delete [] pwd; } break;
		case 6: {
			CFastPlaneBGR888* pwd = (CFastPlaneBGR888*)GetSurfaceInfo()->GetPtr();
			delete [] pwd; } break;
		case 7: {
			CFastPlaneXRGB8888* pwd = (CFastPlaneXRGB8888*)GetSurfaceInfo()->GetPtr();
			delete [] pwd; } break;
		case 8: {
			CFastPlaneXBGR8888* pwd = (CFastPlaneXBGR8888*)GetSurfaceInfo()->GetPtr();
			delete [] pwd; } break;
		case 10: {
			CFastPlaneARGB4565* pwd = (CFastPlaneARGB4565*)GetSurfaceInfo()->GetPtr();
			delete [] pwd; } break;
		case 11: {
			CFastPlaneARGB4555* pwd = (CFastPlaneARGB4555*)GetSurfaceInfo()->GetPtr();
			delete [] pwd; } break;
		case 12: {
			CFastPlaneARGB8888* pdw = (CFastPlaneARGB8888*)GetSurfaceInfo()->GetPtr();
			delete [] pdw; } break;
		case 13: {
			CFastPlaneABGR8888* pdw = (CFastPlaneABGR8888*)GetSurfaceInfo()->GetPtr();
			delete [] pdw; } break;
		default:
			Err.Out("CFastPlane::ReleaseŕsT[tF[X̃[X");
		}
		m_bMySurface = false;
	}

	RELEASE_SAFE(m_lpSurface);
	RELEASE_SAFE(m_lpPalette);
	m_strBitmapFile.erase();
	m_nSizeX	=	0;
	m_nSizeY	=	0;
	m_bLoad256	= false;
	GetSurfaceInfo()->SetInit(false);	//	T[tF[X

	if (!m_bNowRestoring && GetMyFastDraw()!=NULL){
		GetMyFastDraw()->GetFastPlaneList()->erase(this);
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////

LRESULT	CFastPlane::GetSize(int &x,int &y) const {
	x = m_nSizeX;
	y = m_nSizeY;
	return const_cast<CFastPlane*>(this)->GetSurfaceInfo()->IsInit()?0:1;
}

//	T[tF[X̃Xgɑ΂镜A
LRESULT	CFastPlane::Restore(){
	LRESULT lr = 0;
	m_bNowRestoring = true;	//	XgAɂAReleaseŃtbN̋֎~I
	int nType = GetSurfaceInfo()->GetSurfaceType();
	if (nType!=0){	//	Surface݂邩ǂ́AŔ肷Kv
		//	VXẽT[tF[XLostȂ̂OOG
		//	݂̉bppƈقȂT[tF[XȂ΁ÂčȂKv
		bool bRestore = false;
		if (m_lpSurface!=NULL && m_lpSurface->IsLost()) {
			//	&& _Zq́AEւ̕]ۏ؂邵A
			//	VC̍œKɂAɉE]Ȃ̂ۏ؂
			bRestore = true;
		} else {
		//	݂̉bppƃRp`ŖT[tF[XȂ΃XgA
			int nType2 = GetMyFastDraw()->GetPrimary()->GetSurfaceType();
			switch (nType2){
			case 2:	//	256F̂Ƃ́ARGB555Ƃ݂Ȃ
				if (nType==2 && m_bSecondary256) break; // 256FpZJ_H
				if (nType==4 || nType == 11) break;
				bRestore = true; break;
			case 3:
				if (nType==3 || nType == 10) break;
				bRestore = true; break;
			case 4:
				//	256F[h̎ɓǂݍ񂾃rbg}bvȂ񂩐MpłȂ
				if (m_bLoad256 && IsLoaded()) {
					bRestore = true; break;
				}
				if (nType==4 || nType == 11) break;
				bRestore = true; break;
			case 5:
			case 6:
			case 7:
			case 8:
				if (nType==nType2 || nType == 12) break;
				bRestore = true; break;
			}
		}

		if (bRestore){
			if (m_bAutoRestore){
			//	CT[tF[XȂ΁AT[tF[X쐬ARs[
				LRESULT lrErr = 0;
				if (m_nSizeX!=0 && m_nSizeY!=0){
					CFastPlane plane;
					plane.CreateSurface(m_nSizeX,m_nSizeY,IsYGA());
					lrErr = plane.BltFast(this,0,0);
					// ̕ϊ\H
					if (lrErr==0){
						InnerCreateSurface(m_nSizeX,m_nSizeY,m_bYGA,m_bSecondary256);
						lrErr = BltFast(&plane,0,0);
					}
				}
				//	]ɎsA[Ȃ玩OŃXgAĂ񂩁DD
				if (lrErr!=0) goto RestoreRetry;

				//	݂̉ʃ[hɍ킹ColorKeyݒ肵Ȃ
				UpdateColorKey();
			} else {
RestoreRetry:;
				//	rbg}bvt@CȂ΂𕜌
				if (IsLoaded()){
					lr = InnerLoad(m_strBitmapFile);
				} else {
					//	{́ÂƂAϊqpӂĕϊقǂ
					//	ÂׂĂ̑gݍ킹͖cłDD
					//	xAARGB8888ɕϊāA^[Qbg^
					//	߂΁Ał̂DD

					if (m_nSizeX!=0 && m_nSizeY!=0){
						//	Ƃ肠AT[tF[XȂƂDD
						InnerCreateSurface(m_nSizeX,m_nSizeY,m_bYGA,m_bSecondary256);
					}
				}
				//	݂̉ʃ[hɍ킹ColorKeyݒ肵Ȃ
				UpdateColorKey();
				//	I[i[h[mȂ̂ŁA𕜌
				lr |= OnDraw();	//	Ϗ
			}
		}
	}
	m_bNowRestoring = false;	//	XgAIɂAReleaseŃtbN̉I
	return lr;
}


LRESULT CFastPlane::Load(const string& strBitmapFileName){
	Release();
	ResetColorKey();
	// ƂRestoreł悤Ƀt@Ci[ĂB
	LRESULT lr = InnerLoad(strBitmapFileName);
	m_strBitmapFile = strBitmapFileName;
	return lr;
}

//	t@CԂ
string	CFastPlane::GetFileName() const{
	return m_strBitmapFile;
}

////////////////////////////////////////////////////////////////////////////////////

//	rbg}bv̓Iȃ[hBi[t@Cɂ͉eȂ
LRESULT	CFastPlane::InnerLoad(const string& strFileName){
/**
	ISurface::LoadĂ̂ŁA{Iȓǂݍ݂́A
	T[tF[X쐬ɁAISurface::LoadɈϏΗǂ
*/

	/**
		InnerLoad́A
		rbg}bvt@CAF̎w蓙j󂵂ȂƂۏ؂
		̂ReleaseOɂׂĂ̐ݒۑ
	*/
	string strBitmap(m_strBitmapFile);
	//	colorkey̐ݒۑ

	bool bUsePosColorKey = m_bUsePosColorKey;
	int	nColorKeyX = m_nColorKeyX, nColorKeyY = m_nColorKeyY;
	ISurfaceRGB rgbColorKey = m_rgbColorKey;
	{
		Release();	//	
	}
	m_strBitmapFile = strBitmap;
	m_bUsePosColorKey = bUsePosColorKey;
	m_nColorKeyX = nColorKeyX; m_nColorKeyY = nColorKeyY;
	m_rgbColorKey = rgbColorKey;


	//	#notdefined#Ȃ΁AIƂċA
	if (strFileName == "#notdefined#"){
		return 0;
	}

	//	nSurfaceTypẽT[tF[X쐬Aɓǂݍ

	int nSurfaceType = GetMyFastDraw()->GetPrimary()->GetSurfaceType();

	m_bLoad256 = false;
	if (m_bYGAUse){
	//	T[tF[X쐬̂H
		nSurfaceType = GetYGASurfaceType(nSurfaceType);
		//	Ή郿T[tF[X̔ԍ𓾂
	} else {
		switch(nSurfaceType){
		case 2: nSurfaceType = 4; m_bLoad256=true; break;
		// ---- 8bppȂ RGB555ō쐬B
		//	̂Ƃǂݍ񂾃rbg}bv́A
		//	̉ʃ[hɈڍsƂɃXgAׂ
		}
	}

	LRESULT lr = ISurface::LoadByType(strFileName,nSurfaceType);
	if (lr!=0) return lr;

	// FZbgƂ[
	// ResetColorKey();@܂('02/11/01)yane.
	// FXVƂ[
	UpdateColorKey();

	return lr;
}

HDC CFastPlane::GetDC(){
	if (m_hBitmap!=NULL){
		return m_hDC;
	}
	
	if (m_hDC!=NULL) {
		Err.Out("CFastPlane::EndPaintĂяoĂȂ̂BeginPaintĂяoꂽ");
		return NULL;
	}
	if (m_lpSurface==NULL) return NULL;
	if (m_lpSurface->GetDC(&m_hDC)!=DD_OK) return NULL;
	return m_hDC;
}

void CFastPlane::ReleaseDC(){
	if (m_hBitmap!=NULL){
		return ;
	}

	if (m_hDC==NULL) {
		Err.Out("CFastPlane::BeginPaintĂяoĂȂ̂EndPaintĂяoꂽ");
		return ;
	}
	if (m_lpSurface==NULL) return ;
	if (m_lpSurface->ReleaseDC(m_hDC)!=DD_OK) return ;
	m_hDC = NULL;
}

LRESULT CFastPlane::InnerCreateMySurface(int sx,int sy,int nSurfaceType,bool bClear/*=true*/){

	m_nSizeX = sx; m_nSizeY = sy;
	SIZE rc = { m_nSizeX,m_nSizeY };

	switch (nSurfaceType){
	case 4:	{ //	RGB555쐬
		CFastPlaneRGB555* lpSurface;
		if (m_bSecondary256DIB){
			//	256Fp̉zZJ_łȂ΁ADIBSectionōĂ
			//	(HDC擾ł悤ɂ邽)
			BITMAPINFO bmi;
			ZERO(bmi);
			bmi.bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
			bmi.bmiHeader.biWidth		=  m_nSizeX;
			bmi.bmiHeader.biHeight		= -m_nSizeX;
			bmi.bmiHeader.biPlanes		= 1;
			bmi.bmiHeader.biBitCount	= 16;
			bmi.bmiHeader.biCompression	= BI_RGB;
			HDC hdc = ::GetDC(NULL); // hWnd̂ق񂩁H
			m_hBitmap = ::CreateDIBSection(hdc /* NULL*/, &bmi , DIB_RGB_COLORS, (void**)&lpSurface, NULL, 0 );
			//	ōDIBRGB555̂悤H
			::ReleaseDC(NULL,hdc);
			if (m_hBitmap==NULL) return 1;
			m_hDC = ::CreateCompatibleDC(NULL);
//			m_hDC = ::CreateCompatibleDC(::GetDC(NULL));
			::SelectObject(m_hDC,m_hBitmap);
		} else {
			lpSurface = new CFastPlaneRGB555[m_nSizeX * m_nSizeY];
		}
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneRGB555),rc);
		break;
				}
		//	̂ƂAHDC͎擾łȂBSl
	case 3:	{ //	RGB565쐬
		CFastPlaneRGB565* lpSurface = new CFastPlaneRGB565[m_nSizeX * m_nSizeY];
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneRGB565),rc);
		break;
				}
	case 5: { //	RGB888쐬
		CFastPlaneRGB888* lpSurface = new CFastPlaneRGB888[m_nSizeX * m_nSizeY];
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneRGB888),rc);
		break;
			}
	case 6: { //	BGR888쐬
		CFastPlaneBGR888* lpSurface = new CFastPlaneBGR888[m_nSizeX * m_nSizeY];
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneBGR888),rc);
		break;
			}
	case 7: { //	XRGB8888쐬
		CFastPlaneXRGB8888* lpSurface = new CFastPlaneXRGB8888[m_nSizeX * m_nSizeY];
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneXRGB8888),rc);
		break;
			}
	case 8: { //	XBGR8888쐬
		CFastPlaneXBGR8888* lpSurface = new CFastPlaneXBGR8888[m_nSizeX * m_nSizeY];
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneXBGR8888),rc);
		break;
			}

	case 10:	{ //	ARGB4565쐬
		CFastPlaneARGB4565* lpSurface = new CFastPlaneARGB4565[m_nSizeX * m_nSizeY];
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneARGB4565),rc);
		break;
				}
	case 11: { //	ARGB4555쐬
		CFastPlaneARGB4555* lpSurface = new CFastPlaneARGB4555[m_nSizeX * m_nSizeY];
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneARGB4555),rc);
		break;
				}
	case 12:	//	ARGB8888
			{ //	ARGB8888쐬
		CFastPlaneARGB8888* lpSurface = new CFastPlaneARGB8888[m_nSizeX * m_nSizeY];
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneARGB8888),rc);
		break;
				}
	case 13:	//	ABGR8888
			{ //	ABGR8888쐬
		CFastPlaneABGR8888* lpSurface = new CFastPlaneABGR8888[m_nSizeX * m_nSizeY];
		GetSurfaceInfo()->Init((void*)lpSurface,m_nSizeX*sizeof(CFastPlaneABGR8888),rc);
		break;
				}
	default:
		return 1;	//	T|[gĂւŁOOG
	}

	m_bYGA = (nSurfaceType>=10);

	GetSurfaceInfo()->SetSurfaceType(nSurfaceType);
	m_bMySurface = true; // newT[tF[Xł邱ƂӖ}[J[

	//	NAtOĂȂȂNAȂ
	if (bClear) Clear();

	//	hook Jn
	if (!m_bNowRestoring && GetMyFastDraw()!=NULL){
		GetMyFastDraw()->GetFastPlaneList()->insert(this);
	}
	return 0;
}

LRESULT CFastPlane::CreateSurfaceByType(int sx,int sy,int nType){
	return InnerCreateMySurface(sx,sy,nType,false);
}

LRESULT CFastPlane::InnerCreateSurface(int sx,int sy,bool bYGA,bool bSecondary256){
	Release();

	if (sx==0 || sy==0) {
		return 1;	//	ȃT[tF[XAقĂ[OOG
	}

	//	݂̉ʃ[hɉ̂ɂKv
	int nType = GetMyFastDraw()->GetPrimary()->GetSurfaceType();

	if (!bYGA) {
		//	YGA摜ł͖̂ŖDirectDrawSurface
		//	A8bpp̂Ƃ́ARGB555̃T[tF[X
		if (nType == 2 && !bSecondary256) {
			return InnerCreateMySurface(sx,sy,4);
		} else {
			if (bSecondary256) m_bSecondary256 = true;
			//	̃T[tF[X́A256FpZJ_
		}

		///	݂̃vC}傫ȃT[tF[X͍쐬Ɏs
		///	(DirectX3̐)
		int nPx,nPy;
		GetMyFastDraw()->GetPrimary()->GetSize(nPx,nPy);
		bool bCreateDirectDrawSurface = !(nPx < sx || nPx < sy);
		if (bCreateDirectDrawSurface) {

			DDSURFACEDESC ddsd;
			ZERO(ddsd);
			ddsd.dwSize = sizeof(ddsd);
			ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
			//	IɃVXegIvV
			if (m_bUseSystemMemory) {
				ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY;
			} else {
				ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
			}
			// TCYۑĂ
			m_nSizeX = ddsd.dwWidth	 = sx;
			m_nSizeY = ddsd.dwHeight = sy;

			//	RGB888ŁAoCgŏIĂƂ炵̂ŁA
			//	]Ɋmۂ悤ɂBdWidthȂ΋Ŋmۂ悤ɂ
			if (GetMyFastDraw()->GetPrimary()->GetBpp()==24 && ((ddsd.dwWidth & 1)==1)){
				ddsd.dwWidth++;	//	IɋoCgɃAC
			}
			LPDIRECTDRAW lpDraw = GetMyFastDraw()->GetDDraw();
			if (lpDraw==NULL) return 1;
			if (lpDraw->CreateSurface(&ddsd,&m_lpSurface,NULL)!=DD_OK){
				Err.Out("CFastPlane::InnerCreateSurfaceCreateSurfaceɎs");
				return 2; // [
			}
		} else {
			return InnerCreateMySurface(sx,sy,nType);
		}

		UpdateSurfaceInfo();

		//	m_nSurfaceRef = 1;	//	QƃJEg̐ݒOO
		Clear();	//	Ô߃NAĂ(ŏʂ0ɂ邽)
	} else {
		//	xf`摜Ȃ̂ŁẢ݂ʃ[hɉ̂ɂKv
		int nType = GetMyFastDraw()->GetPrimary()->GetSurfaceType();
		switch (nType){
		case 3:	 //	ARGB4565쐬
			return InnerCreateMySurface(sx,sy,10);
			break;

		case 2:	 // 8bpp̂Ƃ́ARGB555Ȃ̂ŁAɑ΂YGAARGB4555
		case 4:	 //	ARGB4555쐬
			return InnerCreateMySurface(sx,sy,11);
			break;

		//	RGBȂARGB8888ł񂿂ႤH
		case 5:	//	RGB888
		case 7:	//	XRGB8888
			return InnerCreateMySurface(sx,sy,12);
			break;
		//	BGRȂΖOaẐƂƂlABGR8888ɂƂH
		case 6:	//	BGR888
		case 8:	//	XBGR8888
			return InnerCreateMySurface(sx,sy,13);
			break;
		}

		//	NAĂȂƃɃS~c܂܂ɂȂDDOOG
		Clear();
	}

	m_bYGA = bYGA;

	//	hook Jn
	//	--- ȊÓAInnerCreateMySurfacêȂhookĂ̂ok
	if (GetMyFastDraw()!=NULL){
		GetMyFastDraw()->GetFastPlaneList()->insert(this);
	}
	return 0;
}

LRESULT CFastPlane::CreateSurface(int sx,int sy,bool bYGA){
	//	ʂCreateSurfaceƁA͊ԈႢȂI[i[h[v[ł
//	m_bOwnerDraw	= false;
//	m_bBitmap		= false;
	ResetColorKey();

	LRESULT lr = InnerCreateSurface(sx,sy,bYGA || m_bYGAUse);
	if (lr) return lr;

	UpdateColorKey();

	//	CreateSurfaceĂ񂾂AFillColor̓Zbgׂ? '00/09/09
	//	˂AĂ܂ƁAʂ؂ւƁAFillColorςĂ܂DD

//	m_bOwnerDraw	= true;

	return 0;
}

//	vC}T[tF[X̐
LRESULT	CFastPlane::CreatePrimary(bool& bUseFlip,int nSx,int nSy){
	m_bPrimary = true;

	Release();
	ResetColorKey();
	LPDIRECTDRAW lpDraw = GetMyFastDraw()->GetDDraw();
	if (lpDraw==NULL) return 1;
	/* if (!IWindow::IsFullScreen()) */
	bUseFlip = false;

sur_retry: ;
	DDSURFACEDESC ddsd;
	ZERO(ddsd);
	ddsd.dwSize = sizeof(ddsd);

	if (bUseFlip) {
		ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE
			| DDSCAPS_FLIP
			| DDSCAPS_COMPLEX;
		ddsd.dwBackBufferCount = 1;
	} else {
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
	}
	if (lpDraw->CreateSurface(&ddsd,&m_lpSurface,NULL)!=DD_OK){
		Err.Out("CFastPlane::CreatePrimaryɎs");
		if (bUseFlip) {
			bUseFlip=false;
			// Flipping Surface̓rfIɔzuKv邽߁A
			// CreateɃ~XƂl
			goto sur_retry;
		}
		return 1; // [
	}
	//	ŃRs[Ă
	if (nSx && nSy) {
		m_nSizeX = nSx; m_nSizeY = nSy;	//	TCY̗͂p
	} else {
		GetMyFastDraw()->GetSize(m_nSizeX,m_nSizeY);
	}

	UpdateSurfaceInfo();

	if (GetSurfaceType() == 2) {
		//	8bppAZJ_256lA
		//	256F[h₯ǁARGB555ł͖A8bppƂėpӂꂽ
		//	ȃT[tF[XƂĐ\
		m_bSecondary256 = true;
	}

	//	̃T[tF[Xɑ΂ĂAJ[L[͐ݒ肵ƂDD
	//	UpdateColorKey();

//	m_nSurfaceRef = 1;		//	QƃJEgĂȂƂ܂Ȃ
	m_bOwnerDraw = true;	//	OnɂȂRestoreĂ܂
	return 0;
}

//	ZJ_T[tF[X̐
LRESULT CFastPlane::CreateSecondary(CFastPlane*lpPrimary,bool& bUseFlip){
	Release();
	ResetColorKey();

	LPDIRECTDRAW lpDraw = GetMyFastDraw()->GetDDraw();
	if (lpDraw==NULL) return 1;

	//	flip[`IT|[gI
sur_retry: ;
	if (bUseFlip) {
		// flipgȏAVXeɃobt@mۂ̂͂܂DDD
		DDSCAPS ddscaps;		
		ZERO(ddscaps);	//	Ȃǈꉞ
		if (m_bUseSystemMemory) {
			ddscaps.dwCaps = DDSCAPS_BACKBUFFER | DDSCAPS_SYSTEMMEMORY;
		} else {
			ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
		}
		if (lpPrimary->GetSurface()->GetAttachedSurface(&ddscaps,&m_lpSurface)!=DD_OK){
			Err.Out("CFastPlane::CreateSecondaryGetAttachedSurfaceɎs");
			// ق₩猾񂱂ȂI
			bUseFlip = false;
			goto sur_retry;
		}
		lpPrimary->GetSize(m_nSizeX,m_nSizeY);
		//	ꉞNAƂ...
		Clear();
		//	T[tF[X̃`FbNXV
		UpdateSurfaceInfo();
	} else {
		int nSizeX,nSizeY;
		lpPrimary->GetSize(nSizeX,nSizeY);
		if (InnerCreateSurface(nSizeX,nSizeY)!=0){
			Err.Out("CFastPlane::CreateSecondaryɎs");
			return 0;
		}
		//	UpdateCleaŕAInnerCreateSurfaceʓ|
	}

	//	̃T[tF[Xɑ΂ĂAJ[L[͐ݒ肵ƂDD
	UpdateColorKey();

//	m_nSurfaceRef = 1;		//	QƃJEgĂȂƂ܂Ȃ
	m_bOwnerDraw = true;
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//	VT[tF[XƂɂ́Å֐ĂяoƁI
LRESULT	CFastPlane::UpdateSurfaceInfo(){
	int nSurfaceType = CDirectDrawSurfaceManager().GetSurfaceType(GetSurface());

	//	ۂLockƂKvł
	DDSURFACEDESC ddsd = { sizeof (ddsd) };
	LRESULT hres;
	ddsd.dwSize = sizeof(ddsd);
	while ((hres = GetSurface()->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
		;
	SIZE rc = { m_nSizeX,m_nSizeY };

	if (hres != DD_OK) {
		if (IsPrimarySurface()){
			//	primarym
			GetSurfaceInfo()->Init(NULL,0,rc,nSurfaceType);
			///	primarýALockɎs邱Ƃ邩珉łƂɂႢ
			GetSurfaceInfo()->SetLocker(smart_ptr<ISurfaceLocker>(new IDisableSurfaceLocker));
			///	SurfaceLock͕Ks悤ɂƂȂĂ͂
		} else {
			//	primaryłȂ̂locks_
			GetSurfaceInfo()->SetInit(false);
		}
		return 1;	//	LockɎs
	}
	GetSurfaceInfo()->Init(ddsd.lpSurface,ddsd.lPitch,rc,nSurfaceType);
	//	AhX肷邽߂ɁAꂪKv

	//	unlockYƑςȂƂɁOOG
	GetSurface()->Unlock(NULL);

	return 0;
}

LPDIRECTDRAWSURFACE CFastPlane::GetSurface(){
	return m_lpSurface;
}

LPDIRECTDRAWPALETTE CFastPlane::GetPalette(){
	return m_lpPalette;
}


LRESULT CFastPlane::SetSystemMemoryUse(bool bEnable){
	m_bUseSystemMemory = bEnable;
	return 0;
}

//////////////////////////////////////////////////////////////////////////////

/*
LRESULT		CFastPlane::SetFillColor(ISurfaceRGB c){
	if (m_lpSurface==NULL) return -1;
	m_FillColor = c;
	return GetSurfaceInfo()->GetMatchColor(c,m_dwFillColor);
}

ISurfaceRGB		CFastPlane::GetFillColor() const {
	return m_FillColor;
}
*/

//////////////////////////////////////////////////////////////////////////////
// todo
// fBXvC̐F𒲂ׂ̂GetDisplayMode͎gĂ͂Ȃ
/*
int		CFastPlane::GetBpp(){
	return CBppManager::GetBpp();
}

void	CFastPlane::InnerGetBpp() {
	CBppManager::Reset();
}
*/

//////////////////////////////////////////////////////////////////////////////

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif // USE_DirectDraw
