//
//	yaneGraphicLoader.h
//
//		BMP,JPEG,GIF,...KvɉSusie-Plug inIɓǂݍރNX
//		programmed by yaneurao(M.Isozaki)	'00/05/15
//		reprogrammed by yaneurao(M.Isozaki) '00/06/21
//
//			SPIǂݍݕ̃Tv\[XAɂ邳ɊӁI
//
//		ygaǂݍ݂ɂΉ '02/07/25
//

#ifndef __yaneGraphicLoader_h__
#define __yaneGraphicLoader_h__


#include <olectl.h>	//	IPicture

#include "../Auxiliary/yaneFile.h"

///////////////////////////////////////////////////////////////////////////

namespace yaneuraoGameSDK3rd {
namespace Draw {

class CGraphicLoader;
class CSurfaceInfo;

class IGraphicLoader {
public:
	virtual LRESULT LoadPicture(const CFile& file)=0;
	virtual LRESULT GetSize(LONG& x,LONG& y) const=0;
	virtual LRESULT IsYGA() const = 0;

//	virtual LRESULT Render(DWORD* p,LONG lPitch)=0;
	virtual LRESULT Render(CSurfaceInfo*pInfo)=0;
	virtual LRESULT	Render(HDC hdc)=0;
	virtual LRESULT	ReleasePicture()=0;
	virtual LRESULT	GetPalette(PALETTEENTRY pal[256])=0;
	virtual ~IGraphicLoader(){}

	//	Ђ[B傦`OOG
	static factory_permutation_i<IGraphicLoader,CGraphicLoader>* GetGraphicFactory() { return& m_factory; }
private:
	static factory_permutation_i<IGraphicLoader,CGraphicLoader> m_factory;
};

class CGraphicLoader : public IGraphicLoader {
public:
	virtual LRESULT LoadPicture(const CFile& file);		///	œǂݍޕԂl0Ȃΐ

	virtual LRESULT GetSize(LONG& x,LONG& y) const;		///	œǂݍ񂾉摜̃TCY擾

	virtual LRESULT IsYGA() const;
	///	ǂݍ񂾉摜AT[tF[XȂ̂Ԃ

	virtual LRESULT Render(CSurfaceInfo*pInfo);
	///	CSurfaceInfonāAɕ`悵Ă炤

	virtual LRESULT	Render(HDC hdc);					///	hdcnāAɕ`悵Ă炤
	virtual LRESULT	ReleasePicture();					///	ŉ

	virtual LRESULT	GetPalette(PALETTEENTRY pal[256]);	///	pbg̎擾

	static LRESULT	ClearPalette(BITMAPINFO* pBI);
	/**
		BITMAPINFO8bppbmp킷Ȃ΁Ǎiɂ
		RGBQUADB
	*/

	/**
		SPI(susie plug-in)̌path̐ݒ^擾
		defaultł"spi"itH_j
		āAjpgǂݍނƂ́A"spi/ifjpg.spi"Ƃ
		vOCTɍsB
	*/
	static	void SetSPIPath(const string& strPath) { m_strSPIPath = strPath; }
	static	string GetSPIPath() { return m_strSPIPath; }

	//	PrototypeFactoryŖIɍĂˁOOG
	CGraphicLoader();
	virtual ~CGraphicLoader();

protected:

	virtual LRESULT LoadPictureByOwn1(const CFile& file);	//	bmp
	virtual LRESULT LoadPictureByOwn2(const CFile& file);	//	yga
	virtual LRESULT LoadPictureByOLE(const CFile& file);	//	jpeg,gif
	virtual LRESULT LoadPictureBySPI(const CFile& file);	//	using by SPI

	//	for LoadPictureByOwn
	BITMAPFILEHEADER*	m_lpBF;
	BITMAPINFOHEADER*	m_lpBI;
	void*				m_lpBits;

	//	for Load YGA Image By Own
	bool	m_bYGA;			//	ǂݍ񂾂̂yga摜Ȃ̂H
	int		m_nYGA_Xsize;	//	yga摜xTCY
	int		m_nYGA_Ysize;	//	yga摜yTCY

	///	renderinǵAIɌĂяo
	virtual LRESULT InnerRenderBmp(CSurfaceInfo*pInfo);	// BMPRender
	virtual LRESULT InnerRenderYga(CSurfaceInfo*pInfo);	// YGARender

///////////////////////////////////////////////////////////////////////////

	//	for OLELoadPicture
	IPicture*	m_lpiPicture;

	//	for SPI
///////////////////////////////////////////////////////////////////////////
typedef struct SpiPictureInfo {
	long left,top;					//	摜WJʒu
	long width;						//	摜̕(pixel)
	long height;					//	摜̍(pixel)
	WORD x_density;					//	f̐x
	WORD y_density;					//	f̐x
	short colorDepth;				//	Pfbit
	HLOCAL hInfo;					//	摜̃eLXg
} SpiPictureInfo, *LPSpiPictureInfo;

typedef	int (PASCAL *SpiFuncIsSupported)(LPSTR, DWORD);
typedef	int (PASCAL *SpiFuncGetPictureInfo)(LPSTR, long, unsigned int, SpiPictureInfo*);
typedef	int (PASCAL *SpiFuncGetPicture)(LPSTR, long, unsigned int, HLOCAL*, HLOCAL*, FARPROC, long);

///////////////////////////////////////////////////////////////////////////

	HMODULE		m_hDLL;
	SpiFuncIsSupported		m_pIsSupported;
	SpiFuncGetPictureInfo	m_pGetPictureInfo;
	SpiFuncGetPicture		m_pGetPicture;
	static string		m_strSPIPath;	//	SPǏpX@default:"SPI"
	struct CSPIPathInitializer {
		CSPIPathInitializer() { CGraphicLoader::m_strSPIPath = "SPI"; }
	};
	friend struct CSPIPathInitializer;
	static CSPIPathInitializer spi_initializer;
	///	SPIpath邽߂̃NXRXgN^

	const CFile*		m_lpFile;
	const CFile*	GetFile() const { return m_lpFile; }

	HLOCAL		m_hBm;
	HLOCAL		m_hBmInfo;
	virtual void	FreeLocalMemory();
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif
