#include "stdafx.h"
#include "yanePlaneLoader.h"

//////////////////////////////////////////////////////////////////////////////

namespace yaneuraoGameSDK3rd {
namespace Draw {

CPlaneLoader::CPlaneLoader()
{
	SetColorKey(ISurface::makeRGB(0,255,0));
	SetFactory(CPlane::GetFactory());	//	defaultfactoryݒ
}

/*smart_ptr<ISurface>*/
CPlane CPlaneLoader::GetPlane(int nNo){		///	v[̎擾

	Load(nNo);

	smart_obj obj;
	if (GetIDObjectManager()->getObject(nNo,obj)!=0){
		//	ꂪȂƂ͖͂..
		return CPlane(new CSurfaceNullDevice);
	}

	smart_ptr<ISurface> p(
		smart_ptr_static_cast<ISurface>(smart_ptr_static_cast<CLoadCacheInfo>(obj)->pObj)
	);
	if (IsRGBColorKey()){
		p->SetColorKey(GetColorKey());
	} else {
		p->SetColorKeyPos(m_nColorKeyPosX,m_nColorKeyPosY);
	}
	return CPlane(p);
}

///	nNõt@C擾
string	CPlaneLoader::GetFileName(int nNo){

	smart_obj obj;
	if (GetIDObjectManager()->getObject(nNo,obj)!=0){
		//	ꂪȂƂ͖͂..
		return "";
	}

	return (smart_ptr_static_cast<CLoadCacheInfo>(obj))->strFileName;
}

//////////////////////////////////////////////////////////////////////////////

LRESULT		CPlaneLoader::InnerLoad(const smart_obj& obj){

	CLoadCacheInfo& info = *smart_ptr_static_cast<CLoadCacheInfo>(obj);

	string strFileName(info.strFileName);

	info.pObj.Add(GetFactory()->CreateInstance());
	LRESULT lr = smart_ptr_static_cast<ISurface>(info.pObj)->Load(strFileName);

	//	G[[hȂ΁ANullDeviceԂ
	if (lr!=0){
		info.pObj.Add(new CSurfaceNullDevice);
	}

	return lr;
}

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd
