// yaneJoyStick.h
//	 This is a JoyStick input wrapper.
//		programmed by yaneurao(M.Isozaki) '99/08/16

#ifndef __yaneJoyStick_h__
#define __yaneJoyStick_h__


#ifdef USE_JOYSTICK

#include "yaneKeyBase.h"

namespace yaneuraoGameSDK3rd {
namespace Input {

class IJoyStick : public IKeyBase {
/// IJoyStick IKeyBaseJoyStick
public:
	///	from CKeyBase
///	virtual LRESULT Input()=0; // 256oCgԂǂݍ
///	virtual bool	IsKeyPress(int key) const;
///	virtual bool	IsKeyPush(int key) const;
///	virtual const BYTE*	GetKeyData() const;

	virtual LRESULT	SelectDevice(int n)=0;
	///	foCX̃io[w(0-15)
	///	̃foCX̏ɎsALRESULT͔OԂ

	///	for JoyStick setting
	virtual LRESULT	SetButtonMax(int max)=0;
	virtual int		GetButtonMax() const=0;
	///	joy stick̃{^̐ݒ擾B
	///	Őݒ肵{^܂ŔFBdefault:ő6{^B
	/**
		̃{^̐ݒ́ASelectDeviceĐƂ̂ݗL
		default : 6{^
	*/

	virtual bool	IsInit() const=0;
	/**
		foCX̏ɐH
	*/
};

class CJoyStickNullDevice : public IJoyStick {
/**
	JoyStickpNull Device
	class CJoyStick Ŏgp
*/
public:
	virtual LRESULT Input() { return 0; }
	virtual bool	IsKeyPress(int key) const{ return false;}
	virtual bool	IsKeyPush(int key) const{ return false; }
	virtual LRESULT	SelectDevice(int n) { return 0; }
	virtual LRESULT	SetButtonMax(int max) { return 0; }
	virtual int		GetButtonMax() const { return 0; }
	virtual bool	IsInit() const { return true; }
};

class CWIN32JoyStick : public IJoyStick	 {
///	Win32joy stick͂sȂwrapper
public:
	virtual LRESULT Input(); // 256oCgԂǂݍ

	virtual LRESULT	SelectDevice(int n);
	///	foCX̃io[w(0-1)	default : 0
	///	̃foCX̏ɎsALRESULT͔OԂ

	///	for JoyStick setting
	virtual LRESULT	SetButtonMax(int max);
	virtual int		GetButtonMax()const		{ return m_nButtonMax; }
	/**
		̃{^̐ݒ́ASelectDeviceĐƂ̂ݗL
		default : 6{^
	*/

	virtual bool	IsInit() const { return m_bSuccessInit;}
	/**
		foCX̏ɐH
	*/

	CWIN32JoyStick();

protected:

	bool	m_bSuccessInit;				//	ɐ̂
	UINT	m_uID;						//	JOYSTICK1 or JOYSTICK2
	int		m_nButtonMax;				//	{^ő吔(fBtHg2)

	UINT	m_uX1,m_uX2;				//	͕~l
	UINT	m_uY1,m_uY2;

	int		m_nSelect;					//	JOYSTICK selector
	
};

class CJoyStick : public IJoyStick {
/**

*/
public:
	///	from IKeyBase
	virtual LRESULT Input(); /// 256oCgԂǂݍ
	virtual bool	IsKeyPress(int key) const;
	virtual bool	IsKeyPush(int key) const;
	virtual const BYTE*	GetKeyData() const;
	/**
		͂́AIsPushKey/IsPressKeÿ0,1,2,3㉺EB
		̂4`35A{^1`32iőjɑΉB
	*/

	virtual LRESULT	SelectDevice(int n);
	///	foCX̃io[w(0-15)
	///	̃foCX̏ɎsALRESULTfalseԂ
	/**
		́ADirectInputpȂƂDirectX5̃CXg[Ă
		ȂWin32API16{܂JoyStickFłB
	*/

	//	for JoyStick setting
	virtual LRESULT	SetButtonMax(int max);
	virtual int		GetButtonMax()const;
	/**
		mő{^ݒB0`32Bdefault : 6 {^
		̃{^̐ݒ́ASelectDeviceĐƂ̂ݗL
	*/

	virtual bool	IsInit() const;

	CJoyStick();

protected:
	smart_ptr<IJoyStick>	m_pJoyStick;
	smart_ptr<IJoyStick> GetJoyStick() const { return m_pJoyStick; }
	void	SetNullDevice();	//	JoyStickNullDeviceݒ肷
};

} // end of namespace Input
} // end of namespace yaneuraoGameSDK3rd

#endif // #ifdef USE_JOYSTICK
#endif
