#include "stdafx.h"
#include "yaneMouse.h"
#include "../AppFrame/yaneAppManager.h"

namespace yaneuraoGameSDK3rd {
namespace Input {

CMouse::CMouse(){
	m_bOutScreenInput = false;
	m_bRB = false;
	m_bLB = false;
	m_bMB = false;
	m_bHistRB = false;
	m_bHistLB = false;
	m_bHistMB = false;
	CAppManager::Hook(this);		//	WindowMessageHook
	m_InteliiWheelMsg = (((GetVersion() & 0x80000000) && LOBYTE(LOWORD(GetVersion())) == 4) ||
						(!(GetVersion() & 0x80000000) && LOBYTE(LOWORD(GetVersion())) == 3))
						? RegisterWindowMessage("MSWHEEL_ROLLMSG") : 0;
}

CMouse::~CMouse(){
	CAppManager::Unhook(this);		//	WindowMessageUnhook
}

//////////////////////////////////////////////////////////////////////////////
LRESULT	CMouse::GetXY(int &x,int &y) const {
	POINT point,point2 = { 0,0 };
	::GetCursorPos(&point);

	if (CAppManager::IsFullScreen()) {
	//	tXN[[hł͌ĂȂEBhDLvV̉e
	//	R̈ʒuɂȂĂ܂̂ŁÂ܂ܕԂĂΗǂB
		x = point.x;
		y = point.y;
	} else {
		HWND hWnd = CAppManager::GetHWnd();
		::ClientToScreen(hWnd,&point2);
		x = point.x - point2.x;
		y = point.y - point2.y;

		if (!m_bOutScreenInput) {
			//	EBhD͈͊Oł΁A{^̓Zbg
			::ScreenToClient(hWnd,&point);// NCAgWɕϊ
			RECT rt;
			::GetClientRect(hWnd,&rt);// NCAg̈擾
			// ͈͊OȂ}EXԏ
			if(point.x<0 || rt.right<=point.x || point.y<0 || rt.bottom<=point.y) {
				//	const_cast fake
				*const_cast<bool*>(&m_bLB) = false;
				*const_cast<bool*>(&m_bRB) = false;
			}
		}
		
	}
	return 0;
}

LRESULT CMouse::GetZ(int &z) const {
	z = m_nZ;
	m_nZ = 0;
	return 0;
}

LRESULT CMouse::SetXY(int x,int y) {
	POINT point,point2 = { 0,0 };

	if (CAppManager::IsFullScreen()) {
		point.x=x;
		point.y=y;
		::SetCursorPos(point.x,point.y);
	} else {
		::ClientToScreen(CAppManager::GetHWnd(),&point2);
		point.x= x + point2.x;
		point.y= y + point2.y;
		::SetCursorPos(point.x,point.y);
	}
	return 0;
}

LRESULT CMouse::GetInfo(int &x,int &y,int &b) const {	// }EX|WVƃ{^ԂԂ
	CMouse::GetXY(x,y);	//	virtual֐ĂяoꂯĂ͉ȂȂ

	b = 0;
	if (m_bRB) b++;		//	{^BENbNȂ1
	if (m_bLB) b+=2;	//	{^BNbNȂ2
	if (m_bMB) b+=4;	//	{^BNbNȂ4

	return 0;
}

bool CMouse::RButton() const {
	return m_bRB;
}

bool CMouse::LButton() const {
	return m_bLB;
}

bool CMouse::MButton() const {
	return m_bMB;
}
void CMouse::SetOutScreenInput(bool bEnable) { m_bOutScreenInput=bEnable;}

//////////////////////////////////////////////////////////////////////////////

void	CMouse::GetButton(bool&bL,bool&bR,bool&bM){
	bL = !m_bHistLB && m_bLB;
	bR = !m_bHistRB && m_bRB;
	bM = !m_bHistMB && m_bMB;
	m_bHistLB = m_bLB;
	m_bHistRB = m_bRB;
	m_bHistMB = m_bMB;
}

void	CMouse::ResetButton(){
	m_bHistRB = false;
	m_bHistLB = false;
	m_bHistMB = false;
}

//////////////////////////////////////////////////////////////////////////////
// bZ[WtbNȂƃ}EX̃{^Ԃ킩Ƃ...
LRESULT CMouse::WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){ // bZ[W̃R[obN

	if(uMsg==m_InteliiWheelMsg){
		uMsg = WM_MOUSEWHEEL;
	}

	switch(uMsg){
	/*
		܂܉ʊOɏoƂɁAǂ̂H
		(ʊOłWM_MOUSEMOVEbZ[W͂ėȂ̂..)
		WM_NCBUTTONUP͂ĂH@˂ėȂ݂(_G)
	*/

	case WM_LBUTTONDOWN:
		m_bLB = true; break;
	case WM_LBUTTONUP:
		m_bLB = false; break;
	case WM_RBUTTONDOWN:
		m_bRB = true; break;
	case WM_RBUTTONUP:
		m_bRB = false; break;
	case WM_MBUTTONDOWN:
		m_bMB = true; break;
	case WM_MBUTTONUP:
		m_bMB = false; break;

	case WM_MOUSEMOVE:
		m_bLB = (wParam & MK_LBUTTON)!=0;
		m_bRB = (wParam & MK_RBUTTON)!=0;
		break;
	case WM_MOUSEWHEEL:
		m_nZ = (short)HIWORD(wParam);
		break;
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////////////

CFixMouse::CFixMouse(){
	m_bRBN = false;
	m_bLBN = false;
	m_bMBN = false;
	m_bHistRB = false;
	m_bHistLB = false;
	m_bHistMB = false;
	m_nRLMBN = 0;
	m_nX = m_nY = m_nZ = 0;
	m_nGuardTime = 2;
}

CFixMouse::~CFixMouse(){
}

LRESULT	CFixMouse::Flush(){
	if (m_nGuardTime!=0) m_nGuardTime--;

	m_bHistLB = m_bLBN;
	m_bHistRB = m_bRBN;
	m_bHistMB = m_bMBN;

	GetMouse()->GetZ(m_nZ);
	if (GetMouse()->GetInfo(m_nX,m_nY,m_nRLMBN)!=0) {
		m_bRBN = m_bLBN = m_bMBN = false;
		return 1;
	}
	m_bRBN = (m_nRLMBN&1)!=0;
	m_bLBN = (m_nRLMBN&2)!=0;
	m_bMBN = (m_nRLMBN&4)!=0;

	return 0;
}

LRESULT CFixMouse::GetXY(int &x,int &y)const{
	x = m_nX;
	y = m_nY;
	return 0;
}

LRESULT CFixMouse::GetZ(int &z)const{
	z = m_nZ;
	return 0;
}

LRESULT CFixMouse::SetXY(int x,int y){
					//	}EXw̃|WVɈړiNCAgWnɂāj
	m_nX = x; m_nY = y;	//	܂XVOOG
	return GetMouse()->SetXY(x,y);
}

bool	CFixMouse::RButton()const{
	return m_bRBN;
}

bool	CFixMouse::LButton()const{
	return m_bLBN;
}

bool	CFixMouse::MButton()const{
	return m_bMBN;
}

LRESULT CFixMouse::GetInfo(int &x,int &y,int &b)const{
	x = m_nX;
	y = m_nY;
	b = m_nRLMBN;
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//	OFlush牟ꂽH

void	CFixMouse::GetButton(bool&bL,bool&bR,bool&bM){
	bR = !m_bHistRB && m_bRBN;
	bL = !m_bHistLB && m_bLBN;
	bM = !m_bHistMB && m_bMBN;
}
bool	CFixMouse::IsPushRButton() const{
	return !m_bHistRB && m_bRBN && (m_nGuardTime==0);
}
bool	CFixMouse::IsPushLButton() const{
	return !m_bHistLB && m_bLBN && (m_nGuardTime==0);
}
bool	CFixMouse::IsPushMButton() const{
	return !m_bHistMB && m_bMBN && (m_nGuardTime==0);
}

/////////////////////////////////////////////////////////////////////////////
//	OFlush牟グꂽH

void	CFixMouse::GetUpButton(bool&bL,bool&bR,bool&bM){
	bR = m_bHistRB && !m_bRBN;
	bL = m_bHistLB && !m_bLBN;
	bM = m_bHistMB && !m_bMBN;

}
bool	CFixMouse::IsPushUpRButton()const{
	return m_bHistRB && !m_bRBN && (m_nGuardTime==0);
}
bool	CFixMouse::IsPushUpLButton()const{
	return m_bHistLB && !m_bLBN && (m_nGuardTime==0);
}
bool	CFixMouse::IsPushUpMButton()const{
	return m_bHistMB && !m_bMBN && (m_nGuardTime==0);
}

/////////////////////////////////////////////////////////////////////////////

void	CFixMouse::ResetButton(){
	m_bHistRB = m_bRBN = false;
	m_bHistLB = m_bLBN = false;
	m_bHistMB = m_bMBN = false;
}

void	CFixMouse::SetGuardTime(int nTime){
	m_nGuardTime = nTime;
}

bool	CFixMouse::IsGuardTime() const {
	return m_nGuardTime!=0;
}

} // end of namespace Input
} // end of namespace yaneuraoGameSDK3rd
