//	yaneAudioMix.h : EF[uI[fBI~LT
//
//		programmed by yaneurao '00/02/28
//

#ifndef __yaneAudioMixer_h__
#define __yaneAudioMixer_h__


namespace yaneuraoGameSDK3rd {
namespace Multimedia {

enum eAudioMix {
AUDIO_MIX_MASTER,	// }X^[H[
AUDIO_MIX_WAVE,		// WAVEH[
AUDIO_MIX_MIDI,		// MIDIo̓H[
AUDIO_MIX_CD		// CDĐH[
};

class IAudioMixer {
public:
	virtual LRESULT SetVolumeRel(eAudioMix eDevice,double dRelVolume)=0;
	virtual LRESULT SetVolumeAbs(eAudioMix eDevice,const vector<DWORD>& adwVol)=0;
	virtual LRESULT SetVolumeOrg(eAudioMix eDevice)=0;
	virtual LRESULT GetVolumeRel(eAudioMix eDevice,double &dRelVolume)const=0;
	virtual LRESULT GetVolumeAbs(eAudioMix eDevice,vector<DWORD>& adwVol)const=0;
	virtual LRESULT	GetVolumeOrg(eAudioMix eDevice,vector<DWORD>& adwVol)const=0;
	virtual	LRESULT	RestoreVolume(eAudioMix eDevice)=0;

	virtual ~IAudioMixer(){}
};

class CAudioMixer : public IAudioMixer {
/**
	I[fBĨ~LVOpBMIDIACDAWAVẼ~LVO𒼐ڕύXB
	~LVORg[̂ŁA̋@킩璼ڃXs[J[
	o͂Ăꍇ͖ӖłB

	class CVolumeFader QƂ邱ƁB

	΃H[́AliCAudioMixer̃RXgNg
	_ł̒lj̑ΎwƂȂ܂B
	lȂ1(100%)̂Q{Ȃ2(200%)AOȂΖʁB
*/
public:
	virtual LRESULT SetVolumeRel(eAudioMix eDevice,double dRelVolume);
	///	΃{[ݒ

	virtual LRESULT SetVolumeAbs(eAudioMix eDevice,const vector<DWORD>& adwVol);
	///	΃{[ݒ

	virtual LRESULT SetVolumeOrg(eAudioMix eDevice);
	///	{[ɐݒ

	virtual LRESULT GetVolumeRel(eAudioMix eDevice,double &dRelVolume)const;
	///	΃{[擾

	virtual LRESULT GetVolumeAbs(eAudioMix eDevice,vector<DWORD>& adwVol)const;
	///	΃{[擾

	virtual LRESULT	GetVolumeOrg(eAudioMix eDevice,vector<DWORD>& adwVol)const;
	///	{[擾

	virtual	LRESULT	RestoreVolume(eAudioMix eDevice);
	///	݂̃{[ݒAu{[ݒvɕۑ

	bool	IsSuccessInit() const { return m_bSuccessInit; }
	///	ɐH

	CAudioMixer();
	virtual ~CAudioMixer();

protected:
	DWORD	m_dwVol;				//	݂̃{[ݒ
	LONG	m_lPan;					//	݂̃pݒ

private:
	struct CAudioInfo {
		bool			m_bAudioComponent;		//	R|[lgT|[gĂ邩ۂ̃tO
		vector<DWORD>	m_dwOriginalVol;		//	̃{[ݒ(`l)
		CAudioInfo() :m_bAudioComponent(false) {}
	};
	CAudioInfo	m_vAudioInfo[4];
	CAudioInfo* GetAudioInfo() { return& m_vAudioInfo[0]; }

	HMIXER		m_hMixer;			//	~LTfoCX̃nh

	UINT		m_MixerID;			//	Lȃ~LTfoCX̎ʎq
	
	MIXERCAPS	m_MixerCaps;		//	~LTfoCX\
	
	MIXERLINE	m_MixerLine[4];		//	4AudioMixɑ΂Line(Ԃenum)
	//	I[fBICԂƃgbNX񂪓\
	
	MIXERCONTROL		m_MixerControl;
	//	I[fBICRg[̃Xe[^XƃgbNX񂪓\

	MIXERLINECONTROLS	m_MixerLineControl;
	//	I[fBIC̃Rg[񂪓\

	MIXERCONTROLDETAILS	m_MCD;
	//	~LTRg[̏ԏ\

	smart_ptr<MIXERCONTROLDETAILS_UNSIGNED>	m_MCD_UnSigned;
	//	~LTRg[̃vpeB擾Aݒł\

protected:
	LRESULT	Open();
	LRESULT Close();

	LRESULT	GetMixerLineControl( int iLineID );		//	Detail̎擾˂B̊֐ɈϏ
	LRESULT GetMixerLineControl(MIXERLINE& ml);		//	炪{OOG
	LRESULT	SetMixerControlDetails( int iLineID, bool bMono );

private:
	LRESULT	GetMixerDev();
	void	ErrAudioMixer( MMRESULT AMErr, LPCSTR strBuf );
	bool	m_bSuccessInit;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif
