
#include "stdafx.h"

#include "yaneMIDIOutputMCI.h"
#include "../Auxiliary/yaneFile.h"
#include "../AppFrame/yaneAppManager.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

namespace {
inline int sign(int val) { return val>0?1:(val<0?-1:0); }	//	Ԃ * yane
}

bool CMIDIOutputMCI::CanUseMCIMIDI() {
	//	DirectMusicgȂ̂ǂ𒲂ׂĕԂ
	static bool bFirst = true;
	static bool bUse   = false;

	if (bFirst){	//	ŏ̂P̂ݒׂĕԂ
		bFirst = false;
		//	ɃI[vĂ݂
		HMIDIOUT hMidi;
		if (::midiOutOpen(&hMidi,MIDI_MAPPER,NULL,NULL,CALLBACK_NULL) == MMSYSERR_NOERROR){
			::midiOutClose(hMidi);
			bUse = true;
		}
	}
	return bUse;
}


////////////////
//	RXgN^EfXgN^
////////////////
CMIDIOutputMCI::CMIDIOutputMCI()
{
	m_wDeviceID = (DWORD)-1;	//	{wordȂ̂ŁA(DWORD)-1͂肦Ȃ
	m_bPaused = 0;
	m_bLoopPlay = false;
	m_bNowPlay = false;
	m_lLength = 0;
	CAppManager::Hook(this);		//	tbNJn
}

CMIDIOutputMCI::~CMIDIOutputMCI()
{
	Close();
	CAppManager::Unhook(this);		//	tbNB
}

////////////////
//	I[v
///////////////
LRESULT CMIDIOutputMCI::Open(const string& sName)
{
	Close();

	//	̃t@Cǂݍ
	if (m_File.Read(sName)!=0) {
		Err.Out("CMIDIOutputMCI::Openœǂݍރt@C %s", sName.c_str());
		return 1;
	}

	if (m_File.CreateTemporary()!=0) {
		Err.Out("CMIDIOutputMCI::OpenCreateTemporaryɎs");
		return 2;
	}

	return 0;
}

LRESULT	CMIDIOutputMCI::InnerOpen(){	//	MCII[v
	if (m_wDeviceID!=-1) return 0;	//	openς

	//	o̓t@CłlhchfoCXI[v
	DWORD	dwOpenFlags = MCI_OPEN_TYPE | MCI_OPEN_TYPE_ID | MCI_OPEN_ELEMENT;
	MCI_OPEN_PARMS open;
	ZERO(open);
	open.lpstrDeviceType = (LPTSTR)MCI_DEVTYPE_SEQUENCER;
//	open.lpstrElementName = (LPTSTR)(CFile::MakeFullName(m_File.GetName()).c_str());
	//	ł̓e|IuWFNgłOOG
	string s;
	s = CFile::MakeFullName(m_File.GetName());
	open.lpstrElementName = (LPTSTR)(s.c_str());

	if (::mciSendCommand(0, MCI_OPEN, dwOpenFlags, (DWORD)&open)) {
		Err.Out("CMIDIOutput::MIDIfoCXI[vłȂB");
		return 1;
	}

	m_wDeviceID = open.wDeviceID;

	// Pʂmsɂ '01/04/09 add kaine
	MCI_SET_PARMS set;
	set.dwTimeFormat = MCI_FORMAT_MILLISECONDS;
	mciSendCommand(m_wDeviceID, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD)(LPVOID)&set);

	return 0;
}

//////////
//	N[Y
//////////
LRESULT CMIDIOutputMCI::Close()
{
	m_File.Close();	//	delete temporary file
	if (m_wDeviceID == -1) return 0; // not opened
	if (m_bNowPlay) Stop();	// stopȂClosełȂ[

	if (::mciSendCommand(m_wDeviceID, MCI_CLOSE, 0, (DWORD)NULL)) {
		Err.Out("CMIDIOutput::MIDIfoCXN[YłȂB");
		return 1;
	}

	m_wDeviceID = (DWORD)-1;
	m_dwPosition = 0;
	return 0;
}

//////////
//	t
/////////

LRESULT CMIDIOutputMCI::Play()
{
	m_bPaused = 0;
	if (InnerOpen()!=0) return 1;

	Stop();
	//	ĐJn
	MCI_PLAY_PARMS play;
	play.dwFrom = 0;
	play.dwCallback = (DWORD)CAppManager::GetHWnd();
	if (mciSendCommand(m_wDeviceID, MCI_PLAY, MCI_FROM|MCI_NOTIFY,(DWORD)&play)) {
		return 2;
	}
	m_bNowPlay = true;
	return 0;
}

LRESULT CMIDIOutputMCI::Replay()
{
	if (m_bPaused==0) return 0;		//	pauseĂւāI
	if (--m_bPaused!=0) return 0;	//	QƃJEg

	if (m_wDeviceID == -1) return 1;	//	I[vĂȂI
	if (InnerOpen()!=0) return 1;

	//	ȂĐȂ̂ŉɋA
	if (IsPlay()) return 0;

	//	ĐĊJ
	MCI_PLAY_PARMS play;
	play.dwFrom = m_dwPosition;
	play.dwCallback = (DWORD)CAppManager::GetHWnd();
	if (::mciSendCommand(m_wDeviceID, MCI_PLAY, MCI_FROM|MCI_NOTIFY,(DWORD)&play)) {
		return 2;
	}
	m_bPaused = 0;
	m_bNowPlay = true;
	return 0;
}

LRESULT CMIDIOutputMCI::Stop()
{
	m_bPaused += sign(m_bPaused);	//	KEZ:p
	if (m_wDeviceID == -1) return 1;	//	not open
	if (!IsPlay()) return 0;			//	łɒ~Ă

	//	Đ̂pauseȂ
	m_bPaused = 1;

	//	ݏԓǂݏoĒ~
	MCI_STATUS_PARMS status;
	ZERO(status);
	status.dwItem = MCI_STATUS_POSITION;
	if (::mciSendCommand(m_wDeviceID, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)&status)) {
		Err.Out("CMIDIOutput::MIDIfoCXXe[^XǂݏoȂB");
		m_dwPosition = 0;
		if (::mciSendCommand(m_wDeviceID, MCI_STOP, 0, (DWORD)NULL)) {
			Err.Out("CMIDIOutput::MIDIfoCX~łȂB");
		}
		return 2;
	}
	m_dwPosition = status.dwReturn;
	if (::mciSendCommand(m_wDeviceID, MCI_STOP, 0, (DWORD)NULL)) {
		Err.Out("CMIDIOutput::MIDIfoCX~łȂB");
		return 2;
	}
	m_bNowPlay = false;
	return 0;
}


LONG	CMIDIOutputMCI::GetCurrentPos() const {
	if (m_wDeviceID == -1) return -1;

	// ݂̍Đ|WV𓾂
	MCI_STATUS_PARMS status;
	status.dwItem = MCI_STATUS_POSITION;
	if (mciSendCommand(m_wDeviceID,MCI_STATUS,MCI_STATUS_ITEM,(DWORD)&status)){
		Err.Out("CMIDIOutputMCI::GetCurrentPosMCI_STATUS(MCI_STATUS_POSITION)Ɏs");
		return -1;	// G[
	}
//	return status.dwReturn * 100; // .1bPʂŎ擾ł
	return status.dwReturn; // [ms]PʂŎ擾ł
}

LRESULT CMIDIOutputMCI::SetCurrentPos(LONG lPos){	// [ms]
	if ( m_wDeviceID == -1) return -1;

	MCI_SEEK_PARMS seek;
	seek.dwTo = lPos;
	seek.dwCallback = (DWORD) (DWORD)CAppManager::GetHWnd();
	if ( mciSendCommand(m_wDeviceID,MCI_SEEK, MCI_TO|MCI_WAIT , (DWORD)&seek)){
		Err.Out("Err SetCurrentPos");
		return -1;
	}

	if ( m_bNowPlay ){
		MCI_PLAY_PARMS play;
		play.dwCallback = (DWORD)CAppManager::GetHWnd();
		if (mciSendCommand(m_wDeviceID, MCI_PLAY, MCI_NOTIFY,(DWORD)&play)) {
			return 2;
		}
	}

	return 0;
}

LRESULT CMIDIOutputMCI::SetLoopPlay(bool bLoop){
	m_bLoopPlay = bLoop;
	return 0;
}

bool CMIDIOutputMCI::IsPlay() const {
	return m_bNowPlay;
}

LRESULT	CMIDIOutputMCI::LoopPlay(){
	if (m_bLoopPlay) {
		return Play();
	} else {
		return Stop();
	}
}

// add '01/04/09 kaine
LONG	CMIDIOutputMCI::GetLength() const {
	if (m_wDeviceID == -1) return -1;

	// 𓾂
	MCI_STATUS_PARMS status;
	status.dwItem = MCI_STATUS_LENGTH;
	if (mciSendCommand(m_wDeviceID,MCI_STATUS,MCI_STATUS_ITEM,(DWORD)&status)){
		Err.Out("CMIDIOutputMCI::GetCurrentPosMCI_STATUS(MCI_STATUS_LENGTH)Ɏs");
		return -1;	// G[
	}
	return status.dwReturn; // [ms]PʂŎ擾ł
}


//////////////////////////////////////////////////////////////////////////////

// WM_MCINOTIFY̒ʒm󂯎Kv
LRESULT CMIDIOutputMCI::WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	switch(uMsg){
	case MM_MCINOTIFY : {
		// ̃bZ[WCD̂񂩁H
		if (lParam!=(LPARAM)m_wDeviceID) return 0; // ႤI

		// StopŒ~Ƃ́AMCI_NOTIFY_ABORTED
		if (wParam==MCI_NOTIFY_SUCCESSFUL){
			LoopPlay();
			return 1;
		}
	}

	} // end switch

	return 0;
}

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd
