//
// yaneSound.h
//
//		MIDI,WAVEo͊NX
//

#ifndef __yaneSound_h__
#define __yaneSound_h__


namespace yaneuraoGameSDK3rd {
namespace Multimedia {

/////////////////////////////////////////////////////////////////////////////
class ISound {
/**
	MIDI,WAVEĐNX̃C^[tF[X
*/
public:
	virtual LRESULT Open(const string& strFileName) = 0;
	/// t@C̓ǂݍ

	virtual LRESULT Close() = 0;
	///	t@C

	virtual LRESULT Play()	= 0;
	///	Đ

	virtual LRESULT Pause() = 0;
	///	ꎞ~

	virtual LRESULT Replay() = 0;
	/// ꎞ~Ă̂ĊJ

	virtual LRESULT Stop()	= 0;
	/// ~

	virtual bool IsPlay() const	 = 0;
	/// ĐȂtrue

	virtual LRESULT SetLoopPlay(bool bLoop) = 0;
	/// [vĐ[hɂiIA擪ɖ߂čĐj

	virtual bool IsLoopPlay() const = 0;
	/// SetLoopPlayŃ[vĐ[hɐݒ肳ĂȂtrue

	virtual LRESULT	SetCurrentPos(LONG lPos) = 0;
	virtual LONG	GetCurrentPos() const = 0;
	/// ݂̍Đ|WVݒ^擾i[ms]Pʁj
	///	擾́AG[̂Ƃ̓}CiX̒lԂ

	virtual LONG	GetLength() const = 0;
	///	Ȃ̑S̒擾B([ms]P)

	virtual LRESULT SetVolume(LONG volume)=0;
	virtual LONG	GetVolume() const =0;
	/**
		H[ݒ^擾B(DSBVOLUME_MIN`DSBVOLUME_MAX̊Ԃ̒l
		w肷BDSBVOLUME_MINw肵Ƃ́A)@A
		ׂẴfoCXŁẢʒT|[gĂƂ͌ȂB
		Ƃ΁ACMIDIOutputDM̓T|[gĂ邪ACMIDIOutputMCÍA
		T|[gĂȂB
	*/

	virtual int	GetType() const = 0;
	/**
		RTTIǂBhNX̃^CvԂ
		0 : NullDevice
		1 : CMIDIOutputMCI
		2 : CMIDIOutputDM
		3 : CWaveStaticSound
		4 : CWaveStreamSound
		5 : CWaveSound
	*/

	virtual string	GetFileName() const = 0;
	/// ǂݍłt@CԂ

	virtual LRESULT ConvertToMealTime(LONG nPos,int&nHour,int&nMin,int&nSec,int&nMS);
	virtual LRESULT ConvertFromMealTime(LONG&nPos,int nHour,int nMin,int nSec,int nMS);
	/**
		GetCurrentPosœꂽnPos [ms] A(nHour,nMin,nSec,nMs)Ȃ킿A
		bтƂϊBтƂ̂́AȂȂPʂƎv܂
		1/1000ibj==1[ms]łBO҂[ms]ˎbсC҂́A
		bс[ms]łB
	*/

	virtual ~ISound() {}
};

class ISoundRestorable : public ISound {
/**
	Restore\Ȏ class ISound ݊C^[tF[X
*/
public:
	virtual LRESULT Restore() = 0;
	///	t@Cēǂݍ

	virtual ~ISoundRestorable() {}
};

class IWaveSound : public ISoundRestorable {
/**
	WAVEĐNX̃C^[tF[X
*/
public:
	virtual LRESULT Restore() = 0;	// Ē`Ȃlist_chain::for_eachRpCoȂ^^;
	///	t@Cēǂݍ

	virtual ~IWaveSound() {}
// ܂o͂Ȃ^^;
};

class CSoundNullDevice : public ISound {
/**
	ɌNULL DEVICE
	MIDI̕tĂȂł́AłAbvLXgĎgΗǂ
*/
public:
	virtual LRESULT Open(const string& sFileName) { return 0; }
	virtual LRESULT Close()	 { return 0; }
	virtual LRESULT Play()	 { return 0; }
	virtual LRESULT Replay() { return 0; }
	virtual LRESULT Stop()	 { return 0; }
	virtual LRESULT Pause()	 { return 0; }
	virtual bool IsPlay() const { return false; }
	virtual bool IsLoopPlay() const { return m_bLoop; }
	virtual LRESULT SetLoopPlay(bool bLoop) { m_bLoop=bLoop; return 0; }
	virtual LONG	GetCurrentPos() const { return -1; }
	virtual LRESULT	SetCurrentPos(LONG lPos) { return -1;}
	virtual LONG	GetLength() const { return -1;}
	virtual LRESULT SetVolume(LONG volume){ return -1;}
	virtual LONG	GetVolume() const { return DSBVOLUME_MIN;}
	virtual string	GetFileName() const { return ""; }
	virtual int	GetType() const { return 0; }

	CSoundNullDevice() : m_bLoop(false) {}

protected:
	bool m_bLoop;
};

class CProxySound : public ISound {
/**
	ISoundproxy object
*/
public:
	virtual LRESULT Open(const string& pFileName) { return GetSound()->Open(pFileName); }
	virtual LRESULT Close() { return GetSound()->Close();  }
	virtual LRESULT Play()	{ return GetSound()->Play();   }
	virtual LRESULT Replay(){ return GetSound()->Replay(); }
	virtual LRESULT Stop()	{ return GetSound()->Stop();   }
	virtual LRESULT Pause() { return GetSound()->Pause();  }
	virtual bool IsPlay() const	{ return GetSound()->IsPlay(); }
	virtual bool IsLoopPlay() const { return GetSound()->IsLoopPlay(); }// ǉ
	virtual LRESULT SetLoopPlay(bool bLoop) { return GetSound()->SetLoopPlay(bLoop); }
	virtual LONG	GetCurrentPos() const { return GetSound()->GetCurrentPos(); }
	virtual LONG	GetLength() const { return GetSound()->GetLength();}
	virtual LRESULT SetCurrentPos(LONG lPos){ return GetSound()->SetCurrentPos(lPos);}
	virtual LRESULT SetVolume(LONG volume){ return GetSound()->SetVolume(volume);}
	virtual LONG	GetVolume() const { return GetSound()->GetVolume();}
	virtual string	GetFileName() const { return GetSound()->GetFileName(); }
	virtual int	GetType() const { return GetSound()->GetType(); }

	CProxySound::CProxySound() : m_lpSound(new CSoundNullDevice) {}

	void	SelectDevice(const smart_ptr<ISound>& p) { m_lpSound = p;}
	/**
		̃NX̂́Aproxyp^[ɂĂ̂
		proxyIuWFNgւ
	*/
protected:
	smart_ptr<ISound>	m_lpSound;
	smart_ptr<ISound>	GetSound() const { return m_lpSound; }
};

/////////////////////////////////////////////////////////////////////////////

class ISoundFactory;
class CSound {
/**
	smart_ptr<ISound> Ƃ͖̂ʓ|ɂ܂Ȃ̂ŁDD

	
		ISurfaceɑ΂CPlaneƓB
		ISoundɑ΂ĂCSoundB
*/
public:

	LRESULT Load(const string& strFileName);
	///	̃t@C(wav,mp3,mid,ogg..)ǂݍ

	///	|C^̂ӂ邽߂̎d|
	ISound& operator*() const  {return *get(); }
	ISound* operator->() const {return get();  }

	///	ISurfaceւ̈Öق̕ϊ
	operator ISound* () const { return get(); }

	/**
		Null Check
			loadɎs΁ÃNX̕Ă|C^smart_ptr<ISound>
			NullɂȂ̂ŁAoB
	*/
	bool	isNull() const { return p_.isNull(); }

	ISound* get() const { return p_.get(); }

	static void SetFactory(const smart_ptr<ISoundFactory>&pFactory)
		{ pFactory_ = pFactory; }
	static smart_ptr<ISoundFactory> GetFactory()
		{ return pFactory_; }

	CSound(){}

	//CSound(const smart_ptr<ISoundFactory>& pFactory);
	///	soundfactoryn΁ApĐĕێ

	CSound(const smart_ptr<ISound>& sound):	p_(sound) {}
	///	copy constructor

	CSound(ISound* sound):p_(sound) {}
	///@́ALCSoundێ̂ŁA
	///		CSound sound(new CMIDISound);
	///	̂悤ɂĎgƁI

protected:
	smart_ptr<ISound> p_; // p_;@ċẮH

	static ThreadLocal<smart_ptr<ISoundFactory> > pFactory_;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif
