/*
	TEhNXpNX
*/

#ifndef __yaneSoundFactory_h__
#define __yaneSoundFactory_h__


#include "../Auxiliary/yaneStringMap.h"
#include "../AppFrame/yaneObjectCreater.h"

#include "../Multimedia/yaneDirectSound.h"
#include "../Multimedia/yaneDirectMusic.h"
#include "../Multimedia/yaneWaveOutput.h"
//#include "../Multimedia/yaneDirectSound.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

//class ISound;
//class CSoundParameter;
//class CDirectSound;
//class CDirectMusic;
//class IWaveOutput;
//class CWaveOutputDirectSound;

class ISoundFactory {
/**
	class ISound hNXfactorỹC^[tF[X
*/
public:
	virtual	smart_ptr<ISound>	Create(const string& filename)=0;
	virtual	smart_ptr<ISound>	Create(const string& filename,bool bStreamPlay)=0;
	virtual smart_ptr<ISound>	CreateSound()=0;
	virtual smart_ptr<ISound>	CreateMIDI()=0;
	virtual list_chain<ISound>*	GetSoundList()=0;
	virtual void			IncRefDirectSound()=0;
	virtual void			DecRefDirectSound()=0;
	virtual CDirectSound*	GetDirectSound()=0;
	virtual void			IncRefDirectMusic()=0;
	virtual void			DecRefDirectMusic()=0;
	virtual CDirectMusic*	GetDirectMusic()=0;
	virtual void			IncRefWaveOutput()=0;
	virtual void			DecRefWaveOutput()=0;
	virtual IWaveOutput*	GetWaveOutput()=0;

	//	property
	virtual void	SelectMIDIFactory(int nFirst,int nSecond) = 0;
	virtual smart_ptr<CSoundParameter> GetSoundParameter() const = 0;
	virtual void	SetSoundParameter(const smart_ptr<CSoundParameter>& p) = 0;
	virtual void	SetStreamPlay(bool b) = 0;
	virtual bool	IsStreamPlay() const = 0;

	virtual ~ISoundFactory() {}
};

class CSoundFactory : public ISoundFactory {
/**
	class ISound hNXfactory

	[ӓ_]@ꂽISoundhNXɁÃNX̂
	@@@@@OB𓯈NX̃oɎꍇ́A
	@@@@@CSoundFactoryɐ錾KvB

	̃NX̃RXgN^ŁA
	class CSound::SetFactoryŁÃNX̃CX^Xo^

	āAȍ~ACSoundƂăTEhĐ邱Ƃł

*/
public:
	//	--------- SoundBasehNXfactory
	///	1.SoundBufferiTEhĐNXj𐶐
	virtual smart_ptr<ISound>	CreateSound();

	///	2.MIDIo͗p̃NX(CMIDIOutputDMCMIDIOutputMCI)𐶐
	virtual smart_ptr<ISound>	CreateMIDI();
	/**
		3.gqɉāACreateSound,CreateMIDIs
		҂CreatéAstreamĐɂ邩ǂw肷B
		(̃IvVw肪Őݒ肵IvVD悳)
		
		̕Ԃlsmart_ptrnullł邱Ƃ͂ȂB
		(ȂƂCSoundNullDeviceԂ)
	*/
	virtual smart_ptr<ISound>	Create(const string& filename);
	virtual	smart_ptr<ISound>	Create(const string& filename,bool bStreamPlay);

	///	LfactoryŐCX^Xlist_chainl
	list_chain<ISound>*	GetSoundList() { return& m_listSound; }

	//	--------- property -------------------

	/**
		CSoundParameter̐ݒE擾
		class ISoundStream h̃vOCNX̎wƁA
		TEhobt@̃O[otH[JX̎ẃA
		ɑ΂čs
	*/
	virtual smart_ptr<CSoundParameter> GetSoundParameter() const { return m_pSoundParameter; }
	virtual void SetSoundParameter(const smart_ptr<CSoundParameter>& p) { m_pSoundParameter = p; }

	/**
		IncRefDirectSoundƂɁAGetDirectSound
		CDirectSound*擾邱Ƃ\B
		gIDecRefDirectSoundׂB
	*/
	void			IncRefDirectSound();
	void			DecRefDirectSound();
	CDirectSound*	GetDirectSound();

	/**
		IncRefDirectSoundƂɁAGetDirectMusic
		CDirectMusic*擾邱Ƃ\B
		gIDecRefDirectMusicׂB
	*/
	void			IncRefDirectMusic();
	void			DecRefDirectMusic();
	CDirectMusic*	GetDirectMusic();

	/**
		IncRefWaveOutputƂɁAGetWaveOutput
		IWaveOutput*擾邱Ƃ\B
		gIDecRefWaveOutputׂB
	*/
	void			IncRefWaveOutput();
	void			DecRefWaveOutput();
	IWaveOutput*	GetWaveOutput();

	/**
		MIDI̍Đfactory؂ւ
		@@nFirst@: ŏɑI΂factory
		@@nSecond : nFirstgpłȂƂɑI΂factory
		l̈Ӗ
		@@0 : CSoundNullDevice(ĐȂ)
		@@1 : CMIDIOutputMCI(MCIɂĐ)
		@@2 : CMIDIOutputDM (DirectMusicɂĐ)
		fBtHgł
		@@nFirst == 2	, nSecond == 1
		Ȃ킿ADirectMusicɂĐ\ȊȂ΁ApA
		ꂪsȊȂ΁AMCIɂčĐB
		iTEhĐs\Ȋł΁ACreateMIDIł
		@CSoundNullDevicẽCX^XԂj
	*/
	virtual void SelectMIDIFactory(int nFirst,int nSecond)
	{
		m_nMIDIFactoryFirst =nFirst;
		m_nMIDIFactorySecond=nSecond;
	}

	/// Xg[Đ邩ݒE擾
	/// CreateSoundŐISoundhNXɔf
	void	SetStreamPlay(bool b) { m_bStreamPlay = b; }
	bool	IsStreamPlay() const { return m_bStreamPlay; }

	CSoundFactory();
	virtual ~CSoundFactory();

protected:
	ref_creater<CDirectSound>	m_vDirectSound;
	ref_creater_and_mediator<CDirectMusic, CDirectSound>	m_vDirectMusic;
	ref_creater_and_mediator<CWaveOutputDirectSound, CDirectSound>	m_vWaveOutputDS;
	//	KvɂȂƂɂ̂ݐ

	list_chain<ISound>	m_listSound;
	//	̃NXfactoryŐCX^Xlist_chain

	int		m_nMIDIFactoryFirst;
	int		m_nMIDIFactorySecond;

	smart_ptr<ISound>	InnerCreate(int nDevice);
	//	ISoundFactory..
	//	nDevice ==	0 : class CSoundNullDevice
	//				1 : class CMIDIOutputMCI
	//				2 : class CMIDIOutputDM
	//				3 : class CWaveSound
	//				4 : IɔStreamSound
	//				5 : IStreamSound

	// CSoundParameterێ
	smart_ptr<CSoundParameter> m_pSoundParameter;

	// Xg[Đ邩(default:false)
	bool m_bStreamPlay;

private:
	CSoundFactory* GetMyClass() { return this; }
	//@RXgN^̃x[XôȂ
	//@thisgƌxoāAᛂɏ̂ŁDD

	bool	InnerDeleteChain(ISound* p);
	//@̃NX̎ISoundchain
	//@Ȃ킿Alist_chain<ISound>
	//@IuWFNg̎ɃR[obNB
	//@̊֐́AchainpÔɎg
	//@XgptrueԂ

	void	InnerDeleteChainForWO(ISound* p);
	//@InnerDeleteChain(){DecRefWaveOutput()

	void	InnerDeleteChainForDM(ISound* p);
	//@InnerDeleteChain(){DecRefDirectMusic()
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneSoundFactory_h__
