#include "stdafx.h"
#include "yaneVolumeFader.h"
#include "../AppFrame/yaneAppManager.h"
#include "../AppFrame/yaneAppBase.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

LRESULT CVolumeFader::ResetVolume(eAudioMix e){
	CheckCallBack(e);

	CVolumeFadeInfo& info = m_FadeInfo[(int)e];
	info.m_bFadeIn		= false;
	info.m_bFadeOut		= false;
	info.m_bChanged		= false;
	m_AudioMixer.SetVolumeOrg(e);		//	{[lɖ߂
	return 0;
}

bool	CVolumeFader::CheckCallBack(eAudioMix e){
//	Kv΃R[obNsȂ
//	callbacksȂƂtrue

	CVolumeFadeInfo& info = m_FadeInfo[(int)e];
	if ((info.m_bFadeIn || info.m_bFadeOut) && !info.m_fn.isNull()){
		info.m_fn->run();
		info.m_fn.Delete();
		return true;
	}
	return false;
}

LRESULT CVolumeFader::FadeOut(eAudioMix e,int dwTime){
	return _FadeOut(e,dwTime,true);
}

LRESULT CVolumeFader::_FadeOut(eAudioMix e,int dwTime,bool bCheckCallBack){
	if (bCheckCallBack){
		CheckCallBack(e);
	}
	//	tF[hAEgJn

	CVolumeFadeInfo& info = m_FadeInfo[(int)e];

	info.m_Timer.Reset();
	info.m_dwWholeTime	= dwTime;
	info.m_bFadeIn		= false;
	info.m_bFadeOut		= true;

	//	݂̃H[ʂXgAĂKv
	//	(H[Rg[ύXꂽ\̂)
	if (!info.m_bChanged) { m_AudioMixer.RestoreVolume(e); }

	//	C^[o^C}[𔭓OO
	if (!IsTimer()) {
		Start();
	}	//	ꂭ炢ŏ\H
	info.m_bChanged		= true;
	TimerProc();
	//	܂PڂĂяoȂƁǍĂяo
	//	ĐĂꍇA̉ʂXVO̒lŏo͂
	return 0;
}

LRESULT CVolumeFader::FadeIn(eAudioMix e,int dwTime){
	return _FadeIn(e,dwTime,true);
}

LRESULT CVolumeFader::_FadeIn(eAudioMix e,int dwTime,bool bCheckCallBack){
	if (bCheckCallBack){
		CheckCallBack(e);
	}

	//	tF[hCJn
	CVolumeFadeInfo& info = m_FadeInfo[(int)e];
	info.m_Timer.Reset();
	info.m_dwWholeTime	= dwTime;
	info.m_bFadeIn		= true;
	info.m_bFadeOut		= false;

	//	݂̃H[ʂXgAĂKv
	//	(H[Rg[ύXꂽ\̂)
	if (!info.m_bChanged) { m_AudioMixer.RestoreVolume(e); }

	//	C^[o^C}[𔭓OO
	if (!IsTimer()) {
		Start();
	}	//	ꂭ炢ŏ\H
	info.m_bChanged = true;
	TimerProc();
	//	܂PڂĂяoȂƁǍĂяo
	//	ĐĂꍇA̉ʂXVO̒lŏo͂
	return 0;
}

void	CVolumeFader::StopFade(){
	Stop();
	for(int i=0;i<4;i++){
		CheckCallBack((eAudioMix)i);
		m_FadeInfo[i].m_bFadeIn	 = false;
		m_FadeInfo[i].m_bFadeOut = false;
	}
}

void	CVolumeFader::TimerProc(){
	if (!m_AudioMixer.IsSuccessInit()) return ;

	int nReset = 0;
	for (int i=0;i<4;i++){
		CVolumeFadeInfo& info = m_FadeInfo[i];
		if (info.m_bFadeIn) {
			double d = (double)info.m_Timer.Get() / info.m_dwWholeTime;
			if (d>1) {
				d=1;
				CheckCallBack((eAudioMix)i);
				info.m_bFadeIn = false;

				info.m_bChanged = false;
				//	ύXIˎfadêƂɂ́A
				//	݂̃H[H[Ƃĕۑ
			}
			m_AudioMixer.SetVolumeRel((eAudioMix)i,d);
		} else if (info.m_bFadeOut){
			double d = (double)info.m_Timer.Get() / info.m_dwWholeTime;
			if (d>1) {
				d=1;
				if (CheckCallBack((eAudioMix)i)){
					d = 0;	//	R[obNsȂ̂ŏH[ɖ߂
					info.m_bChanged = false;
					//	̊֐𔲂ƁA̒l͏H[Ƃ݂Ȃėǂ
				}
				info.m_bFadeOut = false;
			}
			d = 1-d;
			m_AudioMixer.SetVolumeRel((eAudioMix)i,d);
		} else {
			nReset++;
		}
	}
	//	ׂẴtF[hIĂ邩H
	if (nReset==4) Stop();	//	^C}[̒~
}

bool CVolumeFader::IsFade(eAudioMix e) const {
	return m_FadeInfo[(int)e].m_bFadeIn || m_FadeInfo[(int)e].m_bFadeOut;
}

LRESULT CVolumeFader::FadeOut(eAudioMix e,int dwTime,
		const smart_ptr<function_callback>& fn){
	CheckCallBack(e);
	m_FadeInfo[(int)e].m_fn = fn;
	return _FadeOut(e,dwTime,false);
}

LRESULT CVolumeFader::FadeIn(eAudioMix e,int dwTime,
		const smart_ptr<function_callback>& fn){
	CheckCallBack(e);
	m_FadeInfo[(int)e].m_fn = fn;
	return _FadeIn(e,dwTime,false);
}

//////////////////////////////////////////////////////////////////////////////

//	R[obN̊Jn
void	CVolumeFader::Start(){
	if (m_bTimer) return ; // łɃ^C}܂ƂI
	m_bTimer = true;
	smart_ptr<function_callback> fn(
		function_callback_v::Create(&CVolumeFader::TimerProc,this)
	);
	//	R[obN̓o^
	CAppManager::GetMyApp()->GetIntervalTimer()->RegistCallBack(
		this,	//	R[obNo^Ă̂
				//	폜邽߂̎ʎq
		20,		//	ڂ̃R[obN20ms
		20,		//	20msƂ
		0,		//	endlessR[obN
		fn
	);
}

void	CVolumeFader::Stop(){
	//	R[obN̍폜
	if (IsTimer()){
		CAppManager::GetMyApp()->GetIntervalTimer()->DeleteCallBack(this);
		m_bTimer = false;
	}
}

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd
