// yaneWaveOutput.h
//		programmed by ENRA		 '02/03/28

#ifndef __yaneWaveOutput_h__
#define __yaneWaveOutput_h__


#include "../Window/yaneWinHook.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class ISound;
class IWaveSound;
class ISoundBuffer;
class ISoundStreamFactory;
class CDirectSound;
class CSoundParameter;

class IWaveOutput {
/**
	Waveo͂𒊏ۉNX
	class IWaveSound hNX̊Ǘ
	class ISoundBuffer  class ISoundStreamFactory ̒
	󂯎

	[gp@]
	CWaveOutputDirectSound ds;@IWaveOutputhNX
	CWaveSound sound(&ds);
	sound.Play();
*/
public:
	IWaveOutput();
	virtual ~IWaveOutput(){};

	virtual int	GetType() const = 0;
	/**
		RTTIǂBhNX̃^CvԂ
		0 : class CWaveNullOutput
		1 : class CWaveOutputDirectSound
		2 : 񂪂イ
	*/

	/// class ISoundBuffer hNX̐
	virtual smart_ptr<ISoundBuffer> CreateBuffer()=0;

	/// class CSoundParameter ̐ݒE擾
	virtual smart_ptr<CSoundParameter> GetSoundParameter() const { return m_pSoundParameter; }
	virtual void SetSoundParameter(const smart_ptr<CSoundParameter>& p) { m_pSoundParameter = p; }

	/// ǗXg̎擾
	/// class IWaveSound hNX̑SCX^Xɑ΂Ă̑͂ōs
	virtual list_chain<IWaveSound>* GetSoundList() { return &m_listSound; }

	/// ǗXgւ̒ǉE폜
	/// class IWaveSound hNX̃RXgN^EfXgN^ŌĂяô
	/// [UIɌĂяoKv͂Ȃ
	virtual LRESULT AddSound(IWaveSound* p);
	virtual LRESULT DelSound(IWaveSound* p);

protected:
	// class IWaveSound hNX̃Xg
	list_chain<IWaveSound> m_listSound;
	// class CSoundParameter ێ
	smart_ptr<CSoundParameter> m_pSoundParameter;
};

class CWaveNullOutput : public IWaveOutput {
/**
	class IWaveOutput NullDeviceNX
*/
public:
	CWaveNullOutput(){};
	virtual ~CWaveNullOutput(){};

	/// override from class IWaveOutput
	virtual int	GetType() const { return 0; }
	virtual smart_ptr<ISoundBuffer> CreateBuffer();
};

class CWaveOutputDirectSound : public IWaveOutput, public IWinHook {
/**
	DirectSoundɓ class IWaveOutput hNX
	obt@̃XgAǗĂSĂ class IWaveSound hNX
	Restore֐IɌĂт
*/
public:
	/// CDirectSoundւ̃|C^ip==NULLƑj
	/// ȗ\ɂȂref_creater_and_mediator̃RpCoȂ
	CWaveOutputDirectSound(CDirectSound* p=NULL);
	virtual ~CWaveOutputDirectSound();

	/// vC}TEhobt@̃tH[}bgύX
	/// [in] nFrequency - 11kHz(0) or 22kHz(1) or 33kHz(2) or 44kHz(3)
	/// [in] nBit@@@ - 8bit(0) or 16bit(1)
	/// [in] bStereo@@- trueȂXeI
	virtual LRESULT ChangePrimaryFormat(int nFrequency, int nBit, bool bStereo);

	/// ZJ_TEhobt@𐶐
	/// 쐬łȂƂCNullSoundBuffer𐶐
	virtual smart_ptr<ISoundBuffer> CreateSecondery();

	/// override from class IWaveOutput
	virtual int	GetType() const { return 1; }
	virtual smart_ptr<ISoundBuffer> CreateBuffer() { return CreateSecondery(); }

protected:
	// obt@̃XgĎp
	LRESULT WndProc(HWND hWnd,UINT uMsg,WPARAM wparam,LPARAM lparam);
	// CDirectSoundւ̃|C^
	CDirectSound* m_pDirectSound;
	CDirectSound* GetDirectSound() const { return m_pDirectSound; }
	// vC}TEhobt@
	smart_ptr<ISoundBuffer> m_pPrimary;
	// vC}TEhobt@̎
	int	m_nPrimaryType;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneWaveOutput_h__
