//	 re-programmed by yaneurao(M.Isozaki) '99/07/07
//	 re-programmed by ENRA				  '02/03/23

#include "stdafx.h"
#include "../Auxiliary/yaneFile.h"

#include "yaneWaveOutput.h"
#include "yaneSoundParameter.h"
#include "yaneSoundBuffer.h"
#include "yaneSoundStream.h"

#include "yaneWaveStaticSound.h"
//#include "../Window/yaneDebugWindow.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

#define sign(val) (val>0?1:(val<0?-1:0))	//	Ԃ

//////////////////////////////////////////////////////////////////////////

CWaveStaticSound::CWaveStaticSound(IWaveOutput* p) : m_pOutput(p)
{
	m_bPaused = 0;			//	QƃJEg
	m_nAvgBytesPerSec = 0;

	// ftHgŃ[vȂ
	SetLoopPlay(false);

	// NullSoundBufferǂ
	SetBuffer(smart_ptr<ISoundBuffer>(new CNullSoundBuffer));

	// ʓ|Ă
	GetOutput()->AddSound(this);
}

CWaveStaticSound::~CWaveStaticSound(){
	Release();

	// Ȃ[
	GetOutput()->DelSound(this);
}

/*
//////////////////////////////////////////////////////////////////////////
//--- C '02/01/10  by ENRA ---
LRESULT CWaveStaticSound::Load(string filename){
	DWORD dwDataLen = 0;

	// ̊֐ADirectSound̂ȂŁAԂȂ񂿂ႤH
	if (GetDirectSound() == NULL) return 1;	// ꂳI

	Release(); // ܂́A悤ˁI
	m_szFileName.erase();
	if (filename.empty()) return 0;

	// ΃pX
	filename = CFile::MakeFullName(filename);

	// Factoryւ(;LD`)
	if(m_lpReaderFactory==NULL){ m_lpReaderFactory.Add(); }
	// I[vł邩[H
	mtknLib::IkmPCMstream* pReader = m_lpReaderFactory->CreateReader(filename.c_str());
	if (pReader==NULL) {
		Err.Out("CWaveStaticSound::Load " + filename + "̃t@Cǂݍݎ̃G[");
		return 1; // t@Cǂݍ݃G[
	}

	// Kvȃobt@𓾂
	dwDataLen = pReader->GetPCMLength();

	// ƂDirectSound̏
	DSBUFFERDESC  dsbdDesc;
	ZeroMemory(&dsbdDesc, sizeof(DSBUFFERDESC));
	dsbdDesc.dwSize = sizeof(DSBUFFERDESC);
	dsbdDesc.dwFlags = DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLFREQUENCY; // {[Ō\II
	// dsbdDesc.dwFlags = DSBCAPS_LOCSOFTWARE;
	// ʂ̃f[^ꍇA\tgłق肪Ȃ̂
	// in[hEFAɂƂă~LVOɎԂ\j
	// Ȃ\B
	// ƁA{[Rg[\͂ĂKvB
	// n[hEFAobt@Rg[\͂ƁA
	// ɎԂ邩...

	// | DSBCAPS_GETCURRENTPOSITION2;
	// ƁAtǂ̃Xe[^XxȂ̂
	// Xe[^XĂ̘AĐłȂȂI

	// | DSBCAPS_GLOBALFOCUS
	// ƁABackGroundł葱

	dsbdDesc.dwBufferBytes = dwDataLen;
	dsbdDesc.lpwfxFormat = pReader->GetFormat();

	// DirectSoundobt@̍쐬
	if (GetDirectSound()->CreateSoundBuffer(&dsbdDesc,&m_lpDSBuffer, NULL) != DS_OK){
		//	gύX̃Rg[܂񂩁H
		dsbdDesc.dwFlags = DSBCAPS_CTRLVOLUME; // {[ȂǂIH
		if (GetDirectSound()->CreateSoundBuffer(&dsbdDesc,&m_lpDSBuffer, NULL) != DS_OK){
			Err.Out("CWaveStaticSound::LoadCreateSoundBuffer()ŎsI");
			return 7;
		}
	}

	// DirectSoundobt@Lock
	BYTE* lpDSBuffData;
	HRESULT hr;
	hr = m_lpDSBuffer->Lock(0, dwDataLen, (void**)&lpDSBuffData,
		&dwDataLen, NULL, 0, 0);
		// ́ÁAs邱Ƃ͑XL̂:p

	if (hr==DSERR_BUFFERLOST){
		m_lpDSBuffer->Restore(); // ŃIbP!i΁j
		hr = m_lpDSBuffer->Lock(0, dwDataLen, (void**)&lpDSBuffData,
			&dwDataLen, NULL, 0, 0);
		// ŁAgĆII
	}

	if (hr!=DS_OK) {
		// Ń_ȂÂႤH
		Err.Out("CWaveStaticSound::LoadLock()ɎsI");
		return 8;
	}

	// t@CWJ
	pReader->SetLoop(false);
	pReader->Read(lpDSBuffData, dsbdDesc.dwBufferBytes);
	// DLLoȂ̂smart_ptr͎gႾ߂߁B
	pReader->DeleteSelf();  pReader=NULL;

	// DirectSoundobt@Unlock...
	if (m_lpDSBuffer->Unlock(lpDSBuffData, dwDataLen, NULL, 0)
		!= DS_OK) {
		// Ȃӂ[As邩...ǂȂ[[񂶂
		Err.Out("CWaveStaticSound::LoadUnlock()ɎsI");
		return 10;
	}

	//	bԂ̍Đb
	WAVEFORMATEX wfe;
	if( (m_lpDSBuffer->GetFormat( &wfe, sizeof(wfe), NULL )) == DS_OK &&
		(wfe.nAvgBytesPerSec)){
		m_nAvgBytesPerSec = wfe.nAvgBytesPerSec;
	} else {
		//	ȂBG[ɂȂ񂩂H
		m_nAvgBytesPerSec = 0;
	}

	m_szFileName = filename;
	m_lLength = LONG(((DWORDLONG)dwDataLen * 1000) / m_nAvgBytesPerSec);

	return 0;
}
//-------------------------------
*/

LRESULT CWaveStaticSound::Load(const string& filename){
	Release(); // ܂́A悤ˁI
	m_strFileName.erase();
	if (filename.empty()) return 0;

	smart_ptr<ISoundStream> stream = GetOutput()->GetSoundParameter()->GetStreamFactory()->Open(filename);
	LPCWAVEFORMATEX pWFormat = stream->GetFormat();
	if (pWFormat==NULL) return 0;
	const DWORD dwDataLen = (LONG)((DWORDLONG)stream->GetLength() * pWFormat->nAvgBytesPerSec /1000);
	// DirectSoundobt@̍쐬
	SetBuffer(GetOutput()->CreateBuffer());
	if (GetBuffer()->Create(pWFormat, dwDataLen, false, GetOutput()->GetSoundParameter().get()) != 0){
		Err.Out("CWaveStaticSound::Load TEhobt@̍쐬ɎsI");
		// NullSoundBufferǂ
		SetBuffer(smart_ptr<ISoundBuffer>(new CNullSoundBuffer));
		return 1;
	}

	// DirectSoundobt@Lock
	BYTE* lpLockedBuffer;
	DWORD dwLockedSize;
	if (GetBuffer()->Lock(0, dwDataLen, &lpLockedBuffer, &dwLockedSize) != 0) {
		// Ń_ȂÂႤH
		Err.Out("CWaveStaticSound::Load GetBuffer()->Lock()ɎsI");
		return 2;
	}

	// ǂݍ݁`
	const DWORD dwReadedSize = stream->Read(lpLockedBuffer, dwLockedSize);
	if ( dwReadedSize > dwLockedSize ) {	//	G[ƍl
		Err.Out("CWaveStaticSound::Load stream->Read()ɎsI");
		//	YꂸUnlockƂ
		GetBuffer()->Unlock(lpLockedBuffer, dwLockedSize);
		return 3;
	}

	// DirectSoundobt@Unlock...
	if (GetBuffer()->Unlock(lpLockedBuffer, dwLockedSize) != 0) {
		// Ȃӂ[As邩...ǂȂ[[񂶂
		Err.Out("CWaveStaticSound::Load GetBuffer()->Unlock()ɎsI");
		return 4;
	}

	//	bԂ̍Đb
	WAVEFORMATEX wfe;
	if( GetBuffer()->GetFormat(&wfe)==0 ) {
		m_nAvgBytesPerSec = wfe.nAvgBytesPerSec;
	} else {
		//	ȂBG[ɂȂ񂩂H
		m_nAvgBytesPerSec = 0;
	}

	m_strFileName = filename;
	m_lLength = (LONG)( ((DWORDLONG)dwDataLen*1000)/m_nAvgBytesPerSec );

	return 0;
}

LRESULT CWaveStaticSound::Release(){
	if (IsPlay()) Stop();
	// ĐȂƂ߂ƂI iꉞˁj

	// NullSoundBufferǂ
	SetBuffer(smart_ptr<ISoundBuffer>(new CNullSoundBuffer));
	m_strFileName.erase();

	m_nAvgBytesPerSec = 0;

	return 0;
}

LRESULT CWaveStaticSound::Restore(){
	DWORD dwStatus = GetBuffer()->GetStatus();
	if (dwStatus==1){
		GetBuffer()->Restore();
		if (m_strFileName!="") {
			const string temp(m_strFileName); // Rs[ēnReleaseꂿႤ:p
			return Load(temp);
		}
	}

	return 0;
}

LRESULT CWaveStaticSound::Play()
{
	m_bPaused = 0;

	// ĐȂA~߂ĂłĐȂB
	// {ȂAtȂ~߂ɃJg|WVύXĂ
	// ǂ͂Ȃ̂ȀuԂPLAYIƂ\B
	// iȂ񂩁ADirectSound̃oÔ悤ȋCȂȂj

	// ŁAJg|WV擪ɖ߂āAvC~܂
	// ΁AĐƂASYɕύXB
	
	GetBuffer()->SetCurrentPosition(0);
	// ɖ߂Ă̂ف[Play萳m (C) yaneurao
	if (GetBuffer()->GetStatus()==3) {		
		GetBuffer()->Stop(); // ˑR~߂班mCY邯ǂȁBdȂȁB
		GetBuffer()->SetCurrentPosition(0);
	}

	if (GetBuffer()->Play(m_bLoop)!=0){
		if (GetBuffer()->GetStatus()==1) {		
			// 炢Bobt@LOSTBrestoreiI
			return Restore();
		}
		Err.Out("CWaveStaticSound::Play GetBuffer()->Play()ɎsI");
		return 1;
	}

	return 0;
}

	//////////////////////////////////////////////////////////////////////////

LRESULT CWaveStaticSound::Stop()
{
	if (!IsPlay()) return 0; // ~܂Ă[ɁI

	LRESULT ret = GetBuffer()->Stop();
	GetBuffer()->SetCurrentPosition(0); // ǂƂȁI

	return ret;
}

bool CWaveStaticSound::IsPlay() const
// ̃`lĐ(=3)Ȃtrue
{
	return GetBuffer()->GetStatus()==3;
}

LRESULT CWaveStaticSound::Pause()
 // `lpause
{
	m_bPaused += sign(m_bPaused);	//	KEZ:p
	if (!IsPlay()) {
		return 0; // IĂ[ɁI
	}
	//	Đ̂pauseȂ
	m_bPaused = 1;

	// ɔĂ[Ƃ́Am_lpDSBuffer!=NULL
	return GetBuffer()->Stop();
}

LRESULT CWaveStaticSound::Replay()
// pauseŎ~߂ĂÃ`l̍ĐĊJB
{
	if (!m_bPaused) return 0; // pauseĂւāI
	
	if (--m_bPaused==0) {	//	QƃJEg
		return GetBuffer()->Play(m_bLoop);
	}
	return 0;
}

LRESULT CWaveStaticSound::SetVolume(LONG volume)
{
	// ͈͊ÕG[`FbN[ւ񂩂AɂĂ[
	return GetBuffer()->SetVolume(volume);

	// DSBVOLUME_MAXiȂj :		0
	// DSBVOLUME_MINij	 : -10000
	// ̊ԂŎw肷̂B
}

LONG CWaveStaticSound::GetVolume() const
// 擾́A`lɑ΂ĂłȂ...
{
	LONG volume;
	if ((GetBuffer()->GetVolume(volume))!=DS_OK){
		Err.Out("CWaveStaticSound::GetVolumeɎs");
		return 0; // volumeDSBVOLUME_MAXԂƂ?
	}
	return volume;
}

LONG CWaveStaticSound::GetCurrentPos() const
{
	if (m_nAvgBytesPerSec==0) return -1;	//	Load̏擾ŎsĂ
	
	DWORD pos, dm;
	if( (GetBuffer()->GetCurrentPosition( pos, dm )) != 0 ) return -1;
	return LONG(((DWORDLONG) pos * 1000 / m_nAvgBytesPerSec ) );
	//	DWORDLONGɃLXgȂƈꂿႤ:p
}

LRESULT CWaveStaticSound::SetCurrentPos(LONG lPos){
	if (m_nAvgBytesPerSec==0) return -1;	//	Load̏擾ŎsĂ

	DWORD pos;
	pos = (DWORD)((DWORDLONG)lPos * m_nAvgBytesPerSec / 1000);
	return GetBuffer()->SetCurrentPosition(pos);
}

//	bmd̒
LONG CWaveStaticSound::GetFrequency() const
{
	DWORD dwFreq;
	if( GetBuffer()->GetFrequency( dwFreq ) != 0 ) return -1;
	return( (LONG)dwFreq );
}

LRESULT CWaveStaticSound::SetFrequency( DWORD freq )
{
	if((DSBFREQUENCY_MIN<=freq && freq<=DSBFREQUENCY_MAX) || freq==DSBFREQUENCY_ORIGINAL)
		if( GetBuffer()->SetFrequency( freq ) == 0 ) return 0;
	return 1;
}

LRESULT	CWaveStaticSound::SetLoopPlay(bool bLoop)
{
	m_bLoop = bLoop;
	return 0;
}

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd
