#include "stdafx.h"

#include "../Auxiliary/yaneFile.h"
#include "../Thread/yaneCriticalSection.h"
#include "yaneWaveOutput.h"
#include "yaneSoundParameter.h"
#include "yaneSoundBuffer.h"
#include "yaneSoundStream.h"

#include "yaneWaveStreamSound.h"
//#include "../Window/yaneDebugWindow.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

//////////////////////////////////////////////////////////////////////////

void CWaveStreamSound::ThreadProc()
{
	bool bWait = false;
	const DWORD dwBufferSize = GetBufferSize();
	while (true) {
		//	ɗpcH
		if ( !IsThreadValid() ) return ;

		//	t@CŜʂĂ̍Đʒuo
		//	GetNextSoundData֐CThread::sleep֐̊֌WA20msecx̕\Ȃ
		{	CCriticalLock lock(GetCS());
			const DWORD dwPrevPlayCursor = m_dwPrevPlayCursor;
			DWORD dwPlayCursor, dwWriteCursor;
			GetBuffer()->GetCurrentPosition(dwPlayCursor, dwWriteCursor);
			if ( dwPlayCursor >= dwPrevPlayCursor ) {
				m_dwPlayPosition += dwPlayCursor - dwPrevPlayCursor;
			} else {
				m_dwPlayPosition += (dwPlayCursor + dwBufferSize) - dwPrevPlayCursor;
			}
			m_dwPrevPlayCursor = dwPlayCursor;
			m_dwPlayPosition %= m_dwLength;
		}

		//	f[^𗬂
		DWORD ret = GetNextSoundData();
		if ( ret==1 ) {	//	EOF
			if (IsLoopPlay()){
				//	[vĐȂAXg[߂čĐs
				GetStream()->SetCurrentPos(0);
				continue ;
			} else {
				//	񃋁[vĐȂAI[܂ł̍Đ̖ʓ|
				bWait = true;
				break ;
			}
		}
		ef ( ret>=2 ) {	//	G[
			//	Stop()ĂԂƃXbh̏I҂̂ŃfbhbNɂȂ܂
			InnerStop();
			return ;
		}
	}

	if ( bWait ) {
		//	ĐJ[\~ʒuOɂƁA
		//	dwPlayCursor >= m_dwNextWriteCursor Ƃł
		//	ʒuŒ~oȂ
		//	iobt@̈~Ă܂j
		bool bForward = false;
		DWORD dwLimit = 0;
		{	CCriticalLock lock(GetCS());
			//dwLimit = m_dwNextWriteCursor - (m_nAvgBytesPerSec / 50);//	20msecOŎ~߂
			dwLimit = m_dwNextWriteCursor;
			DWORD dwPlayCursor, dwWriteCursor;
			GetBuffer()->GetCurrentPosition(dwPlayCursor, dwWriteCursor);
			if ( dwPlayCursor >= dwLimit ) {
				bForward = true;	//	ĐJ[\͒~ʒuO
			}

			//	݂̏
			//	bForward ==	true  -> ~ʒu`Đʒu܂ŃNA
			//				false -> ~ʒu`I܂ŃNA
			const DWORD dwClearSize = (bForward) ? (dwPlayCursor - dwLimit) : (dwBufferSize - dwLimit);
			BYTE* lpLockedBuffer;
			DWORD dwLockedSize;
			//	bvAEh邱Ƃ͂蓾Ȃ
			if ( GetBuffer()->Lock(dwLimit, dwClearSize, &lpLockedBuffer, &dwLockedSize) ) {
				Err.Out("CWaveStreamSound::ThreadProc GetBuffer()->Lock()ɎsI");
				//	Stop()ĂԂƃXbh̏I҂̂ŃfbhbNɂȂ܂
				InnerStop();
				return ;
			}
			memset(lpLockedBuffer, 0, dwLockedSize);
			if ( GetBuffer()->Unlock(lpLockedBuffer, dwLockedSize) ){
				Err.Out("CWaveStreamSound::ThreadProc GetBuffer()->Unlock()ɎsI");
				//	Stop()ĂԂƃXbh̏I҂̂ŃfbhbNɂȂ܂
				InnerStop();
				return ;
			}
		}

		while (true) {
			//	ɗpcH
			if ( !IsThreadValid() ) return ;

			//	t@CŜʂĂ̍Đʒuo
			//	GetNextSoundData֐CThread::sleep֐̊֌WA20msecx̕\Ȃ
			{	CCriticalLock lock(GetCS());
				const DWORD dwPrevPlayCursor = m_dwPrevPlayCursor;
				DWORD dwPlayCursor, dwWriteCursor;
				GetBuffer()->GetCurrentPosition(dwPlayCursor, dwWriteCursor);
				if ( !bForward && dwPlayCursor >= dwLimit ){
					//	Stop()ĂԂƃXbh̏I҂̂ŃfbhbNɂȂ܂
					InnerStop();
					return ;
				}
				if ( dwPlayCursor == dwPrevPlayCursor ) {
					lock.Leave();						//	bN
					if ( CThread::sleep(20) ) return ;	//	΂xBInvalidateꂽ炷I
					continue ;
				} else {
					if ( dwPlayCursor > dwPrevPlayCursor ) {
						m_dwPlayPosition += dwPlayCursor - dwPrevPlayCursor;
					} else {
						m_dwPlayPosition += (dwPlayCursor + dwBufferSize) - dwPrevPlayCursor;
						//	ĐJ[\͒~ʒuɈʒuĂ鎖ɂȂ
						bForward = false;
					}
				}
				m_dwPrevPlayCursor = dwPlayCursor;
				m_dwPlayPosition %= m_dwLength;
			}
		}
	}
}

LRESULT CWaveStreamSound::GetNextSoundData()
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	const DWORD dwBufferSize = GetBufferSize();

	//	TCY𓾂
	DWORD dwUsedSize = 0;
	DWORD dwPlayCursor, dwWriteCursor;
	GetBuffer()->GetCurrentPosition(dwPlayCursor, dwWriteCursor);
	{
		const DWORD dwPrevWriteCursor = m_dwPrevWriteCursor;
		if ( dwWriteCursor == dwPrevWriteCursor ) {	//	ĂȂ́H
			lock.Leave();		//	bN
			CThread::sleep(20);	//	΂x
			return 0;
		} else {
			//dwUsedSize = ((dwBufferSize + dwWriteCursor) - dwPrevWriteCursor) % dwBufferSize;
			if ( dwWriteCursor > dwPrevWriteCursor ) {
				dwUsedSize = dwWriteCursor - dwPrevWriteCursor;
			} else {
				dwUsedSize = (dwWriteCursor + dwBufferSize) - dwPrevWriteCursor;
			}
		}
	}
	//	O[oȂ悹
	dwUsedSize += m_dwWriteDiffer;
	//	gpʂ0.5b菬Ȃ牽ȂiCPUp[̐ߖj
	if ( dwUsedSize < m_nAvgBytesPerSec/2 ) {
		lock.Leave();		//	bN
		CThread::sleep(20);	//	΂x
		return 0;
	}
	m_dwWriteDiffer = 0;	//	YꂸɃNA[

	//	ĐJ[\ŃNbsO
	{
		const DWORD dwNextWriteCursor = m_dwNextWriteCursor;
		//	bvAEhl
		if ( (dwNextWriteCursor + dwUsedSize) > dwBufferSize ) {
			//	݊Jnʒuobt@I[܂ł̒
			const DWORD dwWriteSize1 = dwBufferSize - dwNextWriteCursor;
			//	obt@[珑ݏIʒu܂ł̒
			const DWORD dwWriteSize2 = dwUsedSize - dwWriteSize1;
			if ( dwWriteSize2 > dwPlayCursor ) {
				dwUsedSize = dwWriteSize1 + dwPlayCursor;
			}
		} else {
			if ( dwNextWriteCursor < dwPlayCursor&&dwPlayCursor < (dwNextWriteCursor + dwUsedSize) ) {
				dwUsedSize = dwPlayCursor - dwNextWriteCursor;
			}
		}
	}
	//	4oCgEɍ킹
	dwUsedSize &= ~3;

	//	݂̏J[\oĂ
	m_dwPrevWriteCursor = dwWriteCursor;

	//	Xg[ǂݍ
	smart_ptr<BYTE> pBuffer;
	pBuffer.AddArray(dwUsedSize);
	const DWORD readed = GetStream()->Read(pBuffer.get(), dwUsedSize);
	if ( readed==0 ) {
		return 1;	//	EOFł
	}
	ef ( readed > dwUsedSize ) {	//	G[ƍl
		Err.Out("CWaveStreamSound::GetNextSoundData GetStream()->Read()ɎsI");
		return 2;
	}

	//	TEhobt@ɏ
	BYTE* lpLockedBuffer;
	DWORD dwLockedSize;
	BYTE* lpLockedBuffer2;
	DWORD dwLockedSize2;
	if ( GetBuffer()->Lock(m_dwNextWriteCursor, dwUsedSize, &lpLockedBuffer, &dwLockedSize, &lpLockedBuffer2, &dwLockedSize2) ) {
		Err.Out("CWaveStreamSound::GetNextSoundData GetBuffer()->Lock()ɎsI");
		return 3;
	}
	if ( readed < dwLockedSize ) {
		//	ǂ߂Ȃ炵
		memcpy(lpLockedBuffer, pBuffer.get(), readed);
	} else {
		memcpy(lpLockedBuffer, pBuffer.get(), dwLockedSize);
	}
	if ( lpLockedBuffer2!=NULL && readed > dwLockedSize ) {
		//	bvAEhRs[
		if ( readed - dwLockedSize < dwLockedSize2 ) {
			//	ǂ߂Ȃ炵
			memcpy(lpLockedBuffer2, pBuffer.get()+dwLockedSize, readed - dwLockedSize);
		} else {
			//	cRs[
			memcpy(lpLockedBuffer2, pBuffer.get()+dwLockedSize, dwLockedSize2);
		}
	}
	if ( GetBuffer()->Unlock(lpLockedBuffer, dwLockedSize, lpLockedBuffer2, dwLockedSize2) ) {
		Err.Out("CWaveStreamSound::GetNextSoundData GetBuffer()->Unlock()ɎsI");
		return 4;
	}

	//	񏑂݃J[\XV
	m_dwNextWriteCursor += readed;
	m_dwNextWriteCursor %= dwBufferSize;
	//	ǂݍ߂ȂTCY͎ɂ܂킷
	if ( readed < dwUsedSize ) {
		m_dwWriteDiffer += dwUsedSize - readed;
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////

CWaveStreamSound::CWaveStreamSound(IWaveOutput* p) : m_pOutput(p)
{
	//	ftHgŃ[vȂ
	SetLoopPlay(false);

	//	NullSoundBufferǂ
	SetBuffer(smart_ptr<ISoundBuffer>(new CNullSoundBuffer));
	//	ȂǂݍłȂO
	m_dwLength = 0;
	m_nAvgBytesPerSec = 0;
	//	QƃJEg
	m_bPaused = 0;
	//	Volume
	m_lVolume = 0;

	//	ʓ|Ă
	GetOutput()->AddSound(this);
}

CWaveStreamSound::~CWaveStreamSound(){
	Release();
	//	Ȃ[
	GetOutput()->DelSound(this);
}

LRESULT CWaveStreamSound::InitBuffer()
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	//	t@Cǂ݂ł́H
	if ( m_strFileName==""||m_nAvgBytesPerSec==0 ) {
		Err.Out("CWaveStreamSound::InitBuffer t@Cǂݍ߂ĂȂ");
		return 1;
	}

	//	ǂݍ߂Ă̂`FbN
	if ( GetStream()->GetFormat()==NULL ) {
		Err.Out("CWaveStreamSound::InitBuffer GetStream()->GetFormat()==NULL");
		return 2;
	}

	//	DirectSoundobt@̍쐬
	SetBuffer( GetOutput()->CreateBuffer() );
	if ( GetBuffer()->Create(GetStream()->GetFormat(), GetBufferSize(), true, GetOutput()->GetSoundParameter().get())!=0 ) {
		Err.Out("CWaveStreamSound::InitBuffer TEhobt@̍쐬ɎsI");
		return 3;
	}

	//	J[\Sď
	m_dwPrevWriteCursor = 0;
	m_dwNextWriteCursor = 0;
	m_dwWriteDiffer = 0;
	m_dwPrevPlayCursor = 0;
	GetBuffer()->SetCurrentPosition(0);
	//	obt@Volume𔽉fĂ
	GetBuffer()->SetVolume(m_lVolume);

	//	obt@TCY7/8炢ǂݍ
	DWORD dwUsedSize = (GetBufferSize()*7)/8;
	//	4oCgEɍ킹
	dwUsedSize &= ~3;

	//	DirectSoundobt@Lock
	BYTE* lpLockedBuffer;
	DWORD dwLockedSize;
	if ( GetBuffer()->Lock(m_dwNextWriteCursor, dwUsedSize, &lpLockedBuffer, &dwLockedSize) ) {
		//	Ń_ȂÂႤH
		Err.Out("CWaveStreamSound::InitBuffer GetBuffer()->Lock()ɎsI");
		return 4;
	}
	const DWORD dwReadedSize = GetStream()->Read(lpLockedBuffer, dwLockedSize);
	if ( dwReadedSize > dwLockedSize ) {	//	G[ƍl
		Err.Out("CWaveStreamSound::InitBuffer GetStream()->Read()ɎsI");
		//	YꂸUnlockƂ
		GetBuffer()->Unlock(lpLockedBuffer, dwLockedSize);
		return 5;
	}
	if ( GetBuffer()->Unlock(lpLockedBuffer, dwLockedSize) ) {
		//	Ȃӂ[As邩...ǂȂ[[񂶂
		Err.Out("CWaveStreamSound::InitBuffer GetBuffer()->Unlock()ɎsI");
		return 6;
	}
	//	񏑂݃J[\XV
	m_dwNextWriteCursor += dwReadedSize;
	//	ǂݍ݂łȂTCY͎ɂ܂킷
	if ( dwReadedSize < dwUsedSize ) { m_dwWriteDiffer = dwUsedSize - dwReadedSize; }

	return 0;
}

LRESULT CWaveStreamSound::Load(const string& filename)
{
	Release(); //	܂́A悤ˁI
	m_strFileName.erase();
	if ( filename.empty() ) { return 0; }

	//	t@CJ
	SetStream( GetOutput()->GetSoundParameter()->GetStreamFactory()->Open(filename) );

	//	bԂ̍Đb
	{	LPCWAVEFORMATEX pWaveFormat = GetStream()->GetFormat();
		if ( pWaveFormat!=NULL ) {
			m_nAvgBytesPerSec = pWaveFormat->nAvgBytesPerSec;
		} else {
			//	ȂBG[ɂȂ񂩂H
			m_nAvgBytesPerSec = 0;
		}
	}

	m_strFileName = filename;
	m_dwLength = (DWORD)((LONGLONG)GetStream()->GetLength() * m_nAvgBytesPerSec / 1000);

	//	o
	SetCurrentPos(0);

	return 0;
}

LRESULT CWaveStreamSound::Release(){
	if (IsPlay()) Stop();
	//	ĐȂƂ߂ƂI iꉞˁj

	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	//	NullSoundBufferǂ
	SetBuffer(smart_ptr<ISoundBuffer>(new CNullSoundBuffer));
	m_strFileName.erase();

	return 0;
}

LRESULT CWaveStreamSound::Restore(){
	//	M񂾂זȂ[
	DWORD status;
	{	CCriticalLock lock(GetCS());
		status = GetBuffer()->GetStatus();
	}

	if (m_strFileName!="" && status==1) {
		//	[XgĂ(;LD`)
		bool bPlay = IsPlay();
		Stop();
		string temp = m_strFileName; //	Rs[ēnReleaseꂿႤ:p
		Load(temp);
		return (bPlay) ? Play() : 0;
	}

	return 0;
}

LRESULT CWaveStreamSound::Play()
{
	//	ĐȂƂ߂ƂI
	if ( IsPlay() ) Stop();

	m_bPaused = 0;

	//	obt@
	if ( InitBuffer()!=0 ) {
		Stop();
		return 1;
	}

	//	obt@ĐԂɂ
	if ( GetBuffer()->Play(true)!=0 ) {
		Err.Out("CWaveStreamSound::InitBuffer GetBuffer()->Play()ɎsI");
		Stop();
		return 2;
	}

	//	Ƃ̓[JXbhɔC
	if ( CreateThread()!=0 ) {
		Err.Out("CWaveStreamSound::InitBuffer CreateThread()ɎsI");
		Stop();
		return 3;
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////

LRESULT CWaveStreamSound::Stop()
{
	//	M񂾂זȂ[
	{
		CCriticalLock lock(GetCS());
		if ( m_bPaused!=0 ) return 0; //	|[YȂStopĂ
	}

	//	Xbh~߂->Ŝߎ~܂܂ő҂StopThread֐g
	StopThread();

	return InnerStop();
}

LRESULT CWaveStreamSound::InnerStop()
{
	//	XbhĂ΂鎖̂LockKv
	CCriticalLock lock(GetCS());

	//	obt@~߂ď
	LRESULT ret = GetBuffer()->Stop();
	GetBuffer()->SetCurrentPosition(0);
	if (!GetStream().isNull()){
		//	̓t@Cǂݍ݂ɎsĂnullł肤
		GetStream()->SetCurrentPos(0);
	}
	m_dwPlayPosition = 0;
	m_bPaused = 0;

	return ret;
}

LONG CWaveStreamSound::GetCurrentPos() const
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	if (m_nAvgBytesPerSec==0) return -1;	//	Load̏擾ŎsĂ

	LONG pos = LONG(((DWORDLONG) m_dwPlayPosition * 1000 / m_nAvgBytesPerSec) );
	//	DWORDLONGɃLXgȂƈꂿႤ:p
	return pos;
}

LRESULT CWaveStreamSound::SetCurrentPos(LONG lPos){
	if (m_nAvgBytesPerSec==0) return 1;	//	Load̏擾ŎsĂ

	//	ʒuςɂ͎~߂邵Ȃ
	bool bPlay = IsPlay();
	Stop();

	//	Stop֐ɂAXbh͎~܂Ă
	//	CriticalSection͕KvȂ
	GetStream()->SetCurrentPos(lPos);
	m_dwPlayPosition = LONG(((DWORDLONG) lPos * m_nAvgBytesPerSec / 1000 ) );

	return (bPlay) ? Play() : 0;
}

bool CWaveStreamSound::IsPlay() const
//	̃`lĐ(=3)Ȃtrue
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	DWORD ret = GetBuffer()->GetStatus();
	return ret==3;
}

LRESULT CWaveStreamSound::Pause()
//	`lpause
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	int& bPaused = m_bPaused;
	bPaused += (bPaused>0?1:(bPaused<0?-1:0));	//	KEZ:p
	if ( !IsPlay() ) {
		return 0; //	IĂ
	}
	//	Đ̂pauseȂ
	bPaused = 1;

	LRESULT ret = GetBuffer()->Stop();
	return ret;
}

LRESULT CWaveStreamSound::Replay()
//	pauseŎ~߂ĂÃ`l̍ĐĊJB
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	if (!m_bPaused) return 0; //	pauseĂւāI

	if (--m_bPaused==0) {	//	QƃJEg
		LRESULT ret = GetBuffer()->Play(true);
		return ret;
	}
	return 0;
}

LRESULT CWaveStreamSound::SetVolume(LONG volume)
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	//	͈͊ÕG[`FbN[ւ񂩂AɂĂ[
	m_lVolume = volume;
	LRESULT ret = GetBuffer()->SetVolume(m_lVolume);
	return ret;

	//	DSBVOLUME_MAXiȂj :		0
	//	DSBVOLUME_MINij	 : -10000
	//	̊ԂŎw肷̂B
}

LONG CWaveStreamSound::GetVolume() const
//	擾́A`lɑ΂ĂłȂ...
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	return m_lVolume;
}

//	bmd̒
DWORD CWaveStreamSound::GetFrequency() const
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	DWORD dwFreq;
	LRESULT ret = GetBuffer()->GetFrequency(dwFreq);

	if ( ret!=0 ) return 0xffffffff;
	return (LONG)dwFreq;
}

LRESULT CWaveStreamSound::SetFrequency(DWORD freq)
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	if((DSBFREQUENCY_MIN<=freq && freq<=DSBFREQUENCY_MAX) || freq==DSBFREQUENCY_ORIGINAL){
		LRESULT ret = GetBuffer()->SetFrequency(freq);
		if(ret==0) return 0;
	}
	return 1;
}

LRESULT	CWaveStreamSound::SetLoopPlay(bool bLoop)
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	m_bLoop = bLoop;
	return 0;
}
bool CWaveStreamSound::IsLoopPlay() const
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	bool ret = m_bLoop;
	return ret;
}

LONG CWaveStreamSound::GetLength() const
{
	//	M񂾂זȂ[
	CCriticalLock lock(GetCS());

	LONG len =	GetStream()->GetLength();
	return len;
}

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd
