#include "stdafx.h"
#include "../Thread/yaneThread.h"
#include "../AppFrame/yaneAppBase.h"
#include <process.h> 

namespace yaneuraoGameSDK3rd {
namespace Thread {

//////////////////////////////////////////////////////////////////////////////
//	static members..
ThreadLocal<IThread*> IThread::pThread;

//////////////////////////////////////////////////////////////////////////////

CThread::CThread(){
	m_dwThreadHandle	 = (HANDLE)0;
	m_dwRunningThreadID	 = (DWORD)-1;
	//	-1̓G[lB(XbhnhƂĂ͂肦Ȃl)
	//	i_beginthread͗_͂OԂĂ邱Ƃj

	m_bCreatedThread = false;
	m_nStackSize = 0; // default
}

CThread::~CThread(){
	StopThread();
}

//	CxgXe[^X̏
void	CThread::InitEvent(){
	GetExistEvent()->ResetEvent();	//	mVOiԂɂ
	//	XbhĂԂ̂Ƃ̓mVOi

	GetThreadStarting()->ResetEvent();
	//	XbhJnĂȂԂ̂Ƃ̓mVOi

	GetExceptionEvent()->ResetEvent();	//	mVOiԂɂ
	//	OĂȂƂ́AmVOi

	GetThreadExecute()->ResetEvent();	//	mVOiԂɂ
	//	XbhsĂȂƂ́AmVOi

	m_bCreatedThread = false;
	//	CreateThreadŐꂽXbhȂtrue
}

bool CThread::IsThreadValid()const{
	///	荞ݏԂɂȂĂ邩
	CThread* pThis = const_cast<CThread*>(this);
	return !pThis->GetExistEvent()->IsSignal();
}

bool CThread::IsThreadExecute()const /// Xbh͎sH
{
	CThread* pThis = const_cast<CThread*>(this);
	return pThis->GetThreadExecute()->IsSignal();
}

//////////////////////////////////////////////////////////////////////////////

LRESULT CThread::CreateThread(const smart_ptr<function_callback>& fn) {
	CCriticalLock cs(GetCriticalSection());
	m_fn = fn;
	return CreateThread();
}

void CThread::SetThreadFunction(const smart_ptr<function_callback>& fn){
	CCriticalLock cs(GetCriticalSection());
	m_fn = fn;
}

LRESULT CThread::CreateThread() {
	CCriticalLock cs(GetCriticalSection());

	StopThread();
	InitEvent();
	m_bCreatedThread = true;

//	return !::CreateThread(NULL,0,ThreadCallBack,this,NULL,&m_dwThreadHandle);
//	m_dwThreadHandle = ::_beginthread(0,ThreadCallBack,0,(void*)this);
	HANDLE dwThreadHandle =
		(HANDLE)::_beginthreadex(0,GetStackSize(),ThreadCallBack,(void*)this,0
			,(unsigned int*)&m_dwRunningThreadID);
	if (dwThreadHandle ==0 ){
	/*
					ŃRpCG[oƂA
		N郉CuVOXbhɂȂĂ邩łB
		vWFNg̐ݒˁuC/C++vˁuR[hvŁA
		ugp郉^CCuv́A
		}`Xbhp̂̂gpĂB
	*/
		return -1;	//	XbhNɎs
	}
	m_dwThreadHandle = dwThreadHandle;

	/**
		XbhN̂҂H
	*/
	return GetThreadStarting()->Wait();
		//	_beginthreadex́AG[A-1ԂĂ
	/*
		CreateThreadł͂Ȃ_beginthreadŃXbh𐶐ȂƁA
		C̃^CĂяoĂꍇAK͂ȃ[NB
		(80oCgx)
		ƁARpCƂ́A}`Xbhp̃Cu
		N悤ɂĂB

	܂A

   Thread.ct@C`Ă݂ƁA
1. _beginthread  CreateThread A ResumeThread
   R[B
2. ƁA_threadstart R[B
3. _threadstartŃR[obN֐R[B
4. LR[obN֐IA 
		_endthread R[
@@B

@ʁAXbhnhɂȂB
@āAWaitForSingleObjectɃXbh
R[obN֐IꍇAȃXbhnh
ɑ΂ҋ@悤ɂȂB

	āA_beginthreadexő҂ׂ

	*/
}

LRESULT CThread::StopThread() {
	CCriticalLock cs(GetCriticalSection());

	InvalidateThread();			//	~܂ė~˂I

	if (m_dwThreadHandle==(HANDLE)0) {
		return 0;
		//	XbhƂ瓮ĂւŁH
	}

	//	XbhAgAȂƂŎ̃Xbh̏I҂Ƃ
	//	fbhbNɂȂ邾
	if (GetThreadId() == ::GetCurrentThreadId()) return 2;

	//	IɁÃXbh폜R[h͊댯Ȃ̂œȂ

	DWORD dwResult = 0;	
	HANDLE dwThreadHandle = m_dwThreadHandle;
	m_dwThreadHandle = (HANDLE)0;
	m_dwRunningThreadID = (DWORD)-1;
	//	ŃnhRs[āANAĂȂƁALeaver[
	//	炽ȃXbhCreateāAnh㏑Ă܂
	//	\

	if (m_bCreatedThread){
		cs.Leave();
			//@lock܂ܑ҂ĂA[J[XbhLocklł
			//	dead lockɐ蓾
		dwResult = ::WaitForSingleObject(dwThreadHandle,INFINITE);
		cs.Enter();
	}
	//	҂͈̂ꌩASȃR[hAfbhbNɂȂ肤
	//	(RԂƂ̂HH_beginthread B_beginthreadexȂok)
	//	@_beginthread̂ق́AIɃXbhnh悤

	if (dwResult != WAIT_OBJECT_0) {
		//	ƁÃXbhnh̏Lł
		//	jĂ̂Ǝv..͋CɂȂŗǂ
		return 1;
	}
	::CloseHandle(dwThreadHandle);
	// ̃nhIɕă\[XƂ

	//	ÎŁDD
	return 0;
}

LRESULT CThread::JumpToThread() {
	StopThread();
	InitEvent();

	m_bCreatedThread = false;

	m_dwRunningThreadID = ::GetCurrentThreadId();
	//	XbhID̕ۑ
	//	(͂AXbhnhƓ̂ł͕̂ۏ؂Ă̂DD)

	{
		//	ꉞXbh}l[Wɓo^Ă
		CThreadManager::GetObj()->AddThread(this);
		GetThreadExecute()->SetEvent();

		ThreadProc();				//	ŝ

		GetThreadExecute()->ResetEvent();
		//	Xbh}l[W폜
		CThreadManager::GetObj()->DelThread(this);

	}

	m_dwRunningThreadID = (DWORD)-1;	//	XbhIۂ
	return 0;
}

//void CThread::ThreadCallBack(LPVOID lpVoid){
unsigned __stdcall CThread::ThreadCallBack( void * lpVoid){
	//	_beginthreadexp̂ŕύX܂
	
	CThread* pThread = reinterpret_cast<CThread*>(lpVoid);

	pThread->m_dwRunningThreadID = ::GetCurrentThreadId();
	//	XbhID̕ۑ

	//	Xbh}l[Wɓo^Ă
	CThreadManager::GetObj()->AddThread(pThread);

	//	̃tO͓ǂݎpȂ̂łŏėǂ
	const smart_ptr<function_callback> fn(pThread->GetCallBack());
	pThread->GetThreadExecute()->SetEvent();
		//	̃tOƁÃXbh𐶐Xbh
		//	CreateThread甲āÂSetFunctionCallBackׂ
		//	֐Ă܂AŏՓ˂邱Ƃ
	pThread->GetThreadStarting()->SetEvent();

	IThread::setThread(pThread);	//	Xbhݒ肵Ă

	if (fn.isNull()){
		pThread->ThreadProc();
	} else {
		fn->run();	//	R[obN
		pThread->m_fn.Delete();			//	function_callback̂
	}

	IThread::unsetThread();		//	ݒ肵ĂXbh*폜

	/**
		ThreadÔ߂InvalidateāA
		̃Xbhɑ΂waitĂXbhɒʒmĂ
	*/
	pThread->InvalidateThread();

	//	Xbh}l[W폜
	CThreadManager::GetObj()->DelThread(pThread);
		//	DeleteThreadɂStopThread

	return 0;
}

void	CThread::InvalidateThread(){
	CCriticalLock cs(GetCriticalSection());
	{
		CCriticalLock cl(GetLockObject()->GetCriticalSection());

		//	҂XgɓĂzAĂ
		GetLockObject()->notifyThreadInWaitList(GetThreadId());

		//	IuWFNgVOiԂɂĂ
		GetExistEvent()->SetEvent();		//	݂Ȃ
//		GetThreadExecute()->ResetEvent();	//	sĂȂ
	}
}

//////////////////////////////////////////////////////////////////////////////
//	Java݊Thread@\AyȂDD

LRESULT	CThread::wait(int nTimeOut /*=-1*/)
		#ifdef USE_EXCEPTION
			throw(CInterruptedException)
		#endif
{
	///		wait L[ɕ
	if (interrupted()){
		#ifdef USE_EXCEPTION
			throw CInterruptedException();
		#endif
	}
	LRESULT lr = GetLockObject()->wait(nTimeOut);
	/*	//	͐SzłCLockObject
	if (interrupted()){
		#ifdef USE_EXCEPTION
			throw CInterruptedException();
		#endif
	}
	*/
	return lr;
}

LRESULT CThread::sleep(int nTime)
		#ifdef USE_EXCEPTION
			throw(CInterruptedException)
		#endif
{
	//	nTime [ms]҂B҂ĂŒɁAIuWFNgVOi
	//	iXbhIȂAƂԁjɂȂ΁A0ԂB

	if (interrupted()){
		#ifdef USE_EXCEPTION
			throw CInterruptedException();
		#endif
	}

	const HANDLE h[] = {
		//	OCxgƐCxgƂ̗ĎKv
		GetExistEvent()->GetHandle(),
		GetExceptionEvent()->GetHandle()
	};

	DWORD dwResult =
		::WaitForMultipleObjects(
			2,&h[0],FALSE,nTime
		);

	if (interrupted()){
		#ifdef USE_EXCEPTION
			throw CInterruptedException();
		#endif
	}
	return dwResult == WAIT_TIMEOUT ? 0:1;
}

void	CThread::notify(){
	/// waitő҂ĂXbh@N(1̂)
	GetLockObject()->notify();
}

void	CThread::notifyAll(){
	/// waitő҂Ă邷ׂẴXbh@N
	GetLockObject()->notifyAll();
}

void	CThread::interrupt(){
	/**
		荞݂B̊֐́AXbhĂяoB
		ƁÃXbh́Awaitsleep
			CInterruptedExceptionO𔭐B
	*/
	CCriticalLock cl(GetLockObject()->GetCriticalSection());
	GetLockObject()->eraseThreadInWaitList(GetThreadId());
		//	҂ĂȂ΁Ȃ҂폜
	GetExceptionEvent()->SetEvent();
	//	sleepĂ\̂ŁALɂĂ

}

bool	CThread::isInterrupted() const{
	///	荞ݏԂɂȂĂ邩
	CThread* pThis = const_cast<CThread*>(this);
	return pThis->GetExceptionEvent()->IsSignal();
}

bool	CThread::interrupted() {
	///	荞ݏԂɂȂĂ邩ԂǍA
	///	荞ݏԂ̓ZbgB
	CCriticalLock cl(GetLockObject()->GetCriticalSection());
		//	ꉞLockĂB

	bool bInterrupted = GetExceptionEvent()->IsSignal();
	GetExceptionEvent()->ResetEvent();
	return bInterrupted;
}

//////////////////////////////////////////////////////////////////////////////
//	ThreadManager
//////////////////////////////////////////////////////////////////////////////
singleton<CThreadManager> CThreadManager::m_obj;

void	CThreadManager::AddThread(IThread* pThread){
	CCriticalLock cl(GetLockObject()->GetCriticalSection());
	//	do^܂ŐSzłł
	GetThreadList()->push_back(pThread);
	GetLockObject()->notifyAll();
}

void	CThreadManager::DelThread(IThread* pThread){
	CCriticalLock cl(GetLockObject()->GetCriticalSection());

	{
		threadlist::iterator it =
			find(GetThreadList()->begin(),GetThreadList()->end(),pThread);
		if (it!=GetThreadList()->end()){
		//	͂₯ǂȂDD
			GetThreadList()->erase(it);
		}
	}

	//	̂ƁALĂXbhIȂ΁A
	//	eraseĂ
	{
		smart_list_ptr<CThreadList>::iterator it =
			GetMyThreadList()->begin();
		while (it!=GetMyThreadList()->end()){
			if ((*it)->pThread.get() == pThread){
			//	Ă̂ł΁DD
//				it = GetMyThreadList()->erase(it);
				//	̃Xbh폜邱Ƃ͏oȂ
				(*it)->bValid = false; // delete}[N
				it++;
			} else {
				it++;
			}
		}
	}

	GetLockObject()->notifyAll();
}

bool	CThreadManager::StopAllThread() {
	if (isStopAllThread()) return false;
	/*
		SXbh̒~łɏoĂ̂Ȃ΁A
		̃Xbh~悤ƂĂA
		̒~oĂXbh~邱Ƃ
		oȂ̂ŁAfbhbNɊׂB
		āAł́Abalkׂ
	*/

	CCriticalLock cl(GetLockObject()->GetCriticalSection());

	GarbageThread();	//	K[xWʁAׂďIĂ邩mȂ

			//	g̃Xbhɓ͂Ȃ̂ŁA1ȉƂ
	while (!(
				(
					(GetThreadList()->empty())
				||
					(
						(GetThreadList()->size()==1)
					&&
						((*GetThreadList()->begin())->GetThreadId()
							==GetCurrentThreadId())
					)
				)
			&&
			//	ǗĂXbhAPƂĂAꂪ̃Xbhgł邩
				(
					(GetMyThreadList()->empty())
				||
					(
						(GetMyThreadList()->size()==1)
					&&
						((*GetMyThreadList()->begin())->pThread->GetThreadId()
							==GetCurrentThreadId())
					)
				)
			)){

				/** /	//	debugpeXgR[h
				int n1 = GetThreadList()->size();
				int n2 = GetMyThreadList()->size();
				DWORD n3 = (*GetThreadList()->begin())->GetThreadId();
				DWORD n4 = (*GetMyThreadList()->begin())->pThread->GetThreadId();
				DWORD n5 = GetCurrentThreadId();
				//*/

	///	GetMyThreadList́AꂩsׂXbh܂܂
	///	vɁAGetThreadListŎ擾XbhemptyłƂĂ
	///	GetMyThreadListemptyłȂ΁AI𖞂ĂȂƂɂȂ
	//	SXbhɒ~߂
		threadlist::iterator it = GetThreadList()->begin();
		while (it!=GetThreadList()->end()){
//			(*it)->StopThread();
			/**
				̃Xbh̃Xbh~悤ɂA
				̃XbhIƂɁAL̃XbhXg
				菜Ƃ邪ÂߏL`FC
				critical lock邱ƂɂȂāAŃfbhbNɊׂB
			*/
			(*it)->InvalidateThread();	//	H
			it++;
		}
		//	񂱂sȂȂƁA
		//	VȃXbh쐬\
		GetLockObject()->wait();
		GarbageThread();
	}
	return true;
}

//	ׂẴXbhÎ҂
void	CThreadManager::WaitAllThreadEnded() {
	CCriticalLock cl(GetLockObject()->GetCriticalSection());

	GarbageThread();	//	K[xWʁAׂďIĂ邩mȂ
	while (!(GetThreadList()->empty() && GetMyThreadList()->empty())){
	///	GetMyThreadList́AꂩsׂXbh܂܂
	///	vɁAGetThreadListŎ擾XbhemptyłƂĂ
	///	GetMyThreadListemptyłȂ΁AI𖞂ĂȂƂɂȂ
		GetLockObject()->wait();
		//	waitĂяobusy waitɂ͂ȂȂ
		GarbageThread();
	}
}

void	CThreadManager::_RegistThread(
	const shared_ptr_ytl<IThread>& pThread,
	const shared_obj&	obj/*=NULL*/
){
	CCriticalLock cl(GetLockObject()->GetCriticalSection());
	CThreadList* p = new CThreadList;
	p->pThread	= pThread;
	p->obj = obj;
	GetMyThreadList()->push_back(smart_ptr<CThreadList>(p));
}

void	CThreadManager::GarbageThread(){
	//	lock͂ȂAOlockƂĂ
	//	̂ƁALĂXbhIȂ΁A
	//	eraseĂ
	{
		smart_list_ptr<CThreadList>::iterator it =
			GetMyThreadList()->begin();
		while (it!=GetMyThreadList()->end()){
			if (!(*it)->bValid){
			//	delete}[NĂȂ
				it = GetMyThreadList()->erase(it);
			} else {
				it++;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////

///	RunThread̏ꍇ́ACAppFrameRunĂяoƂۏ؂
LRESULT CThreadManager::RunThread(IAppBase*pAppBase){
	return RunThread(shared_ptr_ytl<IAppBase>(pAppBase));
}

LRESULT CThreadManager::RunThread(const shared_ptr_ytl<IAppBase>& pAppBase){
	shared_ptr_ytl<IAppBase>* p = new shared_ptr_ytl<IAppBase>(pAppBase);

	shared_ptr_ytl<IThread> pThread(pAppBase->GetWorkerThread(),false);
		//	̃Xbh̒~ÃIuWFNg̉̃tFCYƂ

	GetObj()->_RegistThread(pThread,shared_obj(p));
	//	smart_ptr_baseɃLXg

	return pAppBase->Run();	//	̂Ǝs
}

///	CreateThread̏ꍇ́AIThreadCreateThreadĂяoƂۏ؂
LRESULT CThreadManager::CreateThread(IThread*pThread){
	return CreateThread(shared_ptr_ytl<IThread>(pThread));
}

LRESULT CThreadManager::CreateThread(const shared_ptr_ytl<IThread>& pThread){
	RegistThread(pThread);
	return pThread->CreateThread();	//	Xbh̍쐬
}

} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd
