//	yaneThread.h :
//		programmed by yaneurao	'00/02/26
//		IuWFNg̓ '01/11/19

#ifndef __yaneThread_h__
#define __yaneThread_h__


#include "../Thread/yaneEvent.h"
#include "../Thread/yaneLockObject.h"

namespace yaneuraoGameSDK3rd {
namespace Thread {

class IThread {
public:
	virtual LRESULT CreateThread()=0;
	virtual LRESULT CreateThread(const smart_ptr<function_callback>& fn)=0;
	virtual void SetThreadFunction(const smart_ptr<function_callback>& fn)=0;
	virtual LRESULT StopThread()=0;
	virtual LRESULT JumpToThread()=0;
	virtual bool IsThreadExecute()const=0;
	virtual bool IsThreadValid()const=0;
	virtual void InvalidateThread()=0;
	virtual DWORD	GetThreadId() const=0;

	//	java݊Xbh@\
	virtual LRESULT	wait(int nTimeOut=-1)
		#ifdef USE_EXCEPTION
			throw(CInterruptedException)
		#endif
			=0;
	virtual	LRESULT sleep(int nTime)
		#ifdef USE_EXCEPTION
			throw(CInterruptedException)
		#endif
			=0;
	virtual void	notify()=0;
	virtual void	notifyAll()=0;
	virtual void	interrupt()=0;
	virtual bool	isInterrupted() const=0;
	virtual bool	interrupted()=0;

	virtual ~IThread(){}

	virtual CEvent* GetExceptionEvent()=0;
	//	OsignalԂɂȂCxg

	//	̃XbhɑΉXbhNX𓾂
	//	(NULLł邱Ƃ肤)
	static IThread* getThread() { return pThread; }
	static void setThread(IThread*p) { pThread = p; }
		//	CThreadCreateThreadƂɏɂ
	static void unsetThread() { pThread.Clear(); }

protected:
	static ThreadLocal<IThread*> pThread;
};

}}

//	namespaceɂ̂O錾
namespace yaneuraoGameSDK3rd { namespace AppFrame { class IAppBase; }}

namespace yaneuraoGameSDK3rd {
namespace Thread {

class CThread : public IThread {
/**
	Xbh𐶐iǗj܂B

	XbhɊւẮA
	class CThreadManager ̂قQƂĂB

	//	XbhNXhꍇ́A
	//	KhNXStopThreadsȂKv̂Œ
	(˖{QQƂ̂)
*/
public:
	virtual void ThreadProc() {}
	/**
		[J[Xbh̏Lq邽߂ɁA
		̊֐I[o[Ch܂B
		ĩNXhĎgƂj
	*/

	virtual LRESULT CreateThread();
	virtual LRESULT CreateThread(const smart_ptr<function_callback>& fn);
	virtual void SetThreadFunction(const smart_ptr<function_callback>& fn);
	/**
		CreateThread́AXbh쐬AThreadProcs͂߂܂B
		CreateThread̈ƂāAR[obN֐w肵Ȃꍇ́A
		ThreadProcĂяôThreadProcI[o[ChĂA
		SetThreadFunctionŁAXbh֐ƂăR[obN֐
		ݒ肵ĂƁB
	*/

	virtual LRESULT StopThread();
	/**
		Xbh̃XgbvB~܂ő҂܂
		ԂlF
			OFI
			PFłɃXbh݂ĂȂiIj
	*/

	virtual LRESULT JumpToThread();	///	Xbh炸ɃWv

	virtual bool IsThreadExecute()const; /// Xbh͎sH

	virtual bool IsThreadValid()const;
	/**
		XbhStop͂ĂȂ
		̊֐falseɂȂƂɁAThreadProcEo悤
		R[fBO܂B
	*/

	virtual void InvalidateThread();
	/**
		Xbhɒ~M𑗂
		i̒~҂킯ł͂Ȃj
		[J[Xbh͎IsThreadValid`FbNƂ
		falseԂĂ܂̂ŁÂƂThreadProc甲oł傤B
		邢ThreadSleepƂɔOԂ̂ŁAŃXbh
		R[hĂǂłB
	*/

	/// ----- JavãXbh@\
	/**
		ꂼ̐ɂďڂ class CLockObject ̓̊֐
		JavaThread̓̊֐QƂ̂ƁB
	*/

	virtual LRESULT	wait(int nTimeOut=-1)
		#ifdef USE_EXCEPTION
			throw(CInterruptedException)
		#endif
			;
	///		wait L[ɕ

	virtual void	notify();
	/// waitő҂ĂXbh@N(1̂)

	virtual void	notifyAll();
	/// waitő҂Ă邷ׂẴXbh@N

	virtual void	interrupt();
	/**
		荞݂B̊֐́AXbhĂяoB
		ƁÃXbh́Awaitsleep
			CInterruptedExceptionO𔭐B
	*/

	virtual bool	isInterrupted() const;
	///	荞ݏԂɂȂĂ邩

	virtual bool	interrupted();
	///	荞ݏԂɂȂĂ邩ԂǍA
	///	荞ݏԂ̓ZbgB

	virtual	LRESULT sleep(int nTime)
		#ifdef USE_EXCEPTION
			throw(CInterruptedException)
		#endif
			;
	/**
		nTime [ms]҂B
	ԂlF
		0FI@
		1 : ҂ĂŒɁAʃXbhStopThreadĂяo
		IuWFNgVOiԁiXbhIȂA
		ƂԁjɂȂAɊ֐𔲂B̏ꍇA0ԂB
		XbhÃXbhinterrupt\bhĂяoꂽ
		ꍇAsleepł̑ҋ@𑦍ɏIACInterruptedExceptionO
		B

	ʗA[J[Xbh́A
@@while ( IsThreadValid( ) ) {
@@@	 ;
@@@	Sleep( 20 );
@@} 
	Ƃ悤ȃR[fBOɂāȀsȂ܂A
	̂ƂSleep(20)邽߁AXbhInvalidateāiI̍}j
	A̕X|Xቺ܂BŁASleepł͂ȂA
	if (thread.sleep( 20 )) break; ȂǂƂ΁Ã̕X|X
	コ邱Ƃo܂Bthread.sleep̎́AIuWFNg҂
	(::WaitForSingleObject)悤ɂȂĂ̂ŁA̕ɂCPUp[A
	܂gpAISleep邱Ƃo܂B
	*/

	/// ----- property

	virtual DWORD	GetThreadId() const { return m_dwRunningThreadID; }
	/**
		NĂXbh́AGetCurrentThreadIdŕԂlԂB
		XbhNĂȂꍇ́A-1Ԃ
	*/
	virtual HANDLE	GetThreadHandle() const { return m_dwThreadHandle; }
	/**
		NĂXbh̃nhԂ
	*/

	//	Xbh̃X^bNTCY̎w
	void	SetStackSize(size_t size) { m_nStackSize = size; }
	size_t	GetStackSize() const { return m_nStackSize; }

	CThread();
	virtual ~CThread();

protected:
	volatile HANDLE	m_dwThreadHandle;		//	Xbhnh
	volatile DWORD	m_dwRunningThreadID;	//	XbhID(LƓƎvOSˑ̉\̂ňꉞʈɂ)

//	static void ThreadCallBack(LPVOID lpVoid);
	static unsigned __stdcall ThreadCallBack( void * lpVoid);

	void	InitEvent();
	//	ȉ̂Q̃Xbh̃Xe[^X

	CEvent	m_vExistEvent;
	//	́AXbhĂԂ́AmVOi
	//	VOiԂɂȂƂ́AXbhIȂƂ}
	CEvent* GetExistEvent() { return &m_vExistEvent; }
	//	˃VOiԂɂȂ΁AIsThreadValidfalseԂ

	CEvent m_vThreadExecute;
	///	XbhAXbhR[obN֐JnH
	CEvent* GetThreadExecute() { return &m_vThreadExecute; }
	//	sȂ΃VOiԂɂȂ

	//	sleepƂȂǂɑ҂ׂOCxg
	CEvent	m_vExceptionEvent;
	virtual CEvent* GetExceptionEvent() { return &m_vExceptionEvent; }

	//	threadstart܂ł̏
	CEvent	m_vThreadStarting;
	CEvent*	GetThreadStarting() { return &m_vThreadStarting; }
	//	Jn܂ł̑҂ԁmVOi

	//	CreateStopr邽߂̃NeBJZNV
	CCriticalSection m_vCriticalSection;
	CCriticalSection* GetCriticalSection() { return& m_vCriticalSection;}

	smart_ptr<function_callback> m_fn;
	smart_ptr<function_callback> GetCallBack() const { return m_fn; }

	CLockObject	m_vLockObject;
	/*volatile*/ CLockObject* GetLockObject() { return &m_vLockObject;}
	//	Xbĥ߂Lock Object

	bool	m_bCreatedThread;
	/*
		CreateThreadŐꂽXbhȂ̂tO
		JumpThreadŐꂽXbh́AIWaitForSingleObjectĂ
		Ȃ̂ŁAtO𗧂ĂĂ
	*/

	size_t	m_nStackSize;
};

class IThreadManager {
public:
	///	Xbh̒ǉƍ폜
	virtual void	AddThread(IThread* pThread)=0;
	virtual void	DelThread(IThread* pThread)=0;
	virtual bool	StopAllThread()=0;
	virtual void	WaitAllThreadEnded()=0;
	virtual ~IThreadManager(){}
};

class CThreadManager : public IThreadManager {
/**
	Thread𓝊ThreadManager
	͎class CThread IɌĂяo

	[U[gƂArun\bh炢
	́A
		CThreadManager::RunThread(new CThreadXXX);
	Ƃ悤ɎgBƂ́AL͂̃XbhNX
	ʓ|ĂB
	
*/
public:
	static	CThreadManager* GetObj() { return m_obj.get(); }
	///	ŁAsingletonȓz𓾂

	///	Xbh̒ǉƍ폜
	virtual void	AddThread(IThread* pThread);
	virtual void	DelThread(IThread* pThread);

	///	ׂẴXbhIiI҂j
	virtual bool	StopAllThread();
	/*
		łɑXbhStopAllThreadĂяoAI
		΁AbalkāÂƂfasleԂ
	*/

	///	ׂẴXbhÎ҂iI킯ł͂Ȃj
	virtual void	WaitAllThreadEnded();

	/**
		XbhێBĹÃNXʓ|
		Xbh𑖂点OɁAɏLĂ΁A
		̃XbhIƂɃCX^XIɍ폜
	*/
	static void	RegistThread(IThread* pThread)
		{ GetObj()->RegistThread(shared_ptr_ytl<IThread>(pThread)); }
//	static void RegistThread(const smart_ptr<IThread>& pThread)
//		{ GetObj()->_RegistThread(pThread); }
	static void RegistThread(const shared_ptr_ytl<IThread>& pThread)
		{ GetObj()->_RegistThread(pThread); }

	/**
		RegistThreadƓL܂ł̃NXʓ|邪A
		IAppBaseRunĂяoƂۏ؂
	*/
	static LRESULT RunThread(IAppBase*pAppBase);
//	static LRESULT RunThread(const smart_ptr<IAppBase>& pAppBase);
	static LRESULT RunThread(const shared_ptr_ytl<IAppBase>& pAppBase);

	/**	
		RegistThreadƓL܂ł̃NXʓ|邪A
		IThreadCreateThreadĂяoƂۏ؂
	*/
	static LRESULT CreateThread(IThread*pThread);
//	static LRESULT CreateThread(const smart_ptr<IThread>& pThread);
	static LRESULT CreateThread(const shared_ptr_ytl<IThread>& pThread);

protected:
	//	WvɂāɃWv
	virtual void _RegistThread(
		const shared_ptr_ytl<IThread>& pThread,
			//	̃Xbh~ƂɁA
		const shared_obj& obj=shared_obj()
			//	̃IuWFNg폜
		//	nƂ́AQƃJEgȂ悤
		//	smart_ptr::inc_refĂÃ|C^nĂKv
	);
public:

	CThreadManager():m_bStopAllThread(false) {}

	typedef vector<IThread*> threadlist; 
protected:

	/**
		ǗĂXbhꗗ
	*/

	threadlist m_apThreadList;
	threadlist* GetThreadList() { return& m_apThreadList; }
		//	{volatileȂ̂AVC++́A
		//	oϐւ̃ANZX̓WX^tȂ

	/**
		͏LĂXbhꗗ
	*/
	struct CThreadList {
		shared_ptr_ytl<IThread> pThread;	//	̃Xbh~ƂɁA
		shared_obj obj;		//	̃IuWFNg폜
		bool	bValid;					//	́Q̃f[^oK
			//	ʃXbh폜ȂƁAŎ̃Xbh폜邱Ƃ͏oȂ̂ŁDD
		CThreadList():bValid(true){}
	};
	smart_list_ptr<CThreadList> m_apMyThreadList;
	smart_list_ptr<CThreadList>* GetMyThreadList()
		{ return& m_apMyThreadList; }
	void	GarbageThread();
	//	delete}[N(CThreadList::bValid==false)̂Ă
	//	Xbh폜(ThreadListɑ΂CriticalLocḱA
	//	|ԂŌĂяo)

	CLockObject m_lockobject;
	CLockObject* GetLockObject() { return &m_lockobject; }

	/////////////////////////////////////////////////////////////
	///	SXbh̒~̂߂̐@\
	volatile bool	m_bStopAllThread;
	CCriticalSection m_csStopAllThread;
	CCriticalSection* GetStopAllThreadLock() { return &m_csStopAllThread;}
	/**
		SXbh̒~oĂ邩ǂ̃tO
		ɑ΂NeBJZNV
		(latch)
	*/
	bool	isStopAllThread() {
	///	̃\bh́AxĂяoƁAȍ~trueԂ
		CCriticalLock cl(GetStopAllThreadLock());
		bool b = m_bStopAllThread;
		m_bStopAllThread = true;
		return b;
	}

	/////////////////////////////////////////////////////////////

	///	singletonp^[
	static	singleton<CThreadManager> m_obj;
};

} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd

#endif
