//
// yaneThreadPooler.h :
//
//	CThreadPool,CThreadManageratlŒ`Ă(;LD`)
//	

#ifndef __yaneThreadPooler_h__
#define __yaneThreadPooler_h__


#include "../Thread/yaneThread.h"

namespace yaneuraoGameSDK3rd {
namespace Thread {

class CThreadPoolerRequestQueue {
/**
	CThreadPoolerpR[obN̂߂queue
	PƂłgp邱Ƃ͏o
*/
public:
	///	܊֐sĂXbh̐
	int	getInvokeCount() const { return m_nInvokeCount; }
	void setInvokeCount(int nInvokeCount){
		synchronized g(getLock());
		m_nInvokeCount = nInvokeCount;
		getLock()->notifyAll();	//	҂Ă邩m
	}
	void incInvokeCount() {
		synchronized g(getLock());
		m_nInvokeCount++;
		getLock()->notifyAll();	//	҂Ă邩m
	}
	void decInvokeCount() {
		synchronized g(getLock());
		m_nInvokeCount--;
		getLock()->notifyAll();	//	҂Ă邩m
	}

	///	v[ĂSXbh̐̐ݒ/擾
	int getThreadCount() const { return m_nThreadCount; }
	void setThreadCount(int nThreadNum) {
		synchronized g(getLock());
		m_nThreadCount = nThreadNum;
		getLock()->notifyAll();	//	҂Ă邩m
	}
	void decThreadCount() {
		synchronized g(getLock());
		m_nThreadCount--;
		getLock()->notifyAll();	//	҂Ă邩m
	}
	void incThreadCount() {
		synchronized g(getLock());
		m_nThreadCount++;
		getLock()->notifyAll();
	}

	///	requestget/set
	smart_ptr<function_callback> getRequest() {
		synchronized g(getLock());
		smart_ptr<function_callback> fn;
		if (m_bInvalidate) return fn; // _

		while (m_aInvokeList.size()==0){
			getLock()->wait();
			if (m_bInvalidate) return fn; // _
		}
		fn = *m_aInvokeList.begin();
		m_aInvokeList.pop_front();
		return fn;
	}
	void setRequest(const smart_ptr<function_callback>& req){
		synchronized g(getLock());
		m_aInvokeList.push_back(req);
		getLock()->notifyAll();
	}

	///	getRequestőҋ@ĂXbhɑ΂invalidateʒm
	void invalidateAllThread(){
		synchronized g(getLock());
		//	WorkerThread̂ȂwaitĂSXbhɒʒm
		m_bInvalidate = true;
		getLock()->notifyAll();
	}
	void setValid(bool bValid) {
		m_bInvalidate = !bValid;
	}

	bool isDone(){
		synchronized g(getLock());
	//	I󒍂ĂdȂāAAsĂd
		return	getInvokeCount()==0 && getInvokeList()->size()==0;
	}

	LRESULT waitAllThreadEnded(int nTimeOut){
		synchronized g(getLock());
		while (!isDone()){
			LRESULT lr = getLock()->wait(nTimeOut);
			if (lr!=0) return lr;
		}
		return 0;
	}

	///	󒍂Ăd̃Xg
	smart_list_ptr<function_callback>* getInvokeList()
		{ return &m_aInvokeList;}

	///	Ƃ́AIuWFNglockKv
	CLockObject* getLock() { return& m_vLockObject; }

	CThreadPoolerRequestQueue()
		:m_nInvokeCount(0),m_nThreadCount(0),m_bInvalidate(false){}

private:
	CLockObject m_vLockObject;	//	̎d̃JEĝ߂LockObject	
	smart_list_ptr<function_callback> m_aInvokeList;
	int m_nInvokeCount;
	int m_nThreadCount;
	bool m_bInvalidate;
};

class CThreadPoolerThread : public CThread {
/**
	CThreadPoolerŎgpҋ@Xbh
*/
public:
	CThreadPoolerThread(const shared_ptr_ytl<CThreadPoolerRequestQueue>& queue_)
		: queue(queue_){
		queue->incThreadCount();	//	s̃XbhJEgZ
	//	s̃XbhJEǵARXgN^incāA
	//	ThreadProc𔲂Ƃdec
	}

	virtual void ThreadProc();
	~CThreadPoolerThread(){ StopThread(); }
	//	XbhNXhꍇ́A
	//	KhNXStopThreadsȂKv

private:
	shared_ptr_ytl<CThreadPoolerRequestQueue> queue;
};

class CThreadPooler {
public:
	///	Xbhw肵Nđҋ@
	LRESULT	StartThread(int nThreadNum);

	///	NĂXbhɎw肵֐s
	void	Invoke(const smart_ptr<function_callback>&fn);

	///	ێĂXbhׂĒ~
	void	ClearAllThread();

	///	InvokêɏĂȂd̐0ɂȂtrue
	bool	IsDone() const;

	///	ĂȂd̐0ɂȂ̂҂
	///	0:ok  1:timeout
	LRESULT	wait(int nTimeOut=-1);

	CThreadPooler::CThreadPooler(){ m_pQueue.Add();}
	virtual ~CThreadPooler(){ ClearAllThread(); }

private:
	smart_vector_ptr<CThreadPoolerThread> m_aThread;
	shared_ptr_ytl<CThreadPoolerRequestQueue> m_pQueue;
};

} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd

#endif
